;'use strict';(function(exports){var datastore;var DATASTORE_NAME='bookmarks_store';var readyState;var listeners=Object.create(null);function init(){return new Promise(function doInit(resolve,reject){if(readyState==='initialized'){resolve();return;}
if(readyState==='initializing'){document.addEventListener('ds-initialized',function oninitalized(){document.removeEventListener('ds-initialized',oninitalized);resolve();});return;}
readyState='initializing';if(!navigator.getDataStores){console.error('Bookmark store: DataStore API is not working');reject({name:'NO_DATASTORE'});readyState='failed';return;}
navigator.getDataStores(DATASTORE_NAME).then(function(ds){if(ds.length<1){console.error('Bookmark store: Cannot get access to the Store');reject({name:'NO_ACCESS_TO_DATASTORE'});readyState='failed';return;}
datastore=ds[0];datastore.addEventListener('change',onchangeHandler);readyState='initialized';document.dispatchEvent(new CustomEvent('ds-initialized'));resolve();},reject);});}
function doGetAll(resolve,reject){var result=Object.create(null);var cursor=datastore.sync();function cursorResolve(task){switch(task.operation){case'update':case'add':result[task.data.id]=task.data;break;case'remove':delete result[task.data.id];break;case'clear':result=Object.create(null);break;case'done':resolve(result);return;}
cursor.next().then(cursorResolve,reject);}
cursor.next().then(cursorResolve,reject);}
function get(id){return new Promise(function doGet(resolve,reject){init().then(function onInitialized(){datastore.get(id).then(resolve,reject);},reject);});}
function getAll(){return new Promise(function doGet(resolve,reject){init().then(doGetAll.bind(null,resolve,reject),reject);});}
function onchangeHandler(event){var operation=event.operation;var callbacks=listeners[operation];callbacks&&callbacks.forEach(function iterCallback(callback){datastore.get(event.id).then(function got(result){callback.method.call(callback.context||this,{type:operation,target:result||event});});});}
function addEventListener(type,callback){var context;if(!(type in listeners)){listeners[type]=[];}
var cb=callback;if(typeof cb==='object'){context=cb;cb=cb.handleEvent;}
if(cb){listeners[type].push({method:cb,context:context});init();}}
function removeEventListener(type,callback){if(!(type in listeners)){return false;}
var callbacks=listeners[type];var length=callbacks.length;for(var i=0;i<length;i++){var thisCallback=callback;if(typeof thisCallback==='object'){thisCallback=callback.handleEvent;}
if(callbacks[i]&&callbacks[i].method===thisCallback){callbacks.splice(i,1);return true;}}
return false;}
function add(data){return new Promise(function doAdd(resolve,reject){init().then(function onInitialized(){var id=data.url;Object.defineProperty(data,'id',{enumerable:true,configurable:false,writable:false,value:id});datastore.add(data,id).then(function add_success(){resolve(true);},function add_error(){datastore.put(data,id).then(function put_success(){resolve();},reject);});},reject);});}
function getRevisionId(){return new Promise(function doGet(resolve,reject){init().then(function onInitialized(){resolve(datastore.revisionId);},reject);});}
function put(data){return new Promise(function doAdd(resolve,reject){init().then(function onInitialized(){datastore.put(data,data.id).then(function success(){resolve();},reject);},reject);});}
function remove(id){return new Promise(function doRemove(resolve,reject){init().then(function onInitialized(){datastore.remove(id).then(resolve,reject);},reject);});}
exports.BookmarksDatabase={get:get,getAll:getAll,getRevisionId:getRevisionId,addEventListener:addEventListener,removeEventListener:removeEventListener,add:add,put:put,remove:remove};}(window));;'use strict';(function(exports){var datastore;var DATASTORE_NAME='collections_store';var readyState;var listeners=Object.create(null);function init(){return new Promise(function doInit(resolve,reject){if(readyState==='initialized'){resolve();return;}
if(readyState==='initializing'){document.addEventListener('collections-ds-initialized',function oninitalized(){document.removeEventListener('collections-ds-initialized',oninitalized);resolve();});return;}
readyState='initializing';if(!navigator.getDataStores){console.error('Collection store: DataStore API is not working');reject({name:'NO_DATASTORE'});readyState='failed';return;}
navigator.getDataStores(DATASTORE_NAME).then(function(ds){if(ds.length<1){console.error('Collection store: Cannot get access to the Store');reject({name:'NO_ACCESS_TO_DATASTORE'});readyState='failed';return;}
datastore=ds[0];datastore.addEventListener('change',onchangeHandler);readyState='initialized';document.dispatchEvent(new CustomEvent('collections-ds-initialized'));resolve();},reject);});}
function doGetAll(resolve,reject){var result=Object.create(null);var cursor=datastore.sync();function cursorResolve(task){switch(task.operation){case'update':case'add':result[task.data.id]=task.data;break;case'remove':delete result[task.data.id];break;case'clear':result=Object.create(null);break;case'done':resolve(result);return;}
cursor.next().then(cursorResolve,reject);}
cursor.next().then(cursorResolve,reject);}
function get(id){return new Promise(function doGet(resolve,reject){init().then(function onInitialized(){datastore.get(id).then(resolve,reject);},reject);});}
function getAll(){return new Promise(function doGet(resolve,reject){init().then(doGetAll.bind(null,resolve,reject),reject);});}
function getAllCategories(){return new Promise(function doGet(resolve,reject){getAll().then(function(collections){var categories=[];for(var id in collections){var collection=collections[id];if(collection.categoryId){categories.push(collection.categoryId);}}
resolve(categories);},reject);});}
function onchangeHandler(event){var operation=event.operation;var callbacks=listeners[operation];callbacks&&callbacks.forEach(function iterCallback(callback){datastore.get(event.id).then(function got(result){callback.method.call(callback.context||this,{type:operation,target:result||event});});});}
function addEventListener(type,callback){var context;if(!(type in listeners)){listeners[type]=[];}
var cb=callback;if(typeof cb==='object'){context=cb;cb=cb.handleEvent;}
if(cb){listeners[type].push({method:cb,context:context});init();}}
function removeEventListener(type,callback){if(!(type in listeners)){return false;}
var callbacks=listeners[type];var length=callbacks.length;for(var i=0;i<length;i++){var thisCallback=callback;if(typeof thisCallback==='object'){thisCallback=callback.handleEvent;}
if(callbacks[i]&&callbacks[i].method===thisCallback){callbacks.splice(i,1);return true;}}
return false;}
function add(data){return new Promise(function doAdd(resolve,reject){init().then(function onInitialized(){var id=data.id||uuid();Object.defineProperty(data,'id',{enumerable:true,configurable:false,writable:false,value:id});datastore.add(data,id).then(function add_success(){resolve(true);},function add_error(){datastore.put(data,id).then(function put_success(){resolve();},reject);});},reject);});}
function getRevisionId(){return new Promise(function doGet(resolve,reject){init().then(function onInitialized(){resolve(datastore.revisionId);},reject);});}
function put(data){return new Promise(function doAdd(resolve,reject){init().then(function onInitialized(){datastore.put(data,data.id).then(function success(){resolve();},reject);},reject);});}
function remove(id){return new Promise(function doRemove(resolve,reject){init().then(function onInitialized(){datastore.remove(id).then(resolve,reject);},reject);});}
exports.CollectionsDatabase={get:get,getAll:getAll,getAllCategories:getAllCategories,getRevisionId:getRevisionId,addEventListener:addEventListener,removeEventListener:removeEventListener,add:add,put:put,remove:remove};}(window));;this.asyncStorage=(function(){'use strict';var DBNAME='asyncStorage';var DBVERSION=1;var STORENAME='keyvaluepairs';var db=null;function withDatabase(f){if(db){f();}else{var openreq=indexedDB.open(DBNAME,DBVERSION);openreq.onerror=function withStoreOnError(){console.error('asyncStorage: can\'t open database:',openreq.error.name);};openreq.onupgradeneeded=function withStoreOnUpgradeNeeded(){openreq.result.createObjectStore(STORENAME);};openreq.onsuccess=function withStoreOnSuccess(){db=openreq.result;f();};}}
function withStore(type,callback,oncomplete){withDatabase(function(){var transaction=db.transaction(STORENAME,type);if(oncomplete){transaction.oncomplete=oncomplete;}
callback(transaction.objectStore(STORENAME));});}
function getItem(key,callback){var req;withStore('readonly',function getItemBody(store){req=store.get(key);req.onerror=function getItemOnError(){console.error('Error in asyncStorage.getItem(): ',req.error.name);};},function onComplete(){var value=req.result;if(value===undefined){value=null;}
callback(value);});}
function setItem(key,value,callback){withStore('readwrite',function setItemBody(store){var req=store.put(value,key);req.onerror=function setItemOnError(){console.error('Error in asyncStorage.setItem(): ',req.error.name);};},callback);}
function removeItem(key,callback){withStore('readwrite',function removeItemBody(store){var req=store.delete(key);req.onerror=function removeItemOnError(){console.error('Error in asyncStorage.removeItem(): ',req.error.name);};},callback);}
function clear(callback){withStore('readwrite',function clearBody(store){var req=store.clear();req.onerror=function clearOnError(){console.error('Error in asyncStorage.clear(): ',req.error.name);};},callback);}
function length(callback){var req;withStore('readonly',function lengthBody(store){req=store.count();req.onerror=function lengthOnError(){console.error('Error in asyncStorage.length(): ',req.error.name);};},function onComplete(){callback(req.result);});}
function key(n,callback){if(n<0){callback(null);return;}
var req;withStore('readonly',function keyBody(store){var advanced=false;req=store.openCursor();req.onsuccess=function keyOnSuccess(){var cursor=req.result;if(!cursor){return;}
if(n===0||advanced){return;}
advanced=true;cursor.advance(n);};req.onerror=function keyOnError(){console.error('Error in asyncStorage.key(): ',req.error.name);};},function onComplete(){var cursor=req.result;callback(cursor?cursor.key:null);});}
return{getItem:getItem,setItem:setItem,removeItem:removeItem,clear:clear,length:length,key:key};}());;(function(window,undefined){'use strict';function L10nError(message,id,loc){this.name='L10nError';this.message=message;this.id=id;this.loc=loc;}
L10nError.prototype=Object.create(Error.prototype);L10nError.prototype.constructor=L10nError;var io={load:function load(url,callback,sync){var xhr=new XMLHttpRequest();if(xhr.overrideMimeType){xhr.overrideMimeType('text/plain');}
xhr.open('GET',url,!sync);xhr.addEventListener('load',function io_load(e){if(e.target.status===200||e.target.status===0){callback(null,e.target.responseText);}else{callback(new L10nError('Not found: '+url));}});xhr.addEventListener('error',callback);xhr.addEventListener('timeout',callback);try{xhr.send(null);}catch(e){callback(new L10nError('Not found: '+url));}},loadJSON:function loadJSON(url,callback){var xhr=new XMLHttpRequest();if(xhr.overrideMimeType){xhr.overrideMimeType('application/json');}
xhr.open('GET',url);xhr.responseType='json';xhr.addEventListener('load',function io_loadjson(e){if(e.target.status===200||e.target.status===0){callback(null,e.target.response);}else{callback(new L10nError('Not found: '+url));}});xhr.addEventListener('error',callback);xhr.addEventListener('timeout',callback);try{xhr.send(null);}catch(e){callback(new L10nError('Not found: '+url));}}};function EventEmitter(){}
EventEmitter.prototype.emit=function ee_emit(){if(!this._listeners){return;}
var args=Array.prototype.slice.call(arguments);var type=args.shift();if(!this._listeners[type]){return;}
var typeListeners=this._listeners[type].slice();for(var i=0;i<typeListeners.length;i++){typeListeners[i].apply(this,args);}};EventEmitter.prototype.addEventListener=function ee_add(type,listener){if(!this._listeners){this._listeners={};}
if(!(type in this._listeners)){this._listeners[type]=[];}
this._listeners[type].push(listener);};EventEmitter.prototype.removeEventListener=function ee_rm(type,listener){if(!this._listeners){return;}
var typeListeners=this._listeners[type];var pos=typeListeners.indexOf(listener);if(pos===-1){return;}
typeListeners.splice(pos,1);};function getPluralRule(lang){var locales2rules={'af':3,'ak':4,'am':4,'ar':1,'asa':3,'az':0,'be':11,'bem':3,'bez':3,'bg':3,'bh':4,'bm':0,'bn':3,'bo':0,'br':20,'brx':3,'bs':11,'ca':3,'cgg':3,'chr':3,'cs':12,'cy':17,'da':3,'de':3,'dv':3,'dz':0,'ee':3,'el':3,'en':3,'eo':3,'es':3,'et':3,'eu':3,'fa':0,'ff':5,'fi':3,'fil':4,'fo':3,'fr':5,'fur':3,'fy':3,'ga':8,'gd':24,'gl':3,'gsw':3,'gu':3,'guw':4,'gv':23,'ha':3,'haw':3,'he':2,'hi':4,'hr':11,'hu':0,'id':0,'ig':0,'ii':0,'is':3,'it':3,'iu':7,'ja':0,'jmc':3,'jv':0,'ka':0,'kab':5,'kaj':3,'kcg':3,'kde':0,'kea':0,'kk':3,'kl':3,'km':0,'kn':0,'ko':0,'ksb':3,'ksh':21,'ku':3,'kw':7,'lag':18,'lb':3,'lg':3,'ln':4,'lo':0,'lt':10,'lv':6,'mas':3,'mg':4,'mk':16,'ml':3,'mn':3,'mo':9,'mr':3,'ms':0,'mt':15,'my':0,'nah':3,'naq':7,'nb':3,'nd':3,'ne':3,'nl':3,'nn':3,'no':3,'nr':3,'nso':4,'ny':3,'nyn':3,'om':3,'or':3,'pa':3,'pap':3,'pl':13,'ps':3,'pt':3,'rm':3,'ro':9,'rof':3,'ru':11,'rwk':3,'sah':0,'saq':3,'se':7,'seh':3,'ses':0,'sg':0,'sh':11,'shi':19,'sk':12,'sl':14,'sma':7,'smi':7,'smj':7,'smn':7,'sms':7,'sn':3,'so':3,'sq':3,'sr':11,'ss':3,'ssy':3,'st':3,'sv':3,'sw':3,'syr':3,'ta':3,'te':3,'teo':3,'th':0,'ti':4,'tig':3,'tk':3,'tl':4,'tn':3,'to':0,'tr':0,'ts':3,'tzm':22,'uk':11,'ur':3,'ve':3,'vi':0,'vun':3,'wa':4,'wae':3,'wo':0,'xh':3,'xog':3,'yo':0,'zh':0,'zu':3};function isIn(n,list){return list.indexOf(n)!==-1;}
function isBetween(n,start,end){return typeof n===typeof start&&start<=n&&n<=end;}
var pluralRules={'0':function(){return'other';},'1':function(n){if((isBetween((n%100),3,10))){return'few';}
if(n===0){return'zero';}
if((isBetween((n%100),11,99))){return'many';}
if(n===2){return'two';}
if(n===1){return'one';}
return'other';},'2':function(n){if(n!==0&&(n%10)===0){return'many';}
if(n===2){return'two';}
if(n===1){return'one';}
return'other';},'3':function(n){if(n===1){return'one';}
return'other';},'4':function(n){if((isBetween(n,0,1))){return'one';}
return'other';},'5':function(n){if((isBetween(n,0,2))&&n!==2){return'one';}
return'other';},'6':function(n){if(n===0){return'zero';}
if((n%10)===1&&(n%100)!==11){return'one';}
return'other';},'7':function(n){if(n===2){return'two';}
if(n===1){return'one';}
return'other';},'8':function(n){if((isBetween(n,3,6))){return'few';}
if((isBetween(n,7,10))){return'many';}
if(n===2){return'two';}
if(n===1){return'one';}
return'other';},'9':function(n){if(n===0||n!==1&&(isBetween((n%100),1,19))){return'few';}
if(n===1){return'one';}
return'other';},'10':function(n){if((isBetween((n%10),2,9))&&!(isBetween((n%100),11,19))){return'few';}
if((n%10)===1&&!(isBetween((n%100),11,19))){return'one';}
return'other';},'11':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14))){return'few';}
if((n%10)===0||(isBetween((n%10),5,9))||(isBetween((n%100),11,14))){return'many';}
if((n%10)===1&&(n%100)!==11){return'one';}
return'other';},'12':function(n){if((isBetween(n,2,4))){return'few';}
if(n===1){return'one';}
return'other';},'13':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14))){return'few';}
if(n!==1&&(isBetween((n%10),0,1))||(isBetween((n%10),5,9))||(isBetween((n%100),12,14))){return'many';}
if(n===1){return'one';}
return'other';},'14':function(n){if((isBetween((n%100),3,4))){return'few';}
if((n%100)===2){return'two';}
if((n%100)===1){return'one';}
return'other';},'15':function(n){if(n===0||(isBetween((n%100),2,10))){return'few';}
if((isBetween((n%100),11,19))){return'many';}
if(n===1){return'one';}
return'other';},'16':function(n){if((n%10)===1&&n!==11){return'one';}
return'other';},'17':function(n){if(n===3){return'few';}
if(n===0){return'zero';}
if(n===6){return'many';}
if(n===2){return'two';}
if(n===1){return'one';}
return'other';},'18':function(n){if(n===0){return'zero';}
if((isBetween(n,0,2))&&n!==0&&n!==2){return'one';}
return'other';},'19':function(n){if((isBetween(n,2,10))){return'few';}
if((isBetween(n,0,1))){return'one';}
return'other';},'20':function(n){if((isBetween((n%10),3,4)||((n%10)===9))&&!(isBetween((n%100),10,19)||isBetween((n%100),70,79)||isBetween((n%100),90,99))){return'few';}
if((n%1000000)===0&&n!==0){return'many';}
if((n%10)===2&&!isIn((n%100),[12,72,92])){return'two';}
if((n%10)===1&&!isIn((n%100),[11,71,91])){return'one';}
return'other';},'21':function(n){if(n===0){return'zero';}
if(n===1){return'one';}
return'other';},'22':function(n){if((isBetween(n,0,1))||(isBetween(n,11,99))){return'one';}
return'other';},'23':function(n){if((isBetween((n%10),1,2))||(n%20)===0){return'one';}
return'other';},'24':function(n){if((isBetween(n,3,10)||isBetween(n,13,19))){return'few';}
if(isIn(n,[2,12])){return'two';}
if(isIn(n,[1,11])){return'one';}
return'other';}};var index=locales2rules[lang.replace(/-.*$/,'')];if(!(index in pluralRules)){return function(){return'other';};}
return pluralRules[index];}
var nestedProps=['style','dataset'];var parsePatterns;function parse(ctx,source){var ast={};if(!parsePatterns){parsePatterns={comment:/^\s*#|^\s*$/,entity:/^([^=\s]+)\s*=\s*(.+)$/,multiline:/[^\\]\\$/,macro:/\{\[\s*(\w+)\(([^\)]*)\)\s*\]\}/i,unicode:/\\u([0-9a-fA-F]{1,4})/g,entries:/[\r\n]+/,controlChars:/\\([\\\n\r\t\b\f\{\}\"\'])/g};}
var entries=source.split(parsePatterns.entries);for(var i=0;i<entries.length;i++){var line=entries[i];if(parsePatterns.comment.test(line)){continue;}
while(parsePatterns.multiline.test(line)&&i<entries.length){line=line.slice(0,-1)+entries[++i].trim();}
var entityMatch=line.match(parsePatterns.entity);if(entityMatch){try{parseEntity(entityMatch[1],entityMatch[2],ast);}catch(e){if(ctx){ctx._emitter.emit('error',e);}else{throw e;}}}}
return ast;}
function setEntityValue(id,attr,key,value,ast){var obj=ast;var prop=id;if(attr){if(!(id in obj)){obj[id]={};}
if(typeof(obj[id])==='string'){obj[id]={'_':obj[id]};}
obj=obj[id];prop=attr;}
if(!key){obj[prop]=value;return;}
if(!(prop in obj)){obj[prop]={'_':{}};}else if(typeof(obj[prop])==='string'){obj[prop]={'_index':parseMacro(obj[prop]),'_':{}};}
obj[prop]._[key]=value;}
function parseEntity(id,value,ast){var name,key;var pos=id.indexOf('[');if(pos!==-1){name=id.substr(0,pos);key=id.substring(pos+1,id.length-1);}else{name=id;key=null;}
var nameElements=name.split('.');var attr;if(nameElements.length>1){var attrElements=[];attrElements.push(nameElements.pop());if(nameElements.length>1){if(nestedProps.indexOf(nameElements[nameElements.length-1])!==-1){attrElements.push(nameElements.pop());}}
name=nameElements.join('.');attr=attrElements.reverse().join('.');}else{attr=null;}
setEntityValue(name,attr,key,unescapeString(value),ast);}
function unescapeControlCharacters(str){return str.replace(parsePatterns.controlChars,'$1');}
function unescapeUnicode(str){return str.replace(parsePatterns.unicode,function(match,token){return unescape('%u'+'0000'.slice(token.length)+token);});}
function unescapeString(str){if(str.lastIndexOf('\\')!==-1){str=unescapeControlCharacters(str);}
return unescapeUnicode(str);}
function parseMacro(str){var match=str.match(parsePatterns.macro);if(!match){throw new L10nError('Malformed macro');}
return[match[1],match[2]];}
var MAX_PLACEABLE_LENGTH=2500;var MAX_PLACEABLES=100;var rePlaceables=/\{\{\s*(.+?)\s*\}\}/g;function Entity(id,node,env){this.id=id;this.env=env;this.dirty=false;if(typeof node==='string'){this.value=node;}else{for(var key in node){if(node.hasOwnProperty(key)&&key[0]!=='_'){if(!this.attributes){this.attributes={};}
this.attributes[key]=new Entity(this.id+'.'+key,node[key],env);}}
this.value=node._||null;this.index=node._index;}}
Entity.prototype.resolve=function E_resolve(ctxdata){if(this.dirty){return undefined;}
this.dirty=true;var val;try{val=resolve(ctxdata,this.env,this.value,this.index);}finally{this.dirty=false;}
return val;};Entity.prototype.toString=function E_toString(ctxdata){try{return this.resolve(ctxdata);}catch(e){return undefined;}};Entity.prototype.valueOf=function E_valueOf(ctxdata){if(!this.attributes){return this.toString(ctxdata);}
var entity={value:this.toString(ctxdata),attributes:{}};for(var key in this.attributes){if(this.attributes.hasOwnProperty(key)){entity.attributes[key]=this.attributes[key].toString(ctxdata);}}
return entity;};function subPlaceable(ctxdata,env,match,id){if(ctxdata&&ctxdata.hasOwnProperty(id)&&(typeof ctxdata[id]==='string'||(typeof ctxdata[id]==='number'&&!isNaN(ctxdata[id])))){return ctxdata[id];}
if(env.hasOwnProperty(id)){if(!(env[id]instanceof Entity)){env[id]=new Entity(id,env[id],env);}
var value=env[id].resolve(ctxdata);if(typeof value==='string'){if(value.length>=MAX_PLACEABLE_LENGTH){throw new L10nError('Too many characters in placeable ('+
value.length+', max allowed is '+
MAX_PLACEABLE_LENGTH+')');}
return value;}}
return match;}
function interpolate(ctxdata,env,str){var placeablesCount=0;var value=str.replace(rePlaceables,function(match,id){if(placeablesCount++>=MAX_PLACEABLES){throw new L10nError('Too many placeables ('+placeablesCount+', max allowed is '+MAX_PLACEABLES+')');}
return subPlaceable(ctxdata,env,match,id);});placeablesCount=0;return value;}
function resolve(ctxdata,env,expr,index){if(typeof expr==='string'){return interpolate(ctxdata,env,expr);}
if(typeof expr==='boolean'||typeof expr==='number'||!expr){return expr;}
if(index&&ctxdata&&ctxdata.hasOwnProperty(index[1])){var argValue=ctxdata[index[1]];if(argValue===0&&'zero'in expr){return resolve(ctxdata,env,expr.zero);}
if(argValue===1&&'one'in expr){return resolve(ctxdata,env,expr.one);}
if(argValue===2&&'two'in expr){return resolve(ctxdata,env,expr.two);}
var selector=env.__plural(argValue);if(expr.hasOwnProperty(selector)){return resolve(ctxdata,env,expr[selector]);}}
if('other'in expr){return resolve(ctxdata,env,expr.other);}
return undefined;}
function compile(env,ast){env=env||{};for(var id in ast){if(ast.hasOwnProperty(id)){env[id]=new Entity(id,ast[id],env);}}
return env;}
function Locale(id,ctx){this.id=id;this.ctx=ctx;this.isReady=false;this.entries={__plural:getPluralRule(id)};}
Locale.prototype.getEntry=function L_getEntry(id){var entries=this.entries;if(!entries.hasOwnProperty(id)){return undefined;}
if(entries[id]instanceof Entity){return entries[id];}
return entries[id]=new Entity(id,entries[id],entries);};Locale.prototype.build=function L_build(callback){var sync=!callback;var ctx=this.ctx;var self=this;var l10nLoads=ctx.resLinks.length;function onL10nLoaded(err){if(err){ctx._emitter.emit('error',err);}
if(--l10nLoads<=0){self.isReady=true;if(callback){callback();}}}
if(l10nLoads===0){onL10nLoaded();return;}
function onJSONLoaded(err,json){if(!err&&json){self.addAST(json);}
onL10nLoaded(err);}
function onPropLoaded(err,source){if(!err&&source){var ast=parse(ctx,source);self.addAST(ast);}
onL10nLoaded(err);}
for(var i=0;i<ctx.resLinks.length;i++){var path=ctx.resLinks[i].replace('{{locale}}',this.id);var type=path.substr(path.lastIndexOf('.')+1);switch(type){case'json':io.loadJSON(path,onJSONLoaded,sync);break;case'properties':io.load(path,onPropLoaded,sync);break;}}};Locale.prototype.addAST=function(ast){for(var id in ast){if(ast.hasOwnProperty(id)){this.entries[id]=ast[id];}}};Locale.prototype.getEntity=function(id,ctxdata){var entry=this.getEntry(id);if(!entry){return null;}
return entry.valueOf(ctxdata);};function Context(id){this.id=id;this.isReady=false;this.isLoading=false;this.supportedLocales=[];this.resLinks=[];this.locales={};this._emitter=new EventEmitter();function getWithFallback(id){if(!this.isReady){throw new L10nError('Context not ready');}
var cur=0;var loc;var locale;while(loc=this.supportedLocales[cur]){locale=this.getLocale(loc);if(!locale.isReady){locale.build(null);}
var entry=locale.getEntry(id);if(entry===undefined){cur++;warning.call(this,new L10nError(id+' not found in '+loc,id,loc));continue;}
return entry;}
error.call(this,new L10nError(id+' not found',id));return null;}
this.get=function get(id,ctxdata){var entry=getWithFallback.call(this,id);if(entry===null){return'';}
return entry.toString(ctxdata)||'';};this.getEntity=function getEntity(id,ctxdata){var entry=getWithFallback.call(this,id);if(entry===null){return null;}
return entry.valueOf(ctxdata);};this.getLocale=function getLocale(code){var locales=this.locales;if(locales[code]){return locales[code];}
return locales[code]=new Locale(code,this);};function negotiate(available,requested,defaultLocale){if(available.indexOf(requested[0])===-1||requested[0]===defaultLocale){return[defaultLocale];}else{return[requested[0],defaultLocale];}}
function freeze(supported){var locale=this.getLocale(supported[0]);if(locale.isReady){setReady.call(this,supported);}else{locale.build(setReady.bind(this,supported));}}
function setReady(supported){this.supportedLocales=supported;this.isReady=true;this._emitter.emit('ready');}
this.requestLocales=function requestLocales(){if(this.isLoading&&!this.isReady){throw new L10nError('Context not ready');}
this.isLoading=true;var requested=Array.prototype.slice.call(arguments);var supported=negotiate(requested.concat('en-US'),requested,'en-US');freeze.call(this,supported);};this.addEventListener=function addEventListener(type,listener){this._emitter.addEventListener(type,listener);};this.removeEventListener=function removeEventListener(type,listener){this._emitter.removeEventListener(type,listener);};this.ready=function ready(callback){if(this.isReady){setTimeout(callback);}
this.addEventListener('ready',callback);};this.once=function once(callback){if(this.isReady){setTimeout(callback);return;}
var callAndRemove=(function(){this.removeEventListener('ready',callAndRemove);callback();}).bind(this);this.addEventListener('ready',callAndRemove);};function warning(e){this._emitter.emit('warning',e);return e;}
function error(e){this._emitter.emit('error',e);return e;}}
var DEBUG=false;var isPretranslated=false;var rtlList=['ar','he','fa','ps','qps-plocm','ur'];navigator.mozL10n={ctx:new Context(),get:function get(id,ctxdata){return navigator.mozL10n.ctx.get(id,ctxdata);},localize:function localize(element,id,args){return localizeElement.call(navigator.mozL10n,element,id,args);},translate:function translate(element){return translateFragment.call(navigator.mozL10n,element);},ready:function ready(callback){return navigator.mozL10n.ctx.ready(callback);},once:function once(callback){return navigator.mozL10n.ctx.once(callback);},get readyState(){return navigator.mozL10n.ctx.isReady?'complete':'loading';},language:{set code(lang){navigator.mozL10n.ctx.requestLocales(lang);},get code(){return navigator.mozL10n.ctx.supportedLocales[0];},get direction(){return getDirection(navigator.mozL10n.ctx.supportedLocales[0]);}},_getInternalAPI:function(){return{Error:L10nError,Context:Context,Locale:Locale,Entity:Entity,getPluralRule:getPluralRule,rePlaceables:rePlaceables,getTranslatableChildren:getTranslatableChildren,getL10nAttributes:getL10nAttributes,loadINI:loadINI,fireLocalizedEvent:fireLocalizedEvent,parse:parse,compile:compile};}};navigator.mozL10n.ctx.ready(onReady.bind(navigator.mozL10n));if(DEBUG){navigator.mozL10n.ctx.addEventListener('error',console.error);navigator.mozL10n.ctx.addEventListener('warning',console.warn);}
function getDirection(lang){return(rtlList.indexOf(lang)>=0)?'rtl':'ltr';}
var readyStates={'loading':0,'interactive':1,'complete':2};function waitFor(state,callback){state=readyStates[state];if(readyStates[document.readyState]>=state){callback();return;}
document.addEventListener('readystatechange',function l10n_onrsc(){if(readyStates[document.readyState]>=state){document.removeEventListener('readystatechange',l10n_onrsc);callback();}});}
if(window.document){isPretranslated=(document.documentElement.lang===navigator.language);if(document.documentElement.dataset.noCompleteBug){pretranslate.call(navigator.mozL10n);return;}
if(isPretranslated){waitFor('interactive',function(){window.setTimeout(initResources.bind(navigator.mozL10n));});}else{if(document.readyState==='complete'){window.setTimeout(initResources.bind(navigator.mozL10n));}else{waitFor('interactive',pretranslate.bind(navigator.mozL10n));}}}
function pretranslate(){if(inlineLocalization.call(this)){waitFor('interactive',(function(){window.setTimeout(initResources.bind(this));}).bind(this));}else{initResources.call(this);}}
function inlineLocalization(){var script=document.documentElement.querySelector('script[type="application/l10n"]'+'[lang="'+navigator.language+'"]');if(!script){return false;}
var locale=this.ctx.getLocale(navigator.language);locale.addAST(JSON.parse(script.innerHTML));var l10n={ctx:locale,language:{code:locale.id,direction:getDirection(locale.id)}};translateFragment.call(l10n);isPretranslated=true;return true;}
function initResources(){var resLinks=document.head.querySelectorAll('link[type="application/l10n"]');var iniLinks=[];var i;for(i=0;i<resLinks.length;i++){var link=resLinks[i];var url=link.getAttribute('href');var type=url.substr(url.lastIndexOf('.')+1);if(type==='ini'){iniLinks.push(url);}
this.ctx.resLinks.push(url);}
var iniLoads=iniLinks.length;if(iniLoads===0){initLocale.call(this);return;}
function onIniLoaded(err){if(err){this.ctx._emitter.emit('error',err);}
if(--iniLoads===0){initLocale.call(this);}}
for(i=0;i<iniLinks.length;i++){loadINI.call(this,iniLinks[i],onIniLoaded.bind(this));}}
function initLocale(){this.ctx.requestLocales(navigator.language);window.addEventListener('languagechange',function l10n_langchange(){navigator.mozL10n.language.code=navigator.language;});}
function onReady(){if(!isPretranslated){this.translate();}
isPretranslated=false;fireLocalizedEvent.call(this);}
function fireLocalizedEvent(){var event=new CustomEvent('localized',{'bubbles':false,'cancelable':false,'detail':{'language':this.ctx.supportedLocales[0]}});window.dispatchEvent(event);}
function loadINI(url,callback){var ctx=this.ctx;io.load(url,function(err,source){var pos=ctx.resLinks.indexOf(url);if(err){ctx.resLinks.splice(pos,1);return callback(err);}
if(!source){ctx.resLinks.splice(pos,1);return callback(new Error('Empty file: '+url));}
var patterns=parseINI(source,url).resources.map(function(x){return x.replace('en-US','{{locale}}');});ctx.resLinks.splice.apply(ctx.resLinks,[pos,1].concat(patterns));callback();});}
function relativePath(baseUrl,url){if(url[0]==='/'){return url;}
var dirs=baseUrl.split('/').slice(0,-1).concat(url.split('/')).filter(function(path){return path!=='.';});return dirs.join('/');}
var iniPatterns={'section':/^\s*\[(.*)\]\s*$/,'import':/^\s*@import\s+url\((.*)\)\s*$/i,'entry':/[\r\n]+/};function parseINI(source,iniPath){var entries=source.split(iniPatterns.entry);var locales=['en-US'];var genericSection=true;var uris=[];var match;for(var i=0;i<entries.length;i++){var line=entries[i];if(genericSection&&iniPatterns['import'].test(line)){match=iniPatterns['import'].exec(line);var uri=relativePath(iniPath,match[1]);uris.push(uri);continue;}
if(iniPatterns.section.test(line)){genericSection=false;match=iniPatterns.section.exec(line);locales.push(match[1]);}}
return{locales:locales,resources:uris};}
function translateFragment(element){if(!element){element=document.documentElement;document.documentElement.lang=this.language.code;document.documentElement.dir=this.language.direction;}
translateElement.call(this,element);var nodes=getTranslatableChildren(element);for(var i=0;i<nodes.length;i++){translateElement.call(this,nodes[i]);}}
function getTranslatableChildren(element){return element?element.querySelectorAll('*[data-l10n-id]'):[];}
function localizeElement(element,id,args){if(!element){return;}
if(!id){element.removeAttribute('data-l10n-id');element.removeAttribute('data-l10n-args');setTextContent(element,'');return;}
element.setAttribute('data-l10n-id',id);if(args&&typeof args==='object'){element.setAttribute('data-l10n-args',JSON.stringify(args));}else{element.removeAttribute('data-l10n-args');}
if(this.ctx.isReady){translateElement.call(this,element);}}
function getL10nAttributes(element){if(!element){return{};}
var l10nId=element.getAttribute('data-l10n-id');var l10nArgs=element.getAttribute('data-l10n-args');var args=l10nArgs?JSON.parse(l10nArgs):null;return{id:l10nId,args:args};}
function translateElement(element){var l10n=getL10nAttributes(element);if(!l10n.id){return;}
var entity=this.ctx.getEntity(l10n.id,l10n.args);if(!entity){return;}
if(typeof entity==='string'){setTextContent(element,entity);return true;}
if(entity.value){setTextContent(element,entity.value);}
for(var key in entity.attributes){if(entity.attributes.hasOwnProperty(key)){var attr=entity.attributes[key];var pos=key.indexOf('.');if(pos!==-1){element[key.substr(0,pos)][key.substr(pos+1)]=attr;}else if(key==='ariaLabel'){element.setAttribute('aria-label',attr);}else{element[key]=attr;}}}
return true;}
function setTextContent(element,text){if(!element.firstElementChild){element.textContent=text;return;}
var found=false;var reNotBlank=/\S/;for(var child=element.firstChild;child;child=child.nextSibling){if(child.nodeType===Node.TEXT_NODE&&reNotBlank.test(child.nodeValue)){if(found){child.nodeValue='';}else{child.nodeValue=text;found=true;}}}
if(!found){element.insertBefore(document.createTextNode(text),element.firstChild);}}})(this);;'use strict';var rscheme=/^(?:[a-z\u00a1-\uffff0-9-+]+)(?::|:\/\/)/i;var UrlHelper={a:null,getUrlFromInput:function urlHelper_getUrlFromInput(input){this.a=this.a||document.createElement('a');this.a.href=input;return this.a.href;},hasScheme:function(input){return!!(rscheme.exec(input)||[])[0];},isURL:function urlHelper_isURL(input){return!UrlHelper.isNotURL(input);},isNotURL:function urlHelper_isNotURL(input){var schemeReg=/^\w+\:\/\//;var case1Reg=/^(\?)|(\?.+\s)/;var case2Reg=/[\?\.\s\:]/;var case3Reg=/^(data\:)/;var str=input.trim();if(case1Reg.test(str)||!case2Reg.test(str)){return true;}
if(case3Reg.test(str)){return false;}
if(!schemeReg.test(str)){str='http://'+str;}
if(!this.urlValidate){this.urlValidate=document.createElement('input');this.urlValidate.setAttribute('type','url');}
this.urlValidate.setAttribute('value',str);return!this.urlValidate.validity.valid;}};;'use strict';(function(exports){const PREVENT_TAP_TIMEOUT=300;var SCROLL_THRESHOLD=20*window.devicePixelRatio;function GridView(config){this.config=config;this.onTouchStart=this.onTouchStart.bind(this);this.onTouchEnd=this.onTouchEnd.bind(this);this.onScroll=this.onScroll.bind(this);this.onContextMenu=this.onContextMenu.bind(this);this.onVisibilityChange=this.onVisibilityChange.bind(this);this.lastScrollTime=0;if(config.features.zoom){this.zoom=new GridZoom(this);}
this.layout=new GridLayout(this);if(config.element.hasAttribute('cols')){this.layout.cols=parseInt(config.element.getAttribute('cols'),10);}
this.start();}
GridView.prototype={icons:{},items:[],get element(){return this.config.element;},set cols(value){this.layout.cols=value;},_launchingApp:false,add:function(item,insertTo){if(!item){return;}
if(item.identifier){if(this.icons[item.identifier]){console.log('Error, duplicate identifier: ',item.identifier,new Error().stack);return;}
this.icons[item.identifier]=item;}
if(!isNaN(parseFloat(insertTo))&&isFinite(insertTo)){this.items.splice(insertTo,0,item);}else{this.items.push(item);}},getNearestItemIndex:function(x,y){var leastDistance;var foundIndex;for(var i=0,iLen=this.items.length;i<iLen;i++){var item=this.items[i];if(!item.isDraggable()){continue;}
var distance=Math.sqrt((x-item.x)*(x-item.x)+
(y-item.y)*(y-item.y));if(!leastDistance||distance<leastDistance){leastDistance=distance;foundIndex=i;}}
return foundIndex;},start:function(){this.element.addEventListener('touchstart',this.onTouchStart);this.element.addEventListener('touchend',this.onTouchEnd);this.element.addEventListener('contextmenu',this.onContextMenu);window.addEventListener('scroll',this.onScroll,true);window.addEventListener('visibilitychange',this.onVisibilityChange);this.lastTouchStart=null;},stop:function(){this.element.removeEventListener('touchstart',this.onTouchStart);this.element.removeEventListener('touchend',this.onTouchEnd);this.element.removeEventListener('contextmenu',this.onContextMenu);window.removeEventListener('scroll',this.onScroll,true);window.removeEventListener('visibilitychange',this.onVisibilityChange);this.lastTouchStart=null;},onContextMenu:function(e){setTimeout(function(){if(e.defaultPrevented){this.lastTouchStart=null;}}.bind(this));},onScroll:function(){this.lastScrollTime=performance.now();},onTouchStart:function(e){this.lastTouchStart=e.changedTouches[0];},onTouchEnd:function(e){var lastScrollTime=this.lastScrollTime;this.lastScrollTime=0;var diff=performance.now()-lastScrollTime;if(diff>0&&diff<PREVENT_TAP_TIMEOUT){return;}
var lastTouchStart=this.lastTouchStart;if(!lastTouchStart){return;}
var touch=e.changedTouches.identifiedTouch(lastTouchStart.identifier);if(!touch){return;}
var deltaX=lastTouchStart.clientX-touch.clientX;var deltaY=lastTouchStart.clientY-touch.clientY;this.lastTouchStart=null;var move=Math.hypot(deltaX,deltaY);if(move<SCROLL_THRESHOLD){this.clickIcon(e);}},onVisibilityChange:function(){this._launchingApp=false;},clickIcon:function(e){e.preventDefault();var container=e.target;var action='launch';if(e.target.classList.contains('remove')){container=e.target.parentNode;action='remove';}
var identifier=container.dataset.identifier;var icon=this.icons[identifier];var inEditMode=this.dragdrop&&this.dragdrop.inEditMode;if(!icon){if(e.target.classList.contains('placeholder')&&inEditMode){window.dispatchEvent(new CustomEvent('hashchange'));}
return;}
if(action==='launch'&&inEditMode){if(icon.detail.type!=='bookmark'||!icon.isEditable()){return;}
action='edit';}else{icon.element.classList.add('launching');var returnTimeout=500;setTimeout(function stateReturn(){if(icon.element){icon.element.classList.remove('launching');}},returnTimeout);}
if((icon.detail.type==='app'||icon.detail.type==='bookmark')&&this._launchingApp){return;}
if((icon.detail.type==='app'&&icon.appState==='ready')||icon.detail.type==='bookmark'){this._launchingApp=true;if(this._launchingTimeout){window.clearTimeout(this._launchingTimeout);this._launchingTimeout=null;}
this._launchingTimeout=window.setTimeout(function(){this._launchingTimeout=null;this._launchingApp=false;}.bind(this),3000);}
icon[action]();},cleanItems:function(skipDivider){var appCount=0;var toRemove=[];this.items.forEach(function(item,idx){if(item instanceof GaiaGrid.Divider){if(appCount===0){toRemove.push(idx);}
appCount=0;}else{appCount++;}},this);toRemove.reverse();toRemove.forEach(function(idx){var removed=this.items.splice(idx,1)[0];removed.remove();},this);if(skipDivider){return;}
var lastItem=this.items[this.items.length-1];if(!(lastItem instanceof GaiaGrid.Divider)){this.items.push(new GaiaGrid.Divider());}
if(this.dragdrop&&this.dragdrop.inEditMode){var coords=[0,lastItem.y+2];this.createPlaceholders(coords,this.items.length,this.layout.cols,true);}},removeAllPlaceholders:function(){var toSplice=[];var previousItem;this.items.forEach(function(item,idx){if(item instanceof GaiaGrid.Placeholder){if(previousItem&&previousItem instanceof GaiaGrid.Divider&&this.dragdrop&&this.dragdrop.inDragAction){return;}
toSplice.push(idx);}
previousItem=item;},this);toSplice.reverse().forEach(function(idx){this.items.splice(idx,1)[0].remove();},this);},clear:function(){for(var i=0,iLen=this.items.length;i<iLen;i++){var item=this.items[i];if(item.element){this.element.removeChild(item.element);item.element=null;}}
this.items=[];this.icons={};},createPlaceholders:function(coordinates,idx,count,createsGroup){for(var i=0;i<count;i++){var itemCoords=[coordinates[0]+i,coordinates[1]];var item=new GaiaGrid.Placeholder();item.createsGroupOnDrop=createsGroup;this.items.splice(idx+i,0,item);item.render(itemCoords,idx+i);}},render:function(options){var self=this;options=options||{};this.removeAllPlaceholders();this.cleanItems(options.skipDivider);var from=options.from-1||0;var to=this.items.length-1;this.layout.offsetY=0;var x=0;var y=0;function step(item){self.layout.stepYAxis(item.pixelHeight);x=0;y++;}
var pendingCachedIcons=0;var onCachedIconRendered=()=>{if(--pendingCachedIcons<=0){this.element.removeEventListener('cached-icon-rendered',onCachedIconRendered);this.element.dispatchEvent(new CustomEvent('cached-icons-rendered'));}};this.element.addEventListener('cached-icon-rendered',onCachedIconRendered);for(var idx=0;idx<=to;idx++){var item=this.items[idx];if(x>0&&item.gridWidth>1&&x+item.gridWidth>=this.layout.cols){var remaining=this.layout.cols-x;this.createPlaceholders([x,y],idx,remaining);idx+=remaining;to+=remaining;item=this.items[idx];var lastItem=this.items[idx-(remaining+1)];step(lastItem);}
if(idx>=from){item.hasCachedIcon&&++pendingCachedIcons;item.render([x,y],idx);}
x+=item.gridWidth;if(x>=this.layout.cols){step(item);}}
this.element.setAttribute('cols',this.layout.cols);pendingCachedIcons===0&&onCachedIconRendered();this.loadDragDrop();},loadDragDrop:function(){if(!this.dragdrop&&this.config.features.dragdrop){LazyLoader.load('shared/elements/gaia_grid/js/grid_dragdrop.js',()=>{if(this.dragdrop){return;}
this.dragdrop=new GridDragDrop(this);});}}};exports.GridView=GridView;}(window));;'use strict';(function(exports){const SHADOW_BLUR=1;const SHADOW_OFFSET_Y=1;const SHADOW_OFFSET_X=1;const SHADOW_COLOR='rgba(0, 0, 0, 0.2)';const DEFAULT_BACKGROUND_COLOR='rgb(228, 234, 238)';const UNSCALED_CANVAS_PADDING=2;const CANVAS_PADDING=UNSCALED_CANVAS_PADDING*devicePixelRatio;function IconRenderer(icon){this._icon=icon;}
IconRenderer.TYPE={CLIP:'clip',FAVICON:'favicon',STANDARD:'standard',};IconRenderer.prototype={unscaledCanvasPadding:UNSCALED_CANVAS_PADDING*2,get _maxSize(){return this._icon.grid.layout.gridMaxIconSize;},_createCanvas:function(){var canvas=document.createElement('canvas');canvas.width=this._maxSize+(CANVAS_PADDING*2);canvas.height=this._maxSize+(CANVAS_PADDING*2);return canvas;},_decorateShadowCanvas:function(canvas){var ctx=canvas.getContext('2d',{willReadFrequently:true});ctx.shadowColor=SHADOW_COLOR;ctx.shadowBlur=SHADOW_BLUR;ctx.shadowOffsetY=SHADOW_OFFSET_Y;ctx.shadowOffsetX=SHADOW_OFFSET_X;return ctx;},clip:function(img){return new Promise((resolve)=>{var shadowCanvas=this._createCanvas();var shadowCtx=this._decorateShadowCanvas(shadowCanvas);var clipCanvas=this._createCanvas();var clipCtx=clipCanvas.getContext('2d',{willReadFrequently:true});clipCtx.beginPath();clipCtx.arc(clipCanvas.width/2,clipCanvas.height/2,clipCanvas.height/2,0,2*Math.PI);clipCtx.clip();clipCtx.drawImage(img,0,0,clipCanvas.width,clipCanvas.height);clipCanvas.toBlob((blob)=>{var clipImage=new Image();clipImage.onload=()=>{shadowCtx.drawImage(clipImage,CANVAS_PADDING,CANVAS_PADDING,this._maxSize,this._maxSize);shadowCanvas.toBlob(resolve);URL.revokeObjectURL(clipImage.src);};clipImage.src=URL.createObjectURL(blob);});});},favicon:function(img){if(img.width>this._icon.grid.layout.gridIconSize/2){return this.clip(img);}
return new Promise((resolve)=>{var shadowCanvas=this._createCanvas();var shadowCtx=this._decorateShadowCanvas(shadowCanvas);var iconWidth;var iconHeight;shadowCtx.beginPath();shadowCtx.arc(shadowCanvas.width/2,shadowCanvas.height/2,shadowCanvas.height/2-CANVAS_PADDING,0,2*Math.PI,false);shadowCtx.fillStyle=DEFAULT_BACKGROUND_COLOR;shadowCtx.fill();iconWidth=iconHeight=this._maxSize*0.55;shadowCtx.shadowBlur=0;shadowCtx.shadowOffsetY=0;shadowCtx.mozImageSmoothingEnabled=false;shadowCtx.drawImage(img,(shadowCanvas.width-iconWidth)/2,(shadowCanvas.height-iconHeight)/2,iconWidth,iconHeight);shadowCanvas.toBlob(resolve);});},standard:function(img){return new Promise((resolve)=>{var shadowCanvas=this._createCanvas();var shadowCtx=this._decorateShadowCanvas(shadowCanvas);shadowCtx.drawImage(img,CANVAS_PADDING,CANVAS_PADDING,this._maxSize,this._maxSize);shadowCanvas.toBlob(resolve);});}};exports.GridIconRenderer=IconRenderer;}(window));;'use strict';(function(exports){const maxIconsPerRow=4;const iconScaleFactorMaxIconsPerRow=5;const minIconsPerRow=3;const iconScaleFactorMinIconsPerRow=3.8;const distanceBetweenIconsWithMinIconsPerRow=36;const distanceBetweenIconsWithMaxIconsPerRow=38;var windowWidth=window.innerWidth;function GridLayout(gridView){this.gridView=gridView;if(window.verticalPreferences){verticalPreferences.get('grid.cols').then(value=>{this.cols=value;this.onReady();},this.onReady);verticalPreferences.addEventListener('updated',this);}else{this.onReady();}}
GridLayout.prototype={minIconsPerRow:minIconsPerRow,maxIconsPerRow:maxIconsPerRow,_cols:minIconsPerRow,_offsetY:0,_percent:1,_dividerLineHeight:0,get percent(){return this._percent;},get cols(){return this._cols;},set cols(value){if(!value||value===this._cols){return;}
if(window.verticalPreferences){verticalPreferences.put('grid.cols',value);}
this._offsetY=0;this._percent=value==minIconsPerRow?1:minIconsPerRow/maxIconsPerRow;this._cols=value;},get gridItemHeight(){return this.gridIconSize+
(this._cols===minIconsPerRow?distanceBetweenIconsWithMinIconsPerRow:distanceBetweenIconsWithMaxIconsPerRow);},get gridItemWidth(){return windowWidth/this._cols;},get gridMaxIconSize(){var baseSize=(windowWidth/iconScaleFactorMinIconsPerRow);return baseSize*devicePixelRatio;},get gridIconSize(){var numCols=this._cols;var size=windowWidth/numCols;if(numCols===minIconsPerRow){size=windowWidth/iconScaleFactorMinIconsPerRow;}else if(numCols===maxIconsPerRow){size=windowWidth/iconScaleFactorMaxIconsPerRow;}
return Math.floor(size);},get offsetY(){return this._offsetY;},set offsetY(value){this._offsetY=value;},stepYAxis:function(value){this._offsetY+=value;},handleEvent:function(e){switch(e.type){case'updated':var prop=e.target;if(prop.name==='grid.cols'){this.cols=parseInt(prop.value,10);this.gridView.render();}
break;}},calculateSize:function(){windowWidth=window.innerWidth;},onReady:function(){window.dispatchEvent(new CustomEvent('gaiagrid-layout-ready'));}};exports.GridLayout=GridLayout;}(window));;window.GaiaGrid=(function(win){'use strict';var proto=Object.create(HTMLElement.prototype);var baseurl=window.GaiaGridBaseurl||'/shared/elements/gaia_grid/';proto.createdCallback=function(){var shadow=this.createShadowRoot();this._template=template.content.cloneNode(true);this._styleHack();this._grid=new GridView({element:this,features:{dragdrop:this.getAttribute('dragdrop')!==null,zoom:this.getAttribute('zoom')!==null}});shadow.appendChild(this._template);};proto.add=function(){this._grid.add.apply(this._grid,arguments);};proto.clear=function(){this._grid.clear.apply(this._grid,arguments);};proto.render=function(){this._grid.layout.calculateSize();this._grid.render.apply(this._grid,arguments);};proto.start=function(){this._grid.start.apply(this._grid,arguments);};proto.stop=function(){this._grid.stop.apply(this._grid,arguments);};proto.getIcons=function(){return this._grid.icons;};proto.getItems=function(){return this._grid.items;};proto.getIcon=function(identifier){return this._grid.icons[identifier];};proto.removeIconByIdentifier=function(identifier){delete this._grid.icons[identifier];};proto.removeItemByIndex=function(itemIndex){this._grid.items.splice(itemIndex,1);};proto.removeUntilDivider=function(){var items=this._grid.items;for(var i=items.length-1;i>0;i--){var item=items[i];if(item instanceof GaiaGrid.Placeholder){items.pop();item.remove();continue;}else if(item instanceof GaiaGrid.Divider){return items.pop();}else{return null;}}};proto.setEditHeaderElement=function(element){if(this._grid.dragdrop){this._grid.dragdrop.editHeaderElement=element;}};Object.defineProperty(proto,'maxIconSize',{get:function(){return this._grid.layout.gridMaxIconSize;}});proto.getIndexLastIcon=function(){var items=this._grid.items;for(var i=this._grid.items.length-1;i>=0;i--){if(items[i]instanceof GaiaGrid.Mozapp){return i;}}};proto.removeNonVisualElements=function(){var nonVisualElements=[GaiaGrid.Placeholder];function isNonVisual(elem){var retVal=false;for(var i=0,iLen=nonVisualElements.length;i<iLen&&!retVal;i++){retVal=elem instanceof nonVisualElements[i];}
return retVal;}
var i=0;var iLen=this._grid.items.length;while(i<iLen){this._grid.items[i].detail.index=i;if(isNonVisual(this._grid.items[i])){this._grid.items.splice(i,1);iLen-=1;}else{i+=1;}}};proto.moveTo=function(orig,dst){this._grid.items.splice(dst,0,this._grid.items.splice(orig,1)[0]);};proto._styleHack=function(){var style=this._template.querySelector('style');this.appendChild(style.cloneNode(true));};var stylesheet=baseurl+'style.css';var template=document.createElement('template');template.innerHTML='<style scoped>'+'@import url('+stylesheet+');</style>'+'<content></content>';return document.registerElement('gaia-grid',{prototype:proto});})(window);;'use strict';(function(exports){const ICON_BLOB_DECORATED_EVENT='iconblobdecorated';const ICON_BLOB_ERROR_EVENT='gaiagrid-iconbloberror';const FETCH_XHR_TIMEOUT=10000;function fetchBlob(uri){return new Promise(function(accept,reject){var xhr=new XMLHttpRequest({mozAnon:true,mozSystem:true});xhr.open('GET',uri,true);xhr.responseType='blob';xhr.timeout=FETCH_XHR_TIMEOUT;xhr.send();xhr.onload=function(){var status=xhr.status;if(status!==0&&status!==200){reject(new Error('Got HTTP status '+status+' trying to load '+uri));return;}
accept(xhr.response);};xhr.onerror=xhr.ontimeout=function(){reject(new Error('Error while HTTP GET: ',uri));};});}
function GridItem(){this.detail={};}
GridItem.prototype={x:0,y:0,pixelHeight:0,gridWidth:1,scale:1,persistToDB:true,get hasCachedIcon(){return this.detail&&this.detail.decoratedIconBlob;},renderer:GridIconRenderer.TYPE.STANDARD,iconState:'none',get defaultIcon(){return'/shared/elements/gaia_grid/images/default_icon.png';},get grid(){return document.getElementsByTagName('gaia-grid')[0]._grid;},isRemovable:function(){return false;},isEditable:function(){return false;},isDraggable:function(){return true;},isIconFromOrigin:function(){return this.icon.startsWith('http')||this.icon.startsWith('app:');},setPosition:function(position){this.detail.index=position;},closestIconFromList:function(choices){if(!choices){return this.defaultIcon;}
var list=Object.keys(choices).map(function(size){return size;}).sort(function(a,b){return b-a;});var length=list.length;if(length===0){return this.defaultIcon;}
var maxSize=this.grid.layout.gridMaxIconSize;var accurateSize=list[0];for(var i=0;i<length;i++){var size=list[i];if(size<maxSize){break;}
accurateSize=size;}
var icon=choices[accurateSize];if(!UrlHelper.hasScheme(icon)){var a=document.createElement('a');a.href=this.app.origin;icon=a.protocol+'//'+a.host+icon;}
return icon;},renderIconFromSrc:function(url){var background=new Image();background.src=url;background.onload=this._decorateIcon.bind(this,background);},renderIconFromBlob:function(blob){var background=new Image();background.src=URL.createObjectURL(blob);background.onload=()=>{this._decorateIcon(background);URL.revokeObjectURL(background.src);};},_decorateIcon:function(img){var strategy=this.detail.renderer||this.renderer;this.rendererInstance=new GridIconRenderer(this);this.rendererInstance[strategy](img).then(this._displayDecoratedIcon.bind(this));},_displayDecoratedIcon:function(blob,isCachedIcon){var style=this.element.style;if(!style.backgroundSize){style.height=this.grid.layout.gridItemHeight+'px';style.backgroundSize=((this.grid.layout.gridIconSize*(1/this.scale))+
GridIconRenderer.prototype.unscaledCanvasPadding)+'px';}
if(isCachedIcon){var url=URL.createObjectURL(blob);style.backgroundImage='url('+url+')';this.element.dataset.backgroundImage=url;var img=new Image();img.onload=img.onerror=()=>{this.grid.element.dispatchEvent(new CustomEvent('cached-icon-rendered'));};img.src=url;return;}
this._compareBlobs(blob,this.detail.decoratedIconBlob).then((equal)=>{if(equal){return;}
style.backgroundImage='url('+URL.createObjectURL(blob)+')';this.detail.decoratedIconBlob=blob;this.grid.element.dispatchEvent(new CustomEvent(ICON_BLOB_DECORATED_EVENT,{detail:this}));var bgImg=this.element.dataset.backgroundImage;bgImg&&URL.revokeObjectURL(bgImg);});},_compareBlobs:function(blob1,blob2){return new Promise(function(resolve){if(!blob1||!blob2||blob1.type!==blob2.type||blob1.size!==blob2.size){resolve(false);return;}
var startBytes=127;var bytesHash=16;var reader=new FileReader();reader.onloadend=function(){var result1=reader.result;reader=new FileReader();reader.onloadend=reader.onerror=function(){resolve(result1===reader.result);};reader.readAsDataURL(blob2.slice(startBytes,startBytes+bytesHash));};reader.onerror=function(){resolve(false);};reader.readAsDataURL(blob1.slice(startBytes,startBytes+bytesHash));});},fetchIconBlob:function(){return fetchBlob(this.icon);},_stampElementWithIcon:function(uri){if(uri.startsWith('data:')){return;}
if(uri.length>255){uri=uri.slice(0,255);}
this.element.dataset.testIcon=uri;},renderIcon:function(renderCachedIcon){var icon=this.icon;this.iconState='pending';if(renderCachedIcon&&this.hasCachedIcon){this._displayDecoratedIcon(this.detail.decoratedIconBlob,true);var resolveIcon=()=>{this.grid.element.removeEventListener('cached-icons-rendered',resolveIcon);this.doRenderIcon(icon);};this.grid.element.addEventListener('cached-icons-rendered',resolveIcon);}else{this.doRenderIcon(icon);}},doRenderIcon:function(icon){if(!this.isIconFromOrigin()){this._stampElementWithIcon(icon);this.renderIconFromSrc(icon);this.iconState='success';return Promise.resolve();}
var eventTarget=this.grid.element;var blobNotFound=()=>{this.iconState='error';if(!this.hasCachedIcon){this.renderIconFromSrc(this.defaultIcon);this._stampElementWithIcon(this.defaultIcon);}else{this._stampElementWithIcon('blobcache');}
eventTarget.dispatchEvent(new CustomEvent(ICON_BLOB_ERROR_EVENT,{detail:this}));};return this.fetchIconBlob().then((blob)=>{if(!blob){return blobNotFound();}
this.renderIconFromBlob(blob);this.iconState='success';this._stampElementWithIcon(icon);}).catch((err)=>{console.error('Error fetching icon',err);blobNotFound();});},removeFromGrid:function(){var idx=this.grid.items.indexOf(this);if(idx===-1){console.error('Attempting to remove self before item has been added!');return;}
this.grid.items.splice(idx,1);delete this.grid.icons[this.identifier];if(this.element){this.element.parentNode.removeChild(this.element);}
this.grid.render({from:idx-1});},remove:function(){this.grid.element.dispatchEvent(new CustomEvent('removeitem',{detail:this}));},render:function(coordinates,index){this.scale=this.grid.layout.percent;if(!this.element){var tile=document.createElement('div');tile.className='icon';tile.dataset.identifier=this.identifier;tile.dataset.isDraggable=this.isDraggable();tile.setAttribute('role','link');var nameContainerEl=document.createElement('p');nameContainerEl.style.marginTop=((this.grid.layout.gridIconSize*(1/this.scale))+
(GridIconRenderer.prototype.unscaledCanvasPadding/2))+'px';tile.appendChild(nameContainerEl);var nameEl=document.createElement('span');nameEl.className='title';nameEl.textContent=this.name;nameContainerEl.appendChild(nameEl);if(this.isRemovable()){var removeEl=document.createElement('span');removeEl.className='remove';tile.appendChild(removeEl);}
this.element=tile;this.renderIcon(true);this.grid.element.appendChild(tile);}
var x=coordinates[0]*this.grid.layout.gridItemWidth;var y=this.grid.layout.offsetY;this.setPosition(index);this.x=x;this.y=y;if(this.noTransform){return;}
this.transform(x,y,this.grid.layout.percent);},transform:function(x,y,scale,element){scale=scale||1;element=element||this.element;element.style.transform='translate('+x+'px,'+y+'px) scale('+scale+')';},updateTitle:function(){if(!this.element){return;}
var nameEl=this.element.querySelector('.title');nameEl.textContent=this.name;},updateFromDatastore:function(record){var iconChanged=record.icon!==this.icon;var nameChanged=record.name!==this.name;var type=this.detail.type;var lastIcon=this.icon;record.type=type;this.detail=record;if(nameChanged){this.updateTitle();document.body.clientTop;this.element.style.display='none';document.body.clientTop;this.element.style.display='';}
if(iconChanged&&record.icon){this.renderIcon();}else if(!record.icon){this.detail.icon=lastIcon;}}};exports.GaiaGrid.GridItem=GridItem;}(window));;'use strict';(function(exports){const TYPE='bookmark';function Bookmark(record,features){this.detail=record;this.features=features||{};this.detail.type=TYPE;}
Bookmark.prototype={__proto__:GaiaGrid.GridItem.prototype,renderer:GridIconRenderer.TYPE.FAVICON,get pixelHeight(){return this.grid.layout.gridItemHeight;},gridWidth:1,get name(){return this.detail.name;},get icon(){return this.detail.icon||this.defaultIcon;},get identifier(){return this.detail.id;},update:GaiaGrid.GridItem.prototype.updateFromDatastore,isEditable:function(){return this.features&&this.features.isEditable!==false;},isRemovable:function(){return this.features&&this.features.isRemovable!==false;},isDraggable:function(){return this.features&&this.features.isDraggable!==false;},render:function(coordinates,index){GaiaGrid.GridItem.prototype.render.call(this,coordinates,index);this.element.classList.add('bookmark');if(this.isEditable()){this.element.classList.add('editable');}},launch:function(){var features={name:this.name,icon:this.icon,remote:true,useAsyncPanZoom:true};var url=this.detail.url;if(this.features.search){features.searchName=this.name;features.searchUrl=url;}
window.open(url,'_blank',Object.keys(features).map(function eachFeature(key){return encodeURIComponent(key)+'='+
encodeURIComponent(features[key]);}).join(','));},edit:function(){new MozActivity({name:'save-bookmark',data:{type:'url',url:this.detail.id}});}};exports.GaiaGrid.Bookmark=Bookmark;}(window));;'use strict';(function(exports){const IDENTIFIER_SEP='-';var _=navigator.mozL10n.get;var MOZAPP_EVENTS=['downloadsuccess','downloaderror','downloadavailable','downloadapplied','progress'];var APP_LOADING='loading';var APP_ERROR='error';var APP_UNRECOVERABLE='unrecoverable';var APP_PAUSED='paused';var APP_READY='ready';function Mozapp(app,entryPoint,details){this.app=app;this.entryPoint=entryPoint;this.detail={type:'app',manifestURL:app.manifestURL,entryPoint:entryPoint,index:0,decoratedIconBlob:details&&details.decoratedIconBlob};MOZAPP_EVENTS.forEach(function(type){this.app['on'+type]=this;},this);this.setAppState(this._determineState(app));}
Mozapp.HIDDEN_ROLES=['system','input','homescreen','search'];Mozapp.prototype={__proto__:GaiaGrid.GridItem.prototype,_isHiddenRole:function(){var manifest=this.app.manifest;if(!manifest||!manifest.role){return null;}
return Mozapp.HIDDEN_ROLES.indexOf(manifest.role)!==-1;},_determineState:function(app){if(app.installState==='pending'&&!app.downloadAvailable&&!app.readyToApplyDownload){return APP_UNRECOVERABLE;}
if(app.downloading){return APP_LOADING;}
if(app.downloadError&&app.downloadError.name){if(app.downloadError.name==='DOWNLOAD_CANCELED'){return APP_PAUSED;}
return APP_ERROR;}
if(app.installState==='pending'){return APP_PAUSED;}
return APP_READY;},handleEvent:function(event){switch(event.type){case'progress':case'downloaderror':case'downloadsuccess':this.setAppState(this._determineState(this.app));break;case'downloadapplied':if(this._isHiddenRole()){console.warn('Removing hidden app from the grid',this.name);return this.removeFromGrid();}
delete this._accurateIcon;this.setAppState(this._determineState(this.app));this.renderIcon();break;}},get pixelHeight(){return this.grid.layout.gridItemHeight;},gridWidth:1,get name(){var userLang=document.documentElement.lang;var locales=this.descriptor.locales;var localized=locales&&locales[userLang]&&locales[userLang].name;return localized||this.descriptor.name;},get icon(){var icon=this._accurateIcon;if(!icon){icon=this._accurateIcon=this.closestIconFromList(this.descriptor.icons);}
return icon;},get descriptor(){var manifest=this.app.manifest||this.app.updateManifest;if(this.entryPoint&&manifest.entry_points&&manifest.entry_points[this.entryPoint]){return manifest.entry_points[this.entryPoint];}
return manifest;},identifierSeparator:IDENTIFIER_SEP,get identifier(){var identifier=[this.app.manifestURL];if(this.entryPoint){identifier.push(this.entryPoint);}
return identifier.join(IDENTIFIER_SEP);},isRemovable:function(){return this.app.removable;},unrecoverableError:function(){var dialog=new ConfirmDialogHelper({type:'unrecoverable',title:_('gaia-grid-unrecoverable-error-title'),body:_('gaia-grid-unrecoverable-error-body'),confirm:{title:_('gaia-grid-unrecoverable-error-action'),cb:()=>{navigator.mozApps.mgmt.uninstall(this.app);}}});dialog.show(document.body);},cancel:function(){var dialog=new ConfirmDialogHelper({type:'pause',title:_('gaia-grid-stop-download-title',{name:this.name}),body:_('gaia-grid-stop-download-body'),cancel:{title:_('gaia-grid-cancel')},confirm:{title:_('gaia-grid-stop-download-action'),type:'danger',cb:()=>this.app.cancelDownload()}});dialog.show(document.body);},resume:function(){var dialog=new ConfirmDialogHelper({type:'resume',title:_('gaia-grid-resume-download-title'),body:_('gaia-grid-resume-download-body',{name:this.name}),cancel:{title:_('gaia-grid-cancel')},confirm:{title:_('gaia-grid-resume-download-action'),cb:()=>{this.setAppState(APP_LOADING);this.app.download();}}});dialog.show(document.body);},setAppState:function(state){this.appState=state;if(this.element){this.element.dataset.appState=state;}},render:function(){var needsStateSet=!this.element;GaiaGrid.GridItem.prototype.render.apply(this,arguments);if(needsStateSet){this.setAppState(this.appState);}},launch:function(){var app=this.app;switch(this._determineState(app)){case APP_UNRECOVERABLE:return this.unrecoverableError();case APP_ERROR:case APP_PAUSED:return this.resume();case APP_LOADING:return this.cancel();}
if(this.entryPoint){return app.launch(this.entryPoint);}
return app.launch();}};exports.GaiaGrid.Mozapp=Mozapp;}(window));;'use strict';(function(exports){const mozSettings=navigator.mozSettings;const DEBUG=true;const API_URL='https://api.everything.me/partners/1.0/{resource}/';var initPromise=null;var slice=Function.call.bind(Array.prototype.slice);exports.eme={config:{apiUrl:API_URL},init:function init(){initPromise=this.readSettings().then(function success(settings){if(settings['everythingme.api.url']){this.config.apiUrl=settings['everythingme.api.url'];}
return this.device.init(settings);}.bind(this),function error(e){eme.log('fatal error accessing device settings',e);}).catch(function(e){eme.log('init failed',e);});this.init=function noop(){eme.log('init: noop');return initPromise;};return initPromise;},readSettings:function readSettings(){return new Promise(function ready(resolve,reject){var lock=mozSettings.createLock();var request=lock.get('*');request.onsuccess=function onsuccess(){resolve(request.result);};request.onerror=function onerror(){reject(request.error);};}.bind(this));},log:function log(){if(DEBUG){var args=slice(arguments);args.unshift('evme');console.log.apply(console,args);}},warn:function warn(){var args=slice(arguments);args.unshift('evme','WARNING');console.warn.apply(console,args);},error:function error(){var args=slice(arguments);args.unshift('evme','ERROR');console.error.apply(console,args);}};})(window);;'use strict';(function(eme){var PREFIX='eme-cache';var slice=Function.call.bind(Array.prototype.slice);function Cache(){}
Cache.prototype={generateKey:function cache_generateKey(){return slice(arguments).map(JSON.stringify).join('|');},add:function cache_add(key,value){return new Promise(function ready(resolve,reject){asyncStorage.setItem(PREFIX+key,value);});},get:function cache_get(key){return new Promise(function ready(resolve,reject){asyncStorage.getItem(PREFIX+key,function onValue(value){if(value===null){reject(null);}else{resolve(value);}});});},addRequest:function cache_addRequest(service,method,options,response){this.add(this.generateKey(service,method,options),response);},getRequest:function cache_getRequest(service,method,options){return this.get(this.generateKey(service,method,options));}};eme.Cache=new Cache();})(window.eme);;'use strict';(function(eme){const geolocation=navigator.geolocation;const mozSettings=navigator.mozSettings;const mozWifiManager=navigator.mozWifiManager;const mozMobileConnections=navigator.mozMobileConnections;const dataConnectionNames={'hspa+':'H+','lte':'4G','ehrpd':'4G','hsdpa':'3G','hsupa':'3G','hspa':'3G','evdo0':'3G','evdoa':'3G','evdob':'3G','1xrtt':'3G','umts':'3G','edge':'2G','is95a':'2G','is95b':'2G','gprs':'2G'};var position=null;var positionPromise=null;const positionTTL=10*60*1000;const geoOptions={timeout:4000,maximumAge:positionTTL};function cacheGeolocation(){geolocation.getCurrentPosition((newPosition)=>{eme.log('updating geolocation cache',newPosition.coords);if(newPosition&&newPosition.coords){position=newPosition;}
eme.Cache.add('position',newPosition).then(()=>{});},(error)=>{eme.log('geolocation error',error.code,error.message);},geoOptions);}
function updatePosition(){if(positionPromise){return positionPromise;}
positionPromise=new Promise(function ready(resolve){eme.Cache.get('position').then((newPosition)=>{eme.log('got geolocation cache',newPosition.coords);positionPromise=null;if(newPosition&&newPosition.coords){position=newPosition;}
setTimeout(cacheGeolocation);resolve(position);},()=>{positionPromise=null;setTimeout(cacheGeolocation);resolve(position);});});return positionPromise;}
function Device(){this.osVersion=null;this.deviceId=null;this.deviceName=null;this.screen={width:window.screen.width*window.devicePixelRatio,height:window.screen.height*window.devicePixelRatio};}
Device.prototype={init:function init(settings){var deviceId=settings['search.deviceId'];if(!deviceId){deviceId=this.generateDeviceId();mozSettings.createLock().set({'search.deviceId':deviceId});}
this.deviceId=deviceId;this.deviceName=settings['deviceinfo.product_model'];this.osVersion=settings['deviceinfo.os'];return updatePosition().then(function log(){eme.log('device init',JSON.stringify(this));}.bind(this));},generateDeviceId:function generateDeviceId(){var url=window.URL.createObjectURL(new Blob());var id=url.replace('blob:','');window.URL.revokeObjectURL(url);return'fxos-'+id;},get language(){return navigator.language;},get timezone(){return(new Date().getTimezoneOffset()/-60).toString();},get connection(){if(!this._connection){this._connection=mozMobileConnections&&mozMobileConnections.length&&mozMobileConnections[0];}
return this._connection;},get voiceNet(){return(this.connection&&this.connection.voice)?this.connection.voice.network:null;},get dataConnectionType(){if(mozWifiManager&&mozWifiManager.enabled){return'wifi';}
if(this.connection&&this.connection.data){var type=this.connection.data.type;return dataConnectionNames[type]||type;}
return null;},get carrier(){return this.voiceNet?(this.voiceNet.shortName||this.voiceNet.longName):null;},get mcc(){return this.voiceNet?this.voiceNet.mcc:null;},get mnc(){return this.voiceNet?this.voiceNet.mnc:null;},get position(){if(!position||(Date.now()-position.timestamp>positionTTL)){updatePosition();}
return position;}};eme.device=new Device();})(window.eme);;'use strict';(function(eme){const NETWORK_ERROR='network error';const API_KEY='79011a035b40ef3d7baeabc8f85b862f';const ICON_FORMAT=20;var device=eme.device;function getCtx(){var w=device.screen.width;var h=device.screen.height;var lat;var lon;var position=device.position;if(position&&position.coords){lat=position.coords.latitude;lon=position.coords.longitude;}
return{lc:device.language||undefined,tz:device.timezone||undefined,v:device.osVersion||undefined,dn:device.deviceName||undefined,cr:device.carrier||undefined,ct:device.dataConnectionType||undefined,mcc:device.mcc||undefined,mnc:device.mnc||undefined,sr:(w&&h)?[w,h].join('x'):undefined,ll:(lat&&lon)?[lat,lon].join(','):undefined};}
function Request(service,method,options){var resource=service+'/'+method;var url=eme.config.apiUrl.replace('{resource}',resource);var payload='';options=options?options:{};options.apiKey=API_KEY;options.deviceId=eme.device.deviceId;options.ctx=getCtx();for(var opt in options){var value=options[opt];if(value!==null&&value!==undefined){if(typeof value==='object'){value=JSON.stringify(value);}
payload+=opt+'='+encodeURIComponent(value)+'&';}}
eme.log('API request:',decodeURIComponent(url+'?'+payload));var httpRequest;var promise=new Promise(function done(resolve,reject){httpRequest=new XMLHttpRequest({mozSystem:true});httpRequest.open('POST',url,true);httpRequest.setRequestHeader('Content-Type','application/x-www-form-urlencoded');httpRequest.onload=function onload(e){var response=null;try{response=JSON.parse(httpRequest.responseText);}catch(ex){reject(ex);}
if(response&&response.errorCode>0){resolve(response);}else{reject(response?'errorCode: '+response.errorCode:'invalid response');}};httpRequest.onerror=function onError(e){reject(NETWORK_ERROR);};httpRequest.send(payload);});promise.abort=function(){if(httpRequest.abort){httpRequest.abort();}};return promise;}
function CacheableRequest(service,method,options){return new Promise(function done(resolve,reject){if(navigator.onLine){Request(service,method,options).then(function success(response){eme.Cache.addRequest(service,method,options,response);resolve(response);},reject).catch();}
else{eme.Cache.getRequest(service,method,options).then(function success(cachedResponse){eme.log('using cached response:',service+'/'+method);resolve(cachedResponse);},reject.bind(null,NETWORK_ERROR)).catch(reject);}});}
function PartnersAPI(){this.Apps={MAX_QUERY_LENGTH:128,nativeInfo:function nativeInfo(options){if(options.guids&&options.guids.length){options.guids=JSON.stringify(options.guids);}
return Request('Apps','nativeInfo',options);},search:function search(options){if(!!options.query&&options.query.length>this.MAX_QUERY_LENGTH){options.query=options.query.substr(0,this.MAX_QUERY_LENGTH);}
options.iconFormat=ICON_FORMAT;return Request('Apps','search',options);}};this.Search={suggestions:function suggestions(options){return Request('Search','suggestions',options);},bgimage:function bgimage(options){options.width=Math.ceil(options.width||eme.device.screen.width);options.height=Math.ceil(options.height||eme.device.screen.height);return Request('Search','bgimage',options);}};this.Categories={list:function list(options){return CacheableRequest('Categories','list',options);}};}
eme.api=new PartnersAPI();})(window.eme);;'use strict';(function(exports){function chooseBackgroundRatio(pixelRatio){var backgroundOptions=[1,1.5,2,2.25];return Math.max.apply(null,backgroundOptions.filter((r)=>pixelRatio>=r));}
const backgroundRatio=chooseBackgroundRatio(window.devicePixelRatio);const suffix=backgroundRatio===1?'.jpg':('@'+backgroundRatio+'x.jpg');const mozBgUrl='http://fxos.cdn.mozilla.net/collection/background/{categoryId}'+suffix;const APPS_IN_ICON=3;function Common(){}
Common.prototype={APPS_IN_ICON:APPS_IN_ICON,chooseBackgroundRatio:chooseBackgroundRatio,b64toBlob:function b64toBlob(b64){return new Promise((resolve,reject)=>{var img=new Image();img.onload=function onload(){var canvas=document.createElement('canvas');canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext('2d');ctx.drawImage(img,0,0,canvas.width,canvas.height);canvas.toBlob(resolve);};img.onerror=reject;img.src=b64;});},getMozBackground:function getMozBackground(collection){if(!collection.categoryId){return Promise.reject('no categoryId');}
var url=mozBgUrl.replace('{categoryId}',collection.categoryId);var xhr=new XMLHttpRequest({mozSystem:true});xhr.open('GET',url,true);xhr.responseType='blob';return new Promise((resolve,reject)=>{xhr.onload=function onload(){if(xhr.status===200){var blob=new Blob([xhr.response],{type:'image/jpg'});eme.log('getMozBackground','success',url);resolve({blob:blob,source:url,checksum:'mozilla'});}else{reject('xhr.status '+xhr.status);}};xhr.onerror=function onerror(){reject('xhr error');};xhr.send();});},getEmeBackground:function getEmeBackground(collection,size){var checksum;var options={width:size||undefined,height:size||undefined};if(collection.categoryId){options.categoryId=collection.categoryId;}
else{options.query=collection.query;}
if(collection.background){checksum=collection.background.checksum;if(collection.background.blob){options._checksum=checksum;}}
return eme.api.Search.bgimage(options).then((response)=>{if(checksum&&checksum===response.checksum){eme.log('background didn\'t change (checksum match)');return collection.background;}else{var b64;var image=response.response.image;if(image){b64=image.data;if(/image\//.test(image.MIMEType)){b64='data:'+image.MIMEType+';base64,'+image.data;}}
return this.b64toBlob(b64).then(function toBg(blob){return{blob:blob,source:response.response.source,checksum:response.checksum||null};});}});},getBackground:function getBackground(collection,size){return this.getMozBackground(collection).catch(function(e){eme.log('getBackground',e,'trying e.me background');return this.getEmeBackground(collection,size);}.bind(this)).catch(function(e){eme.log('getBackground','failed',e);});},getWebIcons:function getWebIcons(collection){var options=(collection.categoryId)?{categoryId:collection.categoryId}:{query:collection.query};options.limit=APPS_IN_ICON;return eme.api.Apps.search(options).then(response=>{var webicons=response.response.apps.slice(0,APPS_IN_ICON).map(app=>app.icon);return webicons;});},prepareAssets:function prepareAssets(collection){var ready=Promise.resolve(null);var backgroundPromise=collection.backgroundReady?ready:this.getBackground(collection);var iconsPromise=collection.iconsReady?ready:this.getWebIcons(collection);return Promise.all([iconsPromise,backgroundPromise]).then((results)=>{collection.webicons=results[0]||collection.webicons;collection.background=results[1]||collection.background;return collection;});}};exports.Common=new Common();}(window));;'use strict';(function(exports){const APPS_IN_ICON=Common.APPS_IN_ICON;function WebResult(data,gridItemFeatures){data.emeId=data.id;data.url=data.id=data.appUrl;data.renderer=GridIconRenderer.TYPE.CLIP;return{identifier:data.appUrl,type:'webResult',data:data,features:gridItemFeatures};}
function PinnedHomeIcon(identifier){return{identifier:identifier,type:'homeIcon'};}
function BaseCollection(props){this.id=props.id||null;this.name=props.name||'';this.icon=props.icon||null;this.pinned=props.pinned||[];this.webResults=[];this.webicons=props.webicons||[];this.background=props.background||{};this.originalProps={pinned:props.pinned?props.pinned.slice():[],background:props.background||{}};if(window.SearchDedupe){this.dedupe=new SearchDedupe();}}
BaseCollection.create=function create(data){if(data.categoryId){return new CategoryCollection(data);}else if(data.query){return new QueryCollection(data);}
return null;};BaseCollection.prototype={get iconsReady(){return this.pinned.length+this.webicons.length>=APPS_IN_ICON;},get backgroundReady(){return this.background&&this.background.blob;},get localizedName(){var l10nId='collection-categoryId-'+this.categoryId;return navigator.mozL10n.get(l10nId)||this.name;},refresh:function refresh(){return CollectionsDatabase.get(this.id).then(function create(fresh){this.pinned=fresh.pinned||[];}.bind(this));},save:function save(method){if(this.iconDirty){return this.renderIcon().then(()=>this.write(method),()=>this.write(method));}else{return this.write(method);}},write:function write(method){method=method||'put';var toSave={id:this.id,name:this.name,query:this.query,categoryId:this.categoryId,cName:this.cName,webicons:this.webicons,pinned:this.pinned,background:this.background,icon:this.icon};this.originalProps=toSave;return CollectionsDatabase[method](toSave).then(()=>{this.id=toSave.id;eme.log(this.name,'saved to CollectionsDatabase');});},get iconDirty(){var original=this.originalProps;try{if((original.background&&original.background.blob)!==(this.background&&this.background.blob)){return true;}
var first=this.pinned.concat(this.webResults).slice(0,APPS_IN_ICON);var oFirst=original.pinned.concat(original.webResults).slice(0,APPS_IN_ICON);if(first.length!==oFirst.length){return true;}
for(var i=0;i<APPS_IN_ICON;i++){var item=first[i];var oItem=oFirst[i];if((item&&item.identifier)!==(oItem&&oItem.identifier)){return true;}}}catch(e){eme.error('icon dirty checking failed',e);}
return false;},pin:function pin(){var arg=arguments[0];var items=Array.isArray(arg)?arg:[arg];var newItems=items.filter(this.isNotPinned.bind(this));if(newItems.length){this.pinned=this.pinned.concat(newItems);this.save().then(()=>eme.log(newItems.length,'new pinned to',this.name));}},pinHomeIcons:function pinHomeIcons(identifiers){var items=identifiers.map(function each(identifier){return new PinnedHomeIcon(identifier);});this.pin(items);},dropHomeIcon:function dropHomeIcon(identifier){var newPinned=new PinnedHomeIcon(identifier);for(var i=0,iLen=this.pinned.length;i<iLen;i++){if(this.pinned[i].identifier===identifier){this.pinned.splice(i,1);break;}}
this.pinned.unshift(newPinned);this.save().then(()=>eme.log(identifier,'dropped into',this.name));},pinWebResult:function pinWebResult(data){this.pin(new WebResult(data));},unpin:function unpin(identifier){var idx=this.pinnedIdentifiers.indexOf(identifier);if(idx!==-1){this.pinned.splice(idx,1);return this.save().then(()=>eme.log('removed pinned item',identifier));}},addWebResults:function addWebResult(arrayOfData){var results=arrayOfData.map(function each(data){return new WebResult(data,{isDraggable:false,isRemovable:false});});this.webResults=results;this.webicons=arrayOfData.slice(0,APPS_IN_ICON).map(app=>app.icon);},isPinned:function isPinned(item){return this.pinnedIdentifiers.indexOf(item.identifier)>-1;},isNotPinned:function isNotPinned(item){return!this.isPinned(item);},setPinned:function setPinned(identifiers){this.pinned=identifiers.slice(0,this.pinned.length).map(function(identifier){var idx=this.pinnedIdentifiers.indexOf(identifier);return this.pinned[idx];}.bind(this));this.save();},get pinnedIdentifiers(){return this.pinned.map(function each(item){return item.identifier;});},removeBookmark:function removeBookmark(identifier){window.dispatchEvent(new CustomEvent('collection-remove-webresult',{detail:{identifier:identifier}}));},toGridObject:function(item){var icon;if(item.type==='homeIcon'){if(!HomeIcons.ready){eme.warn('HomeIcons not ready, pinned apps may not render properly');}
icon=HomeIcons.get(item.identifier);}else if(item.type==='webResult'){item.features=item.features||{};item.features.isEditable=false;item.features.search=true;icon=new GaiaGrid.Bookmark(item.data,item.features);if(icon.isRemovable){icon.remove=()=>this.removeBookmark(item.identifier);}}
return icon;},addToGrid:function addToGrid(items,grid){items.forEach(function eachResult(item){item.dedupeId=item.identifier;});items=this.dedupe.reduce(items,'fuzzy');items.forEach(function render(item){if(!item||!item.identifier){return;}
var icon=this.toGridObject(item);if(icon){grid.add(icon);}},this);},addItemToGrid:function prependItemToGrid(item,grid,position){this.pinned.slice(position,1,new PinnedHomeIcon(item.identifier));grid.add(this.toGridObject(item),position);if(this.pinned.length===1){grid.add(new GaiaGrid.Divider(),1);}
grid.render();this.renderIcon();},renderWebResults:function render(grid){if(!this.webResults.length){return;}
grid.add(new GaiaGrid.Divider());this.addToGrid(this.webResults,grid);grid.render({from:this.pinned.length});},render:function render(grid){this.dedupe.reset();grid.clear();this.addToGrid(this.pinned,grid);if(this.webResults.length){grid.add(new GaiaGrid.Divider());this.addToGrid(this.webResults,grid);}
grid.render();},renderIcon:function renderIcon(){eme.log('rendering icon for',this.name);return Common.prepareAssets(this).then(()=>this.doRenderIcon()).catch(()=>this.doRenderIcon());},doRenderIcon:function doRenderIcon(){var iconSrcs=this.pinned.slice(0,APPS_IN_ICON).map((item)=>this.toGridObject(item).icon);if(iconSrcs.length<APPS_IN_ICON){var moreIcons=this.webicons.filter((webicon)=>iconSrcs.indexOf(webicon)===-1).slice(0,APPS_IN_ICON-iconSrcs.length);iconSrcs=iconSrcs.concat(moreIcons);}
var bgSrc=(this.background&&this.background.blob)?URL.createObjectURL(this.background.blob):null;var icon=new CollectionIcon({iconSrcs:iconSrcs,bgSrc:bgSrc});return icon.render().then((canvas)=>{this.icon=canvas.toDataURL();});}};function CategoryCollection(props){BaseCollection.call(this,props);this.categoryId=props.categoryId;this.cName=props.cName;}
CategoryCollection.prototype={__proto__:BaseCollection.prototype};CategoryCollection.fromResponse=function cc_fromResponse(categoryIds,responseData){function getIcon(iconId){return responseData.icons[iconId];}
var collections=[];var categories=responseData.categories.filter(function _filter(cat){return categoryIds.indexOf(cat.categoryId)>-1;});for(var i=0,l=categories.length;i<l;i++){var cat=categories[i];var collection=new CategoryCollection({name:cat.query,categoryId:cat.categoryId,cName:cat.canonicalName,webicons:cat.appIds.map(getIcon)});collections.push(collection);}
return collections;};function QueryCollection(props){BaseCollection.call(this,props);this.name=this.query=props.query;}
QueryCollection.prototype={__proto__:BaseCollection.prototype};exports.BaseCollection=BaseCollection;exports.CategoryCollection=CategoryCollection;exports.PinnedHomeIcon=PinnedHomeIcon;exports.QueryCollection=QueryCollection;exports.WebResult=WebResult;})(window);;(function(exports){'use strict';var scale;var height;var width;var center;var dMain;var dSide;var vOffset;var hOffset;var xMain;var yMain;var xLeft;var xRight;var ySide;const sideIconDarken=0.65;const gradStops=['rgba(0,0,0,0)','rgba(0,0,0,0.65)'];const defaultBgFill='rgba(51, 51, 51, 0.85)';const deafultBgImage='/style/images/icon_default.png';const emePrefix=/https?:\/\/.*everything.me/;function shouldClip(url){return emePrefix.test(url);}
function blobToDataURI(blob){return new Promise(function convert(resolve,reject){var reader=new FileReader();reader.onload=function(){resolve(reader.result);};reader.onerror=reject;reader.readAsDataURL(blob);});}
function systemXHR(url){return new Promise(function doXHR(resolve,reject){var xhr=new XMLHttpRequest({mozAnon:true,mozSystem:true});xhr.open('GET',url,true);xhr.responseType='blob';xhr.onerror=reject;xhr.onload=function onload(){var status=xhr.status;if(status!==0&&status!==200){reject();}else{blobToDataURI(xhr.response).then(resolve,reject).catch(reject);}};try{xhr.send(null);}catch(e){reject(e);return;}});}
function CollectionIcon(config){var canvas=document.createElement('canvas');var context=canvas.getContext('2d');canvas.height=height;canvas.width=width;context.save();this.canvas=canvas;this.context=context;this.iconSrcs=config.iconSrcs||[];this.bgSrc=config.bgSrc||null;}
CollectionIcon.init=function init(maxIconSize){scale=maxIconSize/60;height=maxIconSize;width=maxIconSize;center=maxIconSize/2;dMain=Math.round(22*scale);dSide=Math.round(14*scale);vOffset=Math.round(13*scale);hOffset=Math.round(21*scale);xMain=center-dMain/2;yMain=height-(vOffset+dMain/2);xLeft=center-hOffset-dSide/2;xRight=center+hOffset-dSide/2;ySide=height-(vOffset+dSide/2);};CollectionIcon.prototype.render=function render(){var self=this;var p=new Promise(function done(resolve,reject){self.drawBg().then(self.drawAppIcons.bind(self)).then(function resolved(){resolve(self.canvas);},function rejected(reason){self.context.restore();self.context.clearRect(0,0,width,height);self.drawDefaultBg().then(function resolved(){resolve(self.canvas);});}).catch(function _catch(e){console.log(e);});});return p;};CollectionIcon.prototype.drawAppIcons=function drawAppIcons(){var self=this;var p=new Promise(function done(resolve){var iconPromises=[self.createAppIcon(self.iconSrcs[0]),self.createAppIcon(self.iconSrcs[1],sideIconDarken),self.createAppIcon(self.iconSrcs[2],sideIconDarken)];window.Promise.all(iconPromises).then(function appIconsReady(canvases){var center=canvases[0];var right=canvases[1];var left=canvases[2];if(left){self.context.drawImage(left,xLeft,ySide,dSide,dSide);}
if(right){self.context.drawImage(right,xRight,ySide,dSide,dSide);}
if(center){self.context.drawImage(center,xMain,yMain,dMain,dMain);}
resolve();}).catch(function _catch(e){console.log(e);});});return p;};CollectionIcon.prototype.createAppIcon=function createAppIcon(url,darkness){return new Promise(function done(resolve){if(url){systemXHR(url).then(function success(src){var img=new Image();img.onload=function _onload(){var imgCanvas=document.createElement('canvas');var ctx=imgCanvas.getContext('2d');var imgWidth=img.width;var imgHeight=img.height;imgCanvas.width=imgWidth;imgCanvas.height=imgHeight;if(shouldClip(url)){ctx.arc(imgWidth/2,imgHeight/2,imgWidth/2,0,2*Math.PI);ctx.clip();}
ctx.drawImage(img,0,0,imgWidth,imgHeight);if(darkness){darken(imgCanvas,ctx,darkness);}
resolve(imgCanvas);};img.onerror=function _onerror(){resolve(null);};img.src=src;},function error(e){resolve(null);});}else{resolve(null);}});};CollectionIcon.prototype.drawBg=function drawBg(){var self=this;var p=new Promise(function done(resolve){if(self.bgSrc){var img=new Image();img.onload=function _onload(){var ratio=Math.max(width/this.width,height/this.height);var w=ratio*this.width;var h=ratio*this.height;var wOffset=width-w;var hOffset=height-h;self.context.drawImage(img,wOffset/2,hOffset/2,w,h);self.drawGrad();resolve();};img.onerror=function _onerror(){self.drawDefaultBg().then(resolve);};img.src=self.bgSrc;}else{self.drawDefaultBg().then(resolve);}});return p;};CollectionIcon.prototype.drawDefaultBg=function drawDefaultBg(){var self=this;return new Promise(function handler(resolve){self.context.fillStyle=defaultBgFill;self.context.fillRect(0,0,width,height);var img=new Image();img.onload=function onload(){self.context.drawImage(img,0,0,width,height);resolve();};img.onerror=resolve;img.src=deafultBgImage;});};CollectionIcon.prototype.drawGrad=function drawGrad(){var grad=this.context.createLinearGradient(center,0,center,height);for(var i=0,l=gradStops.length;i<l;i++){grad.addColorStop(i,gradStops[i]);}
this.context.fillStyle=grad;this.context.fillRect(0,0,width,height);};function darken(canvas,context,darkness){var pixels=context.getImageData(0,0,canvas.width,canvas.height);var data=pixels.data;var l=data.length;for(var i=0;i<l;i+=4){data[i]*=darkness;data[i+1]*=darkness;data[i+2]*=darkness;}
context.putImageData(pixels,0,0);}
exports.CollectionIcon=CollectionIcon;})(window);;'use strict';(function(exports){const HIDDEN_ROLES=['system','input','homescreen','search'];var appMgr=navigator.mozApps.mgmt;var initPromise;function HomeIcons(){this.ready=false;this.gridItemsByIdentifier={};this.recordsByManifestUrl={};this.recordsByBookmarkUrl={};}
HomeIcons.prototype={init:function init(){initPromise=Promise.all([this.collectBookmarkURLs(),this.collectManifestURLs()]).then(()=>this.ready=true);this.init=function noop(){return initPromise;};return initPromise;},collectBookmarkURLs:function collectBookmarkURLs(){return new Promise((resolve)=>{BookmarksDatabase.getAll().then((systemBookmarks)=>{for(var id in systemBookmarks){this.processBookmark(systemBookmarks[id]);}
resolve();});});},collectManifestURLs:function collectManifestURLs(){return new Promise(function ready(resolve){appMgr.getAll().onsuccess=function onsuccess(event){for(var i=0,iLen=event.target.result.length;i<iLen;i++){this.processMozApp(event.target.result[i]);}
resolve();}.bind(this);}.bind(this));},processBookmark:function(eachBookmark){var features={isEditable:false,search:true};var bookmark=new GaiaGrid.Bookmark(eachBookmark,features);this.gridItemsByIdentifier[bookmark.identifier]=bookmark;this.recordsByBookmarkUrl[eachBookmark.bookmarkURL]=eachBookmark;},processMozApp:function(eachApp){var manifest=eachApp.manifest||eachApp.updateManifest;var features={isRemovable:true};if(HIDDEN_ROLES.indexOf(manifest.role)!==-1){return;}
function eachIcon(icon){if(!icon.icon){return;}
icon.isRemovable=()=>true;this.gridItemsByIdentifier[icon.identifier]=icon;}
this.recordsByManifestUrl[eachApp.manifestURL]=eachApp;if(manifest.entry_points){for(var i in manifest.entry_points){eachIcon.call(this,new GaiaGrid.Mozapp(eachApp,i,features));}}else{eachIcon.call(this,new GaiaGrid.Mozapp(eachApp,undefined,features));}},get:function get(identifier){return this.gridItemsByIdentifier[identifier];},getIdentifier:function getIdentifier(guid){var gridItem=this.gridItemsByIdentifier[guid];return gridItem?gridItem.identifier:null;},get bookmarkURLs(){return Object.keys(this.recordsByBookmarkUrl);},get manifestURLs(){return Object.keys(this.recordsByManifestUrl);}};exports.HomeIcons=new HomeIcons();}(window));;'use strict';(function(exports){const SETUP_KEY='NativeInfo-setup';function onerror(e){eme.error('NativeInfo error',e&&(e.name||e.message||e));}
function NativeInfo(){}
NativeInfo.prototype={getInfo:function getInfo(guids){if(!navigator.onLine){return Promise.reject();}
return eme.api.Apps.nativeInfo({guids:guids}).then(function success(response){var emeInfo=response.response||{};var guidsByCname={};function each(guid,cName){guidsByCname[cName]=guidsByCname[cName]||[];guidsByCname[cName].push(guid);}
for(var key in emeInfo){var info=emeInfo[key];var cNames=info.experiences||[];cNames.forEach(each.bind(null,info.guid));}
return guidsByCname;});},addToCollections:function addToCollections(guidsByCname){return CollectionsDatabase.getAll().then(function(collections){for(var id in collections){var collection=collections[id];collection=BaseCollection.create(collection);if(collection.cName){var guids=guidsByCname[collection.cName]||[];if(guids.length){var identifiers=guids;eme.log('NativeInfo',identifiers.length,'matches for',collection.cName,JSON.stringify(identifiers));collection.pinHomeIcons(identifiers);}}}});},removeFromCollections:function removeFromCollections(identifier){if(!identifier){return Promise.reject();}
return CollectionsDatabase.getAll().then(function(collections){for(var id in collections){var collection=BaseCollection.create(collections[id]);collection.unpin(identifier);}});},processApp:function processApp(action,id){if(action==='install'){return HomeIcons.init().then(()=>this.getInfo([id])).then(this.addToCollections).catch(onerror);}else if(action==='uninstall'){return HomeIcons.init().then(()=>this.removeFromCollections(id)).catch(onerror);}},processCollection:function processCollection(collection){return this.collectGuids().then(this.getInfo).then(function addToCollection(guidsByCname){var key=collection.cName||collection.query;var guids=guidsByCname[key]||[];if(guids.length){var identifiers=guids;eme.log('NativeInfo',identifiers);collection.pinHomeIcons(identifiers);}});},collectGuids:function collectGuids(){return HomeIcons.init().then(function success(){var manifestURLs=HomeIcons.manifestURLs;var bookmarkURLs=HomeIcons.bookmarkURLs;eme.log('NativeInfo found',manifestURLs.length,'apps');eme.log('NativeInfo found',bookmarkURLs.length,'bookmarks');return manifestURLs.concat(bookmarkURLs);});},doSetup:function doSetup(){eme.init().then(this.collectGuids).then(this.getInfo).then(this.addToCollections).then(function neverAgain(){eme.Cache.add(SETUP_KEY,true);}).catch(onerror);},setup:function setup(){return eme.Cache.get(SETUP_KEY).then(function skip(){eme.log('NativeInfo','skipping setup');},this.doSetup.bind(this));}};exports.NativeInfo=new NativeInfo();}(window));;'use strict';(function(exports){function Synchronizer(){var grid=document.getElementById('grid');CollectionIcon.init(grid.maxIconSize);navigator.mozSetMessageHandler('connection',this.onConnection.bind(this));}
Synchronizer.prototype={onConnection:function(connectionRequest){var action=connectionRequest.keyword;if(action!=='install'&&action!=='uninstall'){return;}
var port=this.port=connectionRequest.port;port.onmessage=this[action].bind(this);port.start();},install:function(event){var message=event.data;eme.init().then(()=>NativeInfo.processApp('install',message.id));},uninstall:function(event){var message=event.data;eme.init().then(()=>NativeInfo.processApp('uninstall',message.id));}};exports.synchronizer=new Synchronizer();}(window));