define("net", [ "require", "exports", "module", "util", "events", "mailapi/worker-router" ], function(e, t) {
    function n(e, t, n) {
        var s = {
            onopen: this._onconnect.bind(this),
            onerror: this._onerror.bind(this),
            ondata: this._ondata.bind(this),
            onclose: this._onclose.bind(this)
        }, i = o.register(function(e) {
            s[e.cmd](e.args);
        });
        this._sendMessage = i.sendMessage, this._unregisterWithRouter = i.unregister;
        var a = [ t, e, {
            useSSL: n,
            useSecureTransport: n,
            binaryType: "arraybuffer"
        } ];
        this._sendMessage("open", a), r.call(this), this.destroyed = !1;
    }
    var s = e("util"), r = e("events").EventEmitter, i = e("mailapi/worker-router"), o = i.registerInstanceType("netsocket");
    t.NetSocket = n, s.inherits(n, r), n.prototype.setTimeout = function() {}, n.prototype.setKeepAlive = function() {}, 
    n.prototype.write = function(e) {
        if (e instanceof Blob) return this._sendMessage("write", [ e ]), void 0;
        if (0 !== e.byteOffset || e.length !== e.buffer.byteLength) {
            var t = e.buffer.slice(e.byteOffset, e.byteOffset + e.length);
            this._sendMessage("write", [ t, 0, t.byteLength ], [ t ]);
        } else this._sendMessage("write", [ e.buffer, e.byteOffset, e.length ]);
    }, n.prototype.upgradeToSecure = function() {
        this._sendMessage("upgradeToSecure", []);
    }, n.prototype.end = function() {
        this.destroyed || (this._sendMessage("close"), this.destroyed = !0, this._unregisterWithRouter());
    }, n.prototype._onconnect = function() {
        this.emit("connect");
    }, n.prototype._onerror = function(e) {
        this.emit("error", e);
    }, n.prototype._ondata = function(e) {
        var t = Buffer(e);
        this.emit("data", t);
    }, n.prototype._onclose = function() {
        this.emit("close"), this.emit("end");
    }, t.connect = function(e, t, s) {
        return new n(e, t, !!s);
    };
}), define("tls", [ "net", "exports" ], function(e, t) {
    t.connect = function(t, n, s, r) {
        var i = new e.NetSocket(t, n, !0);
        return r && i.on("connect", r), i;
    };
}), define("imap", [ "require", "exports", "module", "util", "rdcommon/log", "net", "tls", "events", "./mailapi/syncbase", "mailparser/mailparser" ], function(e, t, n) {
    function s(e) {
        return parseInt(e, 10);
    }
    function r(e) {
        return e.replace(Z, function(e, t) {
            if (!t.length) return "&";
            t = t.replace(et, "/");
            var n = new Buffer(t, "base64");
            return n.toString("utf-16be");
        });
    }
    function i(e) {
        var t = z.exec(e);
        if (!t) throw new Error("Not a good IMAP date-time: " + e);
        var n = parseInt(t[1], 10), s = P.indexOf(t[2]), r = parseInt(t[3], 10), i = parseInt(t[4], 10), o = parseInt(t[5], 10), a = parseInt(t[6], 10), c = Date.UTC(r, s, n, i, o, a), d = parseInt(t[7], 10), l = Math.floor(d / 100), u = d % 100;
        return c -= l * j + u * W;
    }
    function o(e) {
        var t;
        return t = (e.getDate() < 10 ? " " : "") + e.getDate() + "-" + P[e.getMonth()] + "-" + e.getFullYear() + " " + ("0" + e.getHours()).slice(-2) + ":" + ("0" + e.getMinutes()).slice(-2) + ":" + ("0" + e.getSeconds()).slice(-2) + (e.getTimezoneOffset() > 0 ? " -" : " +") + ("0" + Math.abs(e.getTimezoneOffset()) / 60).slice(-2) + ("0" + Math.abs(e.getTimezoneOffset()) % 60).slice(-2);
    }
    function a(e) {
        return this instanceof a ? (k.call(this), this._options = {
            username: "",
            password: "",
            host: "localhost",
            port: 143,
            secure: !1,
            connTimeout: 1e4,
            _logParent: null
        }, this._state = {
            status: B.NOCONNECT,
            conn: null,
            curId: 0,
            requests: [],
            unsentRequests: [],
            activeRequests: 0,
            postGreetingCallback: null,
            numCapRecvs: 0,
            isIdle: !0,
            tmrConn: null,
            curData: null,
            curDataMinLength: 0,
            curExpected: null,
            curXferred: 0,
            box: {
                _uidnext: 0,
                _flags: [],
                _newKeywords: !1,
                validity: 0,
                highestModSeq: void 0,
                keywords: [],
                permFlags: [],
                name: null,
                messages: {
                    total: 0,
                    "new": 0
                }
            },
            ext: {
                idle: {
                    MAX_WAIT: 174e4,
                    state: tt,
                    timeWaited: 0
                }
            }
        }, this._unprocessed = [], this._options = x(this._options, e), this._LOG = this._options._logParent ? ot.ImapProtoConn(this, this._options._logParent, Date.now() % 1e3) : null, 
        this._LOG && this._LOG.created(), this.delim = null, this.namespaces = {
            personal: [],
            other: [],
            shared: []
        }, this.capabilities = [], this.enabledCapabilities = [], this.blacklistedCapabilities = this._options.blacklistedCapabilities || [], 
        void 0) : new a(e);
    }
    function c() {}
    function d() {}
    function l(e, t, n) {
        for (var s = "", r = 0, i = e.length; i > r; r++) {
            var o = n ? e : e[r], a = null, c = n ? "" : " ";
            if ("string" == typeof o) o = o.toUpperCase(); else {
                if (!Array.isArray(o)) throw new Error("Unexpected search option data type. Expected string or array. Got: " + typeof o);
                o.length > 1 && (a = o.slice(1)), o.length > 0 && (o = o[0].toUpperCase());
            }
            if ("OR" === o) {
                if (2 !== a.length) throw new Error("OR must have exactly two arguments");
                s += " OR (" + l(a[0], t, !0) + ") (" + l(a[1], t, !0) + ")";
            } else switch ("!" === o[0] && (c += "NOT ", o = o.substr(1)), o) {
              case "ALL":
              case "ANSWERED":
              case "DELETED":
              case "DRAFT":
              case "FLAGGED":
              case "NEW":
              case "SEEN":
              case "RECENT":
              case "OLD":
              case "UNANSWERED":
              case "UNDELETED":
              case "UNDRAFT":
              case "UNFLAGGED":
              case "UNSEEN":
                s += c + o;
                break;

              case "BCC":
              case "BODY":
              case "CC":
              case "FROM":
              case "SUBJECT":
              case "TEXT":
              case "TO":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                s += c + o + ' "' + v("" + a[0]) + '"';
                break;

              case "BEFORE":
              case "ON":
              case "SENTBEFORE":
              case "SENTON":
              case "SENTSINCE":
              case "SINCE":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                if (!(a[0] instanceof Date) && "Invalid Date" === (a[0] = new Date(a[0])).toString()) throw new Error("Search option argument must be a Date object or a parseable date string");
                s += c + o + " " + a[0].getUTCDate() + "-" + P[a[0].getUTCMonth()] + "-" + a[0].getUTCFullYear();
                break;

              case "KEYWORD":
              case "UNKEYWORD":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                s += c + o + " " + a[0];
                break;

              case "LARGER":
              case "SMALLER":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                var d = parseInt(a[0]);
                if (isNaN(d)) throw new Error("Search option argument must be a number");
                s += c + o + " " + a[0];
                break;

              case "HEADER":
                if (!a || 2 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                s += c + o + ' "' + v("" + a[0]) + '" "' + v("" + a[1]) + '"';
                break;

              case "UID":
                if (!a) throw new Error("Incorrect number of arguments for search option: " + o);
                u(a), s += c + o + " " + a.join(",");
                break;

              case "X-GM-MSGID":
              case "X-GM-THRID":
                if (-1 === t.indexOf("X-GM-EXT-1")) throw new Error("IMAP extension not available: " + o);
                var h;
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                if (h = "" + a[0], !/^\d+$/.test(a[0])) throw new Error("Invalid value");
                s += c + o + " " + h;
                break;

              case "X-GM-RAW":
                if (-1 === t.indexOf("X-GM-EXT-1")) throw new Error("IMAP extension not available: " + o);
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                s += c + o + ' "' + v("" + a[0]) + '"';
                break;

              case "X-GM-LABELS":
                if (-1 === t.indexOf("X-GM-EXT-1")) throw new Error("IMAP extension not available: " + o);
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                s += c + o + " " + a[0];
                break;

              default:
                throw new Error("Unexpected search option: " + o);
            }
            if (n) break;
        }
        return console.log("searchargs:", s), s;
    }
    function u(e) {
        for (var t, n = 0, s = e.length; s > n; n++) {
            if ("string" == typeof e[n]) {
                if ("*" === e[n] || "*:*" === e[n]) {
                    s > 1 && (e = [ "*" ]);
                    break;
                }
                if (/^(?:[\d]+|\*):(?:[\d]+|\*)$/.test(e[n])) continue;
            }
            if (t = parseInt("" + e[n]), isNaN(t)) throw new Error('Message ID/number must be an integer, "*", or a range: ' + e[n]);
            "number" != typeof e[n] && (e[n] = t);
        }
    }
    function h(e) {
        var t = [];
        if (!e.length) return t;
        for (var n, s, r = 0, i = -1, o = 1; o < e.length; o++) {
            var a = e.charCodeAt(o);
            if (48 === a) i = parseInt(e.substring(r, o)), r = ++o; else if ("44" === a) {
                if (-1 === i) t.push(parseInt(e.substring(r, o))); else for (n = parseInt(e.substring(r, o)), 
                s = i; n >= s; s++) t.push(s);
                i = -1, start = ++o;
            }
        }
        if (-1 === i) t.push(parseInt(e.substring(r, o))); else for (n = parseInt(e.substring(r, o)), 
        s = i; n >= s; s++) t.push(s);
        return t;
    }
    function p(e, t) {
        for (var n = S(e), s = 0; 3 > s; ++s) if (Array.isArray(n[s])) {
            for (var r = [], i = 0, o = n[s].length; o > i; ++i) {
                var a = {
                    prefix: n[s][i][0],
                    delim: n[s][i][1]
                };
                if (n[s][i].length > 2) {
                    a.extensions = [];
                    for (var c = 2, d = n[s][i].length; d > c; c += 2) a.extensions.push({
                        name: n[s][i][c],
                        flags: n[s][i][c + 1]
                    });
                }
                r.push(a);
            }
            0 === s ? t.personal = r : 1 === s ? t.other = r : 2 === s && (t.shared = r);
        }
    }
    function m(e, t, n) {
        for (var s = S(e), r = 0, o = s.length; o > r; r += 2) if ("UID" === s[r]) n.id = parseInt(s[r + 1], 10); else if ("INTERNALDATE" === s[r]) n.rawDate = s[r + 1], 
        n.date = i(s[r + 1]); else if ("FLAGS" === s[r]) n.flags = s[r + 1].filter(b), n.flags.sort(); else if ("MODSEQ" === s[r]) n.modseq = s[r + 1].slice(1, -1); else if ("BODYSTRUCTURE" === s[r]) n.structure = f(s[r + 1]); else if ("string" == typeof s[r]) n[s[r].toLowerCase()] = s[r + 1]; else if (Array.isArray(s[r]) && "string" == typeof s[r][0] && 0 === s[r][0].indexOf("HEADER") && t) {
            var a = new O.MailParser();
            a._remainder = t, process.immediate = !0, a._process(!0), process.immediate = !1, 
            n.msg = a._currentNode;
        }
    }
    function f(e, t, n) {
        var s = [];
        if (void 0 === t) {
            var r = Array.isArray(e) ? e : S(e);
            r.length && (s = f(r, "", 1));
        } else {
            var i, o, a = e.length;
            if (Array.isArray(e[0])) {
                for (o = -1; Array.isArray(e[++o]); ) s.push(f(e[o], t + ("" !== t ? "." : "") + (n++).toString(), 1));
                if (i = {
                    type: "multipart",
                    subtype: e[o++].toLowerCase()
                }, a > o) {
                    if (Array.isArray(e[o])) {
                        i.params = {};
                        for (var c = 0, d = e[o].length; d > c; c += 2) i.params[e[o][c].toLowerCase()] = e[o][c + 1];
                    } else i.params = e[o];
                    ++o;
                }
            } else {
                if (o = 7, "string" == typeof e[1] ? i = {
                    partID: "" !== t ? t : "1",
                    type: e[0].toLowerCase(),
                    subtype: e[1].toLowerCase(),
                    params: null,
                    id: e[3],
                    description: e[4],
                    encoding: e[5],
                    size: e[6]
                } : (i = {
                    type: e[0].toLowerCase(),
                    params: null
                }, e.splice(1, 0, null), ++a, o = 2), Array.isArray(e[2])) {
                    i.params = {};
                    for (var c = 0, d = e[2].length; d > c; c += 2) i.params[e[2][c].toLowerCase()] = e[2][c + 1];
                    null === e[1] && ++o;
                }
                if ("message" === i.type && "rfc822" === i.subtype) {
                    if (a > o && Array.isArray(e[o])) {
                        i.envelope = {};
                        for (var c = 0, d = e[o].length; d > c; ++c) if (0 === c) i.envelope.date = e[o][c]; else if (1 === c) i.envelope.subject = e[o][c]; else if (c >= 2 && 7 >= c) {
                            var l = e[o][c];
                            if (Array.isArray(l)) {
                                for (var u, h = [], p = !1, m = 0, _ = l.length; _ > m; ++m) if (null === l[m][3]) p = !0, 
                                u = {
                                    group: l[m][2],
                                    addresses: []
                                }; else if (null === l[m][2]) p = !1, h.push(u); else {
                                    var y = {
                                        name: l[m][0],
                                        mailbox: l[m][2],
                                        host: l[m][3]
                                    };
                                    p ? u.addresses.push(y) : h.push(y);
                                }
                                l = h;
                            }
                            2 === c ? i.envelope.from = l : 3 === c ? i.envelope.sender = l : 4 === c ? i.envelope["reply-to"] = l : 5 === c ? i.envelope.to = l : 6 === c ? i.envelope.cc = l : 7 === c && (i.envelope.bcc = l);
                        } else if (8 === c) i.envelope["in-reply-to"] = e[o][c]; else {
                            if (9 !== c) break;
                            i.envelope["message-id"] = e[o][c];
                        }
                    } else i.envelope = null;
                    ++o, i.body = a > o && Array.isArray(e[o]) ? f(e[o], t + ("" !== t ? "." : "") + (n++).toString(), 1) : null, 
                    ++o;
                }
                ("text" === i.type || "message" === i.type && "rfc822" === i.subtype) && a > o && (i.lines = e[o++]), 
                "string" == typeof e[1] && a > o && (i.md5 = e[o++]);
            }
            g(i, a, e, o), s.unshift(i);
        }
        return s;
    }
    function g(e, t, n, s) {
        if (t > s) {
            var r = {
                type: null,
                params: null
            };
            if (Array.isArray(n[s])) {
                if (r.type = n[s][0], Array.isArray(n[s][1])) {
                    r.params = {};
                    for (var i = 0, o = n[s][1].length; o > i; i += 2) r.params[n[s][1][i].toLowerCase()] = n[s][1][i + 1];
                }
            } else null !== n[s] && (r.type = n[s]);
            e.disposition = null === r.type ? null : r, ++s;
        }
        t > s && (e.language = null !== n[s] ? Array.isArray(n[s]) ? n[s] : [ n[s] ] : null, 
        ++s), t > s && (e.location = n[s++]), t > s && (e.extensions = n[s]);
    }
    function _(e, t, n) {
        if (arguments.length < 3 || void 0 === arguments[1] || void 0 === arguments[2] || !t || "" === t || "function" == typeof t || "object" == typeof t) return !1;
        if (t = t === !0 ? "1" : t.toString(), !n || 0 === n) return e.split(t);
        if (0 > n) return !1;
        if (n > 0) {
            var s = e.split(t), r = s.splice(0, n - 1), i = s.join(t);
            return r.push(i), r;
        }
        return !1;
    }
    function y(e) {
        return e.trim().length > 0;
    }
    function b(e) {
        var t = e.trim();
        return t.length > 0 && !it.test(t);
    }
    function v(e) {
        return e.replace(/\\/g, "\\\\").replace(/"/g, '\\"');
    }
    function w(e) {
        return e.toUpperCase();
    }
    function S(e, t, n) {
        n = n || 0;
        var s = !1, r = n - 1, i = !1;
        if (t || (t = new Array()), "string" == typeof e) {
            var o = new Object();
            o.str = e, e = o, i = !0;
        }
        for (var a = n, c = e.str.length; c > a; ++a) {
            if (s) '"' === e.str[a] && e.str[a - 1] && ("\\" !== e.str[a - 1] || e.str[a - 2] && "\\" === e.str[a - 2]) && (s = !1); else if ('"' === e.str[a]) s = !0; else if (" " === e.str[a] || ")" === e.str[a] || "]" === e.str[a]) {
                if (a - (r + 1) > 0 && t.push(N(e.str.substring(r + 1, a))), ")" === e.str[a] || "]" === e.str[a]) return a;
                r = a;
            } else if ("(" === e.str[a] || "[" === e.str[a]) {
                var d = [];
                a = S(e, d, a + 1), r = a, t.push(d);
            } else if ("{" === e.str[a]) {
                var l = e.str.indexOf("\r\n", a);
                if (-1 != l) {
                    var u = /\{(\d+)\}\r\n/.exec(e.str.substring(a, l + 2));
                    if (u) {
                        var h = parseInt(u[1], 10);
                        isNaN(h) || (t.push(N(e.str.substr(l + 2, h))), a = l + 2 + h - 1, r = a);
                    }
                }
            }
            a + 1 === c && c - (r + 1) > 0 && t.push(N(e.str.substring(r + 1)));
        }
        return i ? t : n;
    }
    function N(e) {
        if ('"' === e[0]) return e.substring(1, e.length - 1);
        if ("NIL" === e) return null;
        if (/^\d+$/.test(e)) {
            var t = parseInt(e, 10);
            return t.toString() === e ? t : e;
        }
        return e;
    }
    function x(e, t, n) {
        for (var s in t) n && s === n ? x(e[s], t[s]) : e[s] = t[s];
        return e;
    }
    function T(e, t) {
        var n = new Buffer(e.length + t.length);
        if (e.copy(n, 0, 0), Buffer.isBuffer(t)) t.copy(n, e.length, 0); else if (Array.isArray(t)) for (var s = e.length, r = t.length; r > s; s++) n[s] = t[s];
        return n;
    }
    function E(e, t) {
        for (var n = e.length - 1, s = t || 0; n > s; s++) if (13 === e[s] && 10 === e[s + 1]) return s;
        return -1;
    }
    var I = e("util"), A = e("rdcommon/log"), C = e("net"), D = e("tls"), k = e("events").EventEmitter, M = e("./mailapi/syncbase"), O = e("mailparser/mailparser"), L = function() {}, F = "\r\n", R = Buffer(F), B = {
        NOCONNECT: 0,
        NOGREET: 1,
        NOAUTH: 2,
        AUTH: 3,
        BOXSELECTING: 4,
        BOXSELECTED: 5
    }, P = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ], q = /^\* (\d+) FETCH/, H = / \{(\d+)}$/, U = /BODY\[(.*)\](?:\<\d+\>)?/, G = /UID (\d+)/, z = /^( ?\d|\d{2})-(.{3})-(\d{4}) (\d{2}):(\d{2}):(\d{2}) ([+-]\d{4})$/, j = 36e5, W = 6e4;
    const X = ("}".charCodeAt(0), "*".charCodeAt(0)), $ = ")".charCodeAt(0);
    var Q = window.setTimeout.bind(window), Y = window.clearTimeout.bind(window), V = window.setTimeout.bind(window), J = window.clearTimeout.bind(window);
    t.TEST_useTimeoutFuncs = function(e, t) {
        Q = e, Y = t;
    }, t.TEST_useStaleTimeoutFuncs = function(e, t) {
        V = e, J = t;
    };
    var K = new Uint8Array(2e3);
    const Z = /&([^-]*)-/g, et = /,/g;
    t.decodeModifiedUtf7 = r, t.parseImapDateTime = i;
    var tt = 1, nt = 2, st = 3, rt = 4;
    I.inherits(a, k), t.ImapConnection = a, a.prototype.hasCapability = function(e) {
        return -1 !== this.capabilities.indexOf(e);
    }, a.prototype.blacklistCapability = function(e) {
        var t = this.blacklistedCapabilities;
        if (e = w(e), -1 === t.indexOf(e)) {
            t.push(e);
            var n = this.capabilities.indexOf(e);
            -1 !== n && this.capabilities.splice(n, 1);
        }
    }, a.prototype._findAndShiftRequestByPrefix = function(e) {
        var t = this._state.requests.length;
        e = e.trim();
        var n, s;
        for (s = 0; t > s; s++) if (n = this._state.requests[s], n && n.prefix && 0 === n.prefix.lastIndexOf(e, 0)) return this._state.requests.splice(s, 1)[0];
        if (this._state.requests.length > 1) {
            var r = [];
            for (s = 0; t > s; s++) n = this._state.requests[s], r.push(n.prefix);
        }
        return this._state.requests.shift();
    }, a.prototype._findFetchRequest = function(e, t) {
        for (var n, s = this._state.requests, r = s.length, i = 0; r > i; i++) if (n = s[i].fetchParams, 
        n && n.uids[e] && n.bodyPart === t) return s[i];
    }, a.prototype.connect = function(e) {
        function t() {
            d._state.staleTimeout && (J(d._state.staleTimeout), d._state.staleTimeout = null), 
            d._state.staleTimeout = V(function() {
                d._state.status >= B.AUTH && (console.log("Killing stale connection."), d._state.conn.end(), 
                d._reset(), this._LOG && this._LOG.closed("forcibly killed stale connection"), d.emit("close"));
            }, M.STALE_CONNECTION_TIMEOUT_MS);
        }
        function n(e) {
            var t = null;
            if ("*" === e[0]) {
                if (d._state.status === B.NOGREET) {
                    if ("PREAUTH" === e[1]) return d._state.status = B.AUTH, 0 === d._state.numCapRecvs && (d._state.numCapRecvs = 1), 
                    void 0;
                    if ("NO" === e[1] || "BAD" === e[1] || "BYE" === e[1]) return d._LOG && "BAD" === e[1] && d._LOG.bad(e[2]), 
                    d._state.conn.end(), void 0;
                    if (e[2].startsWith("[CAPABILITY ") && (d._state.numCapRecvs = 1, d.capabilities = e[2].substring(12, e[2].lastIndexOf("]")).split(" ").map(w)), 
                    d._state.status = B.NOAUTH, d._state.postGreetingCallback) {
                        var n = d._state.postGreetingCallback;
                        d._state.postGreetingCallback = null, n();
                    }
                    return;
                }
                if (d._state.status === B.NOAUTH && "CAPABILITY" !== e[1] && "ALERT" !== e[1]) return;
                switch (e[1]) {
                  case "CAPABILITY":
                    d._state.numCapRecvs < 2 && d._state.numCapRecvs++, d.capabilities = e[2].split(" ").map(w);
                    break;

                  case "ENABLED":
                    d.enabledCapabilities = d.enabledCapabilities.concat(e[2].split(" ")), d.enabledCapabilities.sort();
                    break;

                  case "FLAGS":
                    d._state.status === B.BOXSELECTING && (d._state.box._flags = e[2].substr(1, e[2].length - 2).split(" ").map(function(e) {
                        return e.substr(1);
                    }));
                    break;

                  case "OK":
                    if (i = /^\[ALERT\] (.*)$/i.exec(e[2])) d.emit("alert", i[1]); else if (d._state.status === B.BOXSELECTING) {
                        var i;
                        if (i = /^\[UIDVALIDITY (\d+)\]/i.exec(e[2])) d._state.box.validity = i[1]; else if (i = /^\[UIDNEXT (\d+)\]/i.exec(e[2])) d._state.box._uidnext = parseInt(i[1]); else if (i = /^\[PERMANENTFLAGS \((.*)\)\]/i.exec(e[2])) {
                            d._state.box.permFlags = i[1].split(" ");
                            var o;
                            (o = d._state.box.permFlags.indexOf("\\*")) > -1 && (d._state.box._newKeywords = !0, 
                            d._state.box.permFlags.splice(o, 1)), d._state.box.keywords = d._state.box.permFlags.filter(function(e) {
                                return "\\" !== e[0];
                            });
                            for (var a = 0; a < d._state.box.keywords.length; a++) d._state.box.permFlags.splice(d._state.box.permFlags.indexOf(d._state.box.keywords[a]), 1);
                            d._state.box.permFlags = d._state.box.permFlags.map(function(e) {
                                return e.substr(1);
                            });
                        } else (i = /^\[HIGHESTMODSEQ (\d+)\]/i.exec(e[2])) ? d._state.box.highestModSeq = i[1] : (i = /^\[NOMODSEQ\]/i.exec(e[2])) && (d._state.box.highestModSeq = null);
                    }
                    break;

                  case "NAMESPACE":
                    p(e[2], d.namespaces);
                    break;

                  case "SEARCH":
                    d._state.requests[0].args.push(void 0 === e[2] || 0 === e[2].length ? [] : e[2].trim().split(" ").map(s));
                    break;

                  case "LIST":
                  case "XLIST":
                    var i;
                    if (null === d.delim && (i = /^\(\\No[sS]elect(?:[^)]*)\) (.+?) .*$/.exec(e[2]))) d.delim = "NIL" === i[1] ? !1 : i[1].substring(1, i[1].length - 1); else if (null !== d.delim) {
                        0 === d._state.requests[0].args.length && d._state.requests[0].args.push({}), i = /^\((.*)\) (.+?) "?([^"]+)"?$/.exec(e[2]);
                        var l = {
                            displayName: null,
                            attribs: i[1].split(" ").map(function(e) {
                                return e.substr(1).toUpperCase();
                            }),
                            delim: "NIL" === i[2] ? !1 : i[2].substring(1, i[2].length - 1),
                            children: null,
                            parent: null
                        }, u = i[3], f = d._state.requests[0].args[0];
                        if ('"' === u[0] && '"' === u[u.length - 1] && (u = u.substring(1, u.length - 1)), 
                        l.delim) {
                            var g = u.split(l.delim).filter(y), _ = null;
                            u = g.pop();
                            for (var a = 0, b = g.length; b > a; a++) f[g[a]] || (f[g[a]] = {
                                delim: l.delim
                            }), f[g[a]].children || (f[g[a]].children = {}), _ = f[g[a]], f = f[g[a]].children;
                            l.parent = _;
                        }
                        l.displayName = r(u), f[u] && (l.children = f[u].children), f[u] = l;
                    }
                    break;

                  case "VANISHED":
                    var v = !1;
                    0 === e[2].lastIndexOf("(EARLIER) ", 0) && (v = !0, e[2] = e[2].substring(10)), 
                    d.emit("vanished", h(e[2]), v);
                    break;

                  default:
                    if (/^\d+$/.test(e[1])) {
                        var S = d._state.requests[0] && d._state.requests[0].command.indexOf("NOOP") > -1 || d._state.isIdle && d._state.ext.idle.state === st;
                        switch (e[2]) {
                          case "EXISTS":
                            var N = d._state.box.messages.total, x = parseInt(e[1]);
                            d._state.box.messages.total = x, d._state.status !== B.BOXSELECTING && x > N && (d._state.box.messages.new = x - N, 
                            d.emit("mail", d._state.box.messages.new));
                            break;

                          case "RECENT":
                            d._state.box.messages.new = parseInt(e[1]);
                            break;

                          case "EXPUNGE":
                            d._state.box.messages.total > 0 && d._state.box.messages.total--, S && d.emit("deleted", parseInt(e[1], 10));
                            break;

                          default:
                            if (/^FETCH/.test(e[2])) {
                                var T = new c();
                                m(e[2].substring(e[2].indexOf("(") + 1, e[2].lastIndexOf(")")), "", T), T.seqno = parseInt(e[1], 10), 
                                d._state.requests.length && d._state.requests[0].command.indexOf("FETCH") > -1 ? (t = d._state.requests[0], 
                                t._fetcher.emit("message", T), T.emit("end")) : S && d.emit("msgupdate", T);
                            }
                        }
                    }
                }
            } else if ("A" === e[0][0] || "+" === e[0]) {
                if ("+" === e[0] && d._state.ext.idle.state === nt) return d._state.ext.idle.state = st, 
                process.nextTick(function() {
                    d._send();
                }), void 0;
                var E = !1;
                if (d._state.status === B.BOXSELECTING && ("OK" === e[1] ? (E = !0, d._state.status = B.BOXSELECTED) : (d._state.status = B.AUTH, 
                d._resetBox())), 0 === d._state.requests.length) return;
                var I = "+" !== e[0] ? d._findAndShiftRequestByPrefix(e[0]) : d._state.requests.shift();
                if (I.command.indexOf("RENAME") > -1 && (d._state.box.name = d._state.box._newName, 
                delete d._state.box._newName, E = !0), "function" == typeof I.callback) {
                    var A = null, C = I.args, D = I.command;
                    if ("+" === e[0]) {
                        if (d._state.requests.unshift(I), 0 === D.indexOf("APPEND")) return I.callback();
                        A = new Error("Unexpected continuation"), A.type = "continuation", A.serverResponse = "", 
                        A.request = D;
                    } else "OK" !== e[1] ? (A = new Error("Error while executing request: " + e[2]), 
                    A.type = e[1], A.serverResponse = e[2], A.request = D) : d._state.status === B.BOXSELECTED && (E ? C.unshift(d._state.box) : 0 !== D.indexOf("UID FETCH") && 0 !== D.indexOf("UID SEARCH") || 0 !== C.length || C.unshift([]));
                    C.unshift(A), I.callback.apply(I, C);
                }
                if (!I) {
                    if (d._state.status === B.NOCONNECT) return;
                    return console.error("IMAP: Somehow no recentReq for data:", e), void 0;
                }
                I.active && d._state.activeRequests--;
                var k = I.command;
                d._LOG && d._LOG.cmd_end(I.prefix, k, /^LOGIN$/.test(k) ? "***BLEEPING OUT LOGON***" : I.cmddata), 
                (0 !== d._state.requests.length || "LOGOUT" === k) && process.nextTick(function() {
                    d._send();
                }), d._state.isIdle = !0;
            } else "IDLE" === e[0] ? (d._state.requests.length && process.nextTick(function() {
                d._send();
            }), d._state.isIdle = !1, d._state.ext.idle.state = tt, d._state.ext.idle.timeWaited = 0) : d._LOG && d._LOG.unknownResponse(e[0], e[1], e[2]);
        }
        function i(e) {
            return d._state.curData = d._state.curData ? T(d._state.curData, e) : e, d._state.curData;
        }
        function o(e) {
            d._state.curData = e ? new Buffer(e) : null, d._state.curDataMinLength = 0;
        }
        function a(e) {
            if (0 !== e.length) {
                var t, s, r = null;
                if (null === d._state.curExpected) {
                    var a = 0;
                    if (d._state.curDataMinLength) {
                        if (d._state.curData.length + e.length < d._state.curDataMinLength) return i(e), 
                        void 0;
                        a = d._state.curDataMinLength - d._state.curData.length, d._state.curDataMinLength = 0;
                    }
                    if (-1 === (r = E(e, a))) return i(e), void 0;
                    e.length >= r + 2 && d._unprocessed.unshift(e.slice(r + 2)), e = e.slice(0, r), 
                    e = i(e);
                }
                if (s = s || d._state.requests[0], s && null !== d._state.curExpected) {
                    var l = e;
                    if (d._state.curXferred += e.length, d._state.curXferred > d._state.curExpected) {
                        var u = e.length - (d._state.curXferred - d._state.curExpected), h = e.slice(u);
                        l = u > 0 ? e.slice(0, u) : void 0, h.length && d._unprocessed.unshift(h), s._done = 1, 
                        d._state.curExpected = null;
                    }
                    return l && l.length && (d._LOG && d._LOG.data(l.length, l), "headers" === s._msgtype ? (l.copy(d._state.curData, s.curPos, 0), 
                    s.curPos += l.length) : s._msg.emit("data", l)), s._done && ("headers" === s._msgtype && (s._headers = d._state.curData.toString("ascii")), 
                    o()), void 0;
                }
                if (s && 1 === s._done) {
                    var p;
                    return e[e.length - 1] === $ && (p = e.toString("ascii", 0, e.length - 1).trim(), 
                    p.length && (s._desc += " " + p), m(s._desc, s._headers, s._msg), s._done = !1, 
                    d._state.curXferred = 0, d._state.curExpected = null, o(), s._msg.emit("end", s._msg)), 
                    void 0;
                }
                if (e[0] === X && (f = e.toString("ascii")) && q.test(f) && (t = H.exec(f))) {
                    var f, g = parseInt(t[1], 10), y = U.exec(e);
                    if (!y) return e = i(R), d._state.curDataMinLength = e.length + g, void 0;
                    d._state.curExpected = g;
                    var b = f.substring(f.indexOf("(") + 1).trim(), v = y[1], w = G.exec(b)[1];
                    s = d._findFetchRequest(w, v) || d._state.requests[0];
                    var S = new c();
                    return d._state.requests[0] !== s && (d._state.requests.splice(d._state.requests.indexOf(s), 1), 
                    d._state.requests.unshift(s)), S.seqno = parseInt(t[1], 10), s._desc = b, s._msg = S, 
                    S.size = d._state.curExpected, s._fetcher.emit("message", S), s._msgtype = 0 === v.indexOf("HEADER") ? "headers" : "body", 
                    "headers" === s._msgtype && (o(d._state.curExpected), s.curPos = 0), d._LOG && d._LOG.data(f.length, f), 
                    void 0;
                }
                if (o(), e.length) {
                    var N = e.toString("ascii");
                    d._LOG && d._LOG.data(N.length, N), n(_(N, " ", 3));
                }
            }
        }
        var d = this, l = function() {
            var t = function() {
                var t = !1, n = function(s) {
                    return s ? (e(s), void 0) : !t && d.capabilities.indexOf("NAMESPACE") > -1 ? (t = !0, 
                    d._send("NAMESPACE", null, n), void 0) : (d._send('LIST "" ""', null, e), void 0);
                };
                d._login(n);
            };
            0 === d._state.numCapRecvs ? d._send("CAPABILITY", null, t) : t();
        };
        e = e || L, this._reset(), this._LOG && this._LOG.connect(this._options.host, this._options.port), 
        this._state.conn = ("ssl" === this._options.crypto || this._options.crypto === !0 ? D : C).connect(this._options.port, this._options.host), 
        this._state.tmrConn = Q(this._fnTmrConn.bind(this, e), this._options.connTimeout), 
        this._state.conn.on("connect", function() {
            d._LOG && d._LOG.connected(), d._state.tmrConn && (Y(d._state.tmrConn), d._state.tmrConn = null), 
            d._state.status === B.NOCONNECT && (d._state.status = B.NOGREET);
        }), this._state.postGreetingCallback = function() {
            return "starttls" === d._options.crypto ? (d._state.numCapRecvs = 0, d._send("STARTTLS", null, function(t) {
                if (t) {
                    var n = new Error("Server does not support STARTTLS");
                    n.type = "bad-security", e(n);
                } else d._state.conn.upgradeToSecure(), l();
            }), void 0) : (l(), void 0);
        }, this._state.conn.on("data", function(e) {
            try {
                for (t(), d._unprocessed.push(e); d._unprocessed.length; ) a(d._unprocessed.shift());
            } catch (n) {
                throw console.error("Explosion while processing data", n), "stack" in n && console.error("Stack:", n.stack), 
                n;
            }
        }), this._state.conn.on("close", function() {
            d._reset(), this._LOG && this._LOG.closed("connection close"), d.emit("close");
        }), this._state.conn.on("error", function(t) {
            try {
                var n;
                if (t && "object" == typeof t && /^Security/.test(t.name) && (t = new Error("SSL error"), 
                n = t.type = "bad-security"), d._state.tmrConn && (Y(d._state.tmrConn), d._state.tmrConn = null), 
                d._state.status === B.NOCONNECT) {
                    var s = new Error("Unable to connect. Reason: " + t);
                    s.type = n || "unresponsive-server", s.serverResponse = "", e(s);
                }
                d.emit("error", t), this._LOG && this._LOG.connError(t);
            } catch (r) {
                throw console.error("Error in imap onerror:", r), r;
            }
        });
    }, a.prototype.die = function() {
        this._state.conn && (this._state.conn.removeAllListeners(), this._state.conn.end()), 
        this._reset(), this._LOG && this._LOG.__die();
    }, a.prototype.isAuthenticated = function() {
        return this._state.status >= B.AUTH;
    }, a.prototype.logout = function(e) {
        if (!(this._state.status >= B.NOAUTH)) throw new Error("Not connected");
        this._send("LOGOUT", null, e);
    }, a.prototype.enable = function(e, t) {
        if (this._state.status < B.AUTH) throw new Error("Not connected or authenticated");
        this._send("ENABLE " + e.join(" "), t || L);
    }, a.prototype.openBox = function(e, t, n) {
        function s() {
            r._state.status = B.BOXSELECTING, r._state.box.name = e;
        }
        if (this._state.status < B.AUTH) throw new Error("Not connected or authenticated");
        this._state.status === B.BOXSELECTED && this._resetBox(), void 0 === n && (n = void 0 === t ? L : t, 
        t = !1);
        var r = this;
        this._send(t ? "EXAMINE" : "SELECT", ' "' + v(e) + '"', n, s);
    }, a.prototype.qresyncBox = function(e, t, n, s, r, i) {
        function o() {
            a._state.status = B.BOXSELECTING, a._state.box.name = e;
        }
        if (this._state.status < B.AUTH) throw new Error("Not connected or authenticated");
        if (-1 === this.enabledCapabilities.indexOf("QRESYNC")) throw new Error("QRESYNC is not enabled");
        this._state.status === B.BOXSELECTED && this._resetBox(), void 0 === i && (i = void 0 === t ? L : t, 
        t = !1);
        var a = this;
        this._send((t ? "EXAMINE" : "SELECT") + ' "' + v(e) + '"' + " (QRESYNC (" + n + " " + s + (r ? " " + r : "") + "))", i, o);
    }, a.prototype.closeBox = function(e) {
        var t = this;
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        this._send("CLOSE", null, function(n) {
            n || (t._state.status = B.AUTH, t._resetBox()), e(n);
        });
    }, a.prototype.removeDeleted = function(e) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        e = arguments[arguments.length - 1], this._send("EXPUNGE", null, e);
    }, a.prototype.getBoxes = function(e, t, n) {
        n = arguments[arguments.length - 1], arguments.length < 2 && (e = ""), arguments.length < 3 && (t = "*");
        var s, r = ' "' + v(e) + '" "' + v(t) + '"';
        -1 !== this.capabilities.indexOf("SPECIAL-USE") ? (s = "LIST", r += " RETURN (SPECIAL-USE)") : s = -1 !== this.capabilities.indexOf("XLIST") ? "XLIST" : "LIST", 
        this._send(s, r, n);
    }, a.prototype.addBox = function(e, t) {
        if (t = arguments[arguments.length - 1], "string" != typeof e || 0 === e.length) throw new Error("Mailbox name must be a string describing the full path of a new mailbox to be created");
        this._send("CREATE", ' "' + v(e) + '"', t);
    }, a.prototype.delBox = function(e, t) {
        if (t = arguments[arguments.length - 1], "string" != typeof e || 0 === e.length) throw new Error("Mailbox name must be a string describing the full path of an existing mailbox to be deleted");
        this._send("DELETE", ' "' + v(e) + '"', t);
    }, a.prototype.noop = function(e) {
        this._send("NOOP", "", e);
    }, a.prototype.renameBox = function(e, t, n) {
        if (n = arguments[arguments.length - 1], "string" != typeof e || 0 === e.length) throw new Error("Old mailbox name must be a string describing the full path of an existing mailbox to be renamed");
        if ("string" != typeof t || 0 === t.length) throw new Error("New mailbox name must be a string describing the full path of a new mailbox to be renamed to");
        this._state.status === B.BOXSELECTED && e === this._state.box.name && "INBOX" !== e && (this._state.box._newName = e), 
        this._send("RENAME", ' "' + v(e) + '" "' + v(t) + '"', n);
    }, a.prototype.search = function(e, t) {
        this._search("UID ", e, t);
    }, a.prototype._search = function(e, t, n) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        if (!Array.isArray(t)) throw new Error("Expected array for search options");
        this._send(e + "SEARCH", l(t, this.capabilities), n);
    }, a.prototype.append = function(e, t, n) {
        if ("function" == typeof t && (n = t, t = {}), t = t || {}, !("mailbox" in t)) {
            if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox specified or currently selected");
            t.mailbox = this._state.box.name;
        }
        var s = ' "' + v(t.mailbox) + '"';
        if ("flags" in t && (Array.isArray(t.flags) || (t.flags = Array(t.flags)), t.flags.length && (s += " (\\" + t.flags.join(" \\") + ")")), 
        "date" in t) {
            if (!(t.date instanceof Date)) throw new Error("Expected null or Date object for date");
            s += ' "' + o(t.date) + '"';
        }
        s += " {", s += e instanceof Blob ? e.size : Buffer.isBuffer(e) ? e.length : Buffer.byteLength(e), 
        s += "}";
        var r = this, i = 1;
        this._send("APPEND", s, function(t) {
            return t || 2 === i++ ? n(t) : ("string" == typeof e ? r._state.conn.write(Buffer(e + F)) : (r._state.conn.write(e), 
            r._state.conn.write(R)), this._LOG && this._LOG.sendData(e.length, e), void 0);
        });
    }, a.prototype.multiappend = function(e, t) {
        function n(e) {
            if ("flags" in e && (Array.isArray(e.flags) || (e.flags = Array(e.flags)), e.flags.length && (s += " (\\" + e.flags.join(" \\") + ")")), 
            "date" in e) {
                if (!(e.date instanceof Date)) throw new Error("Expected null or Date object for date");
                s += ' "' + o(e.date) + '"';
            }
            s += " {", s += d instanceof Blob ? d.size : Buffer.isBuffer(d) ? d.length : Buffer.byteLength(d), 
            s += "}";
        }
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox specified or currently selected");
        var s = ' "' + v(this._state.box.name) + '"', r = this, i = 1, a = !1, c = e[0], d = c.messageText;
        n(c), this._send("APPEND", s, function(o) {
            return o || a ? t(o, i - 1) : (r._state.conn.write("string" == typeof d ? Buffer(d) : d), 
            r._LOG && r._LOG.sendData(d.length, d), i < e.length ? (s = "", c = e[i++], d = c.messageText, 
            n(c), s += F, r._state.conn.write(Buffer(s)), r._LOG && r._LOG.sendData(s.length, s)) : (r._state.conn.write(R), 
            r._LOG && r._LOG.sendData(2, F), a = !0), void 0);
        });
    }, a.prototype.fetch = function(e, t) {
        return this._fetch("UID ", e, t);
    }, a.prototype._fetch = function(e, t, n) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        if (void 0 === t || null === t || Array.isArray(t) && 0 === t.length) throw new Error("Nothing to fetch");
        Array.isArray(t) || (t = [ t ]), u(t);
        var s, r = {
            markSeen: !1,
            request: {
                struct: !0,
                headers: !0,
                body: !1
            }
        }, i = "", o = this;
        if ("object" != typeof n && (n = {}), x(r, n, "request"), Array.isArray(r.request.headers)) s = "HEADER.FIELDS (" + r.request.headers.join(" ").toUpperCase() + ")"; else {
            if (Array.isArray(r.request.body)) {
                var a;
                if (2 !== r.request.body.length) throw new Error("Expected Array of length 2 for body byte range");
                if ("string" != typeof r.request.body[1] || !(a = /^([\d]+)\-([\d]+)$/.exec(r.request.body[1])) || parseInt(a[1]) >= parseInt(a[2])) throw new Error("Invalid body byte range format");
                i = "<" + parseInt(a[1]) + "." + parseInt(a[2]) + ">", r.request.body = r.request.body[0];
            }
            if ("boolean" == typeof r.request.headers && r.request.headers === !0) s = "HEADER"; else if ("boolean" == typeof r.request.body && r.request.body === !0) s = "TEXT"; else if ("string" == typeof r.request.body) if ("FULL" === r.request.body.toUpperCase()) s = ""; else {
                if (!/^([\d]+[\.]{0,1})*[\d]+$/.test(r.request.body)) throw new Error("Invalid body partID format");
                s = r.request.body;
            }
        }
        var c;
        if (1 === t.length && r.request.body) {
            var l = {};
            t.forEach(function(e) {
                l[e] = s;
            }), c = {
                uids: l,
                bodyPart: r.request.body
            };
        }
        var h = "";
        this.capabilities.indexOf("X-GM-EXT-1") > -1 ? h = "X-GM-THRID X-GM-MSGID X-GM-LABELS " : this.enabledCapabilities.indexOf("QRESYNC") > -1 && (h = "MODSEQ ");
        var p = " " + t.join(",") + " (" + h + "UID FLAGS INTERNALDATE" + (r.request.struct ? " BODYSTRUCTURE" : "") + ("string" == typeof s ? " BODY" + (r.markSeen ? "" : ".PEEK") + "[" + s + "]" + i : "") + ")", m = function(e) {
            var t = this._fetcher;
            e && t ? t.emit("error", e) : e && !t ? o.emit("error", e) : t && t.emit("end");
        };
        this._send(e + "FETCH", p, m, null, null, c);
        var f = new d();
        return this._state.requests[this._state.requests.length - 1]._fetcher = f, f;
    }, a.prototype.addFlags = function(e, t, n) {
        this._store("UID ", e, t, !0, n);
    }, a.prototype.delFlags = function(e, t, n) {
        this._store("UID ", e, t, !1, n);
    }, a.prototype.addKeywords = function(e, t, n) {
        return this._addKeywords("UID ", e, t, n);
    }, a.prototype._addKeywords = function(e, t, n, s) {
        if (!this._state.box._newKeywords) throw new Error("This mailbox does not allow new keywords to be added");
        this._store(e, t, n, !0, s);
    }, a.prototype.delKeywords = function(e, t, n) {
        this._store("UID ", e, t, !1, n);
    }, a.prototype.copy = function(e, t, n) {
        return this._copy("UID ", e, t, n);
    }, a.prototype._copy = function(e, t, n, s) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        Array.isArray(t) || (t = [ t ]), u(t), this._send(e + "COPY", " " + t.join(",") + ' "' + v(n) + '"', s);
    }, a.prototype.__defineGetter__("seq", function() {
        var e = this;
        return {
            move: function(t, n, s) {
                return e._move("", t, n, s);
            },
            copy: function(t, n, s) {
                return e._copy("", t, n, s);
            },
            delKeywords: function(t, n, s) {
                e._store("", t, n, !1, s);
            },
            addKeywords: function(t, n, s) {
                return e._addKeywords("", t, n, s);
            },
            delFlags: function(t, n, s) {
                e._store("", t, n, !1, s);
            },
            addFlags: function(t, n, s) {
                e._store("", t, n, !0, s);
            },
            fetch: function(t, n) {
                return e._fetch("", t, n);
            },
            search: function(t, n) {
                e._search("", t, n);
            }
        };
    }), a.prototype._fnTmrConn = function(e) {
        var t = new Error("Connection timed out");
        t.type = "timeout", e(t), this._state.conn.end();
    }, a.prototype._store = function(e, t, n, s, r) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        if (void 0 === t) throw new Error("The message ID(s) must be specified");
        if (Array.isArray(t) || (t = [ t ]), u(t), !Array.isArray(n) && "string" != typeof n || Array.isArray(n) && 0 === n.length) throw new Error((isKeywords ? "Keywords" : "Flags") + " argument must be a string or a non-empty Array");
        Array.isArray(n) || (n = [ n ]), n = n.join(" "), r = arguments[arguments.length - 1], 
        this._send(e + "STORE", " " + t.join(",") + " " + (s ? "+" : "-") + "FLAGS.SILENT (" + n + ")", r);
    }, a.prototype._login = function(e) {
        var t = this, n = function(n) {
            return n || (t._state.status = B.AUTH, 2 === t._state.numCapRecvs) ? (e(n), void 0) : (t._send("CAPABILITY", null, e), 
            void 0);
        };
        if (this._state.status === B.NOAUTH) {
            var s;
            if (this.capabilities.indexOf("LOGINDISABLED") > -1) return s = new Error("Logging in is disabled on this server"), 
            s.type = "server-maintenance", s.serverResponse = "LOGINDISABLED", e(s), void 0;
            if (-1 !== this.capabilities.indexOf("AUTH=XOAUTH") && "xoauth" in this._options) this._send("AUTHENTICATE XOAUTH " + v(this._options.xoauth), n); else if (this.capabilities.indexOf("AUTH=XOAUTH2") && "xoauth2" in this._options) this._send("AUTHENTICATE XOAUTH2 " + v(this._options.xoauth2), n); else {
                if (void 0 === this._options.username || void 0 === this._options.password) return s = new Error("Unsupported authentication mechanism(s) detected. Unable to login."), 
                s.type = "sucky-imap-server", s.serverResponse = "CAPABILITIES: " + this.capabilities.join(" "), 
                e(s), void 0;
                this._send("LOGIN", ' "' + v(this._options.username) + '" "' + v(this._options.password) + '"', n);
            }
        }
    }, a.prototype._reset = function() {
        this._state.tmrConn && Y(this._state.tmrConn), this._state.staleTimeout && (J(this._state.staleTimeout), 
        this._state.staleTimeout = null), this._state.status = B.NOCONNECT, this._state.numCapRecvs = 0, 
        this._state.requests = [], this._state.unsentRequests = [], this._state.postGreetingCallback = null, 
        this._state.isIdle = !0, this._state.ext.idle.state = tt, this._state.ext.idle.timeWaited = 0, 
        this.namespaces = {
            personal: [],
            other: [],
            shared: []
        }, this.delim = null, this.capabilities = [], this._resetBox();
    }, a.prototype._resetBox = function() {
        this._state.box._uidnext = 0, this._state.box.validity = 0, this._state.box.highestModSeq = null, 
        this._state.box._flags = [], this._state.box._newKeywords = !1, this._state.box.permFlags = [], 
        this._state.box.keywords = [], this._state.box.name = null, this._state.box.messages.total = 0, 
        this._state.box.messages.new = 0;
    }, a.prototype._send = function(e, t, n, s, r, i) {
        var o;
        if (void 0 !== e && (o = {
            prefix: null,
            command: e,
            cmddata: t,
            callback: n,
            dispatch: s,
            args: [],
            fetchParams: i,
            active: !1
        }, r || (this._state.requests.push(o), this._state.unsentRequests.push(o))), this._state.ext.idle.state === nt || this._state.ext.idle.state === rt) return o;
        if (r) return this._writeRequest(o), o;
        var a = this._state.unsentRequests;
        if (0 === a.length) return null;
        if (0 === this._state.activeRequests && this._writeRequest(a.shift(), !0), this._state.lastRequest && this._state.lastRequest.fetchParams) for (;a.length && a[0].fetchParams; ) this._writeRequest(a.shift(), !0);
        return o;
    }, a.prototype._writeRequest = function(e, t) {
        var n = "", s = e.command, r = e.cmddata, i = e.dispatch;
        this._state.ext.idle.state === st && "DONE" !== s ? this._send("DONE", null, void 0, void 0, !0) : "IDLE" === s ? (n = "IDLE ", 
        this._state.ext.idle.state = nt) : "DONE" === s && (this._state.ext.idle.state = rt), 
        "IDLE" !== s && "DONE" !== s && (n = "A" + ++this._state.curId + " ", e.prefix = n, 
        this._state.lastRequest = e), i && i();
        var o, a = 0;
        for (o = 0; o < n.length; o++) K[a++] = n.charCodeAt(o);
        for (o = 0; o < s.length; o++) K[a++] = s.charCodeAt(o);
        if (r) if (r.length < K.length - 2) if ("string" == typeof r) for (o = 0; o < r.length; o++) K[a++] = r.charCodeAt(o); else K.set(r, a), 
        a += r.length; else this._state.conn.write(K.subarray(0, a)), "string" == typeof r ? this._state.conn.write(Buffer(r)) : this._state.conn.write(r), 
        this._state.conn.write(R), a = 0;
        a && (K[a++] = 13, K[a++] = 10, this._state.conn.write(K.subarray(0, a))), t && (e.active = !0, 
        this._state.activeRequests++), this._LOG && this._LOG.cmd_begin(n, s, /^LOGIN$/.test(s) ? "***BLEEPING OUT LOGON***" : r);
    }, I.inherits(c, k), I.inherits(d, k);
    const it = /^\\Recent$/i;
    t.parseExpr = S;
    var ot = t.LOGFAB = A.register(n, {
        ImapProtoConn: {
            type: A.CONNECTION,
            subtype: A.CLIENNT,
            events: {
                created: {},
                connect: {},
                connected: {},
                closed: {
                    reason: !1
                },
                sendData: {
                    length: !1
                },
                bypassCmd: {
                    prefix: !1,
                    cmd: !1
                },
                data: {
                    length: !1
                }
            },
            TEST_ONLY_events: {
                connect: {
                    host: !1,
                    port: !1
                },
                sendData: {
                    data: !1
                },
                data: {
                    data: A.TOSTRING
                }
            },
            errors: {
                connError: {
                    err: A.EXCEPTION
                },
                bad: {
                    msg: !1
                },
                unknownResponse: {
                    d0: !1,
                    d1: !1,
                    d2: !1
                }
            },
            asyncJobs: {
                cmd: {
                    prefix: !1,
                    cmd: !1
                }
            },
            TEST_ONLY_asyncJobs: {
                cmd: {
                    data: !1
                }
            }
        }
    });
}), define("mailapi/imap/probe", [ "imap", "exports" ], function(e, t) {
    function n(n, s, r) {
        var i = {
            host: s.hostname,
            port: s.port,
            crypto: s.crypto,
            username: n.username,
            password: n.password,
            connTimeout: t.CONNECT_TIMEOUT_MS
        };
        r && (i._logParent = r), console.log("PROBE:IMAP attempting to connect to", s.hostname), 
        this._conn = new e.ImapConnection(i), this._conn.connect(this.onLoggedIn.bind(this)), 
        this._conn.on("error", this.onError.bind(this)), this.tzOffset = null, this.blacklistedCapabilities = null, 
        this.onresult = null, this.error = null, this.errorDetails = {
            server: s.hostname
        };
    }
    t.CONNECT_TIMEOUT_MS = 3e4, t.ImapProber = n, n.prototype = {
        onLoggedIn: function(e) {
            return e ? (this.onError(e), void 0) : (o(this._conn, this.onGotTZOffset.bind(this)), 
            void 0);
        },
        onGotTZOffset: function(e, n) {
            return e ? (this.onError(e), void 0) : (console.log("PROBE:IMAP happy, TZ offset:", n / 36e5), 
            this.tzOffset = n, t.checkServerProblems(this._conn, this.onServerProblemsChecked.bind(this)), 
            void 0);
        },
        onServerProblemsChecked: function(e, t) {
            if (e) return this.onError(e), void 0;
            this.blacklistedCapabilities = t;
            var n = this._conn;
            this._conn = null, this.onresult && (this.onresult(this.error, n, this.tzOffset, t), 
            this.onresult = !1);
        },
        onError: function(e) {
            if (this.onresult) {
                console.warn("PROBE:IMAP sad.", e && e.name, "|", e && e.type, "|", e && e.message, "|", e && e.serverResponse);
                var t = s(e);
                this.error = t.name;
                try {
                    this._conn.die();
                } catch (n) {}
                this._conn = null, this.onresult(this.error, null, this.errorDetails), this.onresult = !1;
            }
        }
    };
    var s = t.normalizeError = function(e) {
        var t, n = !1, s = !0, r = !1;
        switch (e.type) {
          case "NO":
          case "no":
            n = !0, e.serverResponse ? (r = !0, s = !1, t = -1 !== e.serverResponse.indexOf("[ALERT] Application-specific password required") ? "needs-app-pass" : -1 !== e.serverResponse.indexOf("/support.google.com/mail/accounts/bin/answer.py?answer=78754") ? "mitigate-gmail-sumo" : -1 !== e.serverResponse.indexOf("[ALERT] Your account is not enabled for IMAP use.") || -1 !== e.serverResponse.indexOf("[ALERT] IMAP access is disabled for your domain.") ? "imap-disabled" : "bad-user-or-pass") : (t = "unknown", 
            r = !1);
            break;

          case "BAD":
          case "bad":
            t = "bad-user-or-pass", r = !0, s = !1;
            break;

          case "server-maintenance":
            t = e.type, n = !0;
            break;

          case "bad-security":
            t = e.type, n = !0, s = !1;
            break;

          case "unresponsive-server":
          case "timeout":
            t = "unresponsive-server";
            break;

          default:
            t = "unknown";
        }
        return {
            name: t,
            reachable: n,
            retry: s,
            reportProblem: r
        };
    }, r = -252e5, i = t._extractTZFromHeaders = function(e) {
        for (var t = 0; t < e.length; t++) {
            var n = e[t];
            if ("received" === n.key) {
                var s = / ([+-]\d{4})/.exec(n.value);
                if (s) {
                    var r = 1e3 * 60 * 60 * parseInt(s[1].substring(1, 3), 10) + 1e3 * 60 * parseInt(s[1].substring(3, 5), 10);
                    return "-" === s[1].substring(0, 1) && (r *= -1), r;
                }
            }
        }
        return null;
    }, o = t.getTZOffset = function(e, t) {
        function n(e, n) {
            return e ? (t(e), void 0) : n.messages.total ? (s(n._uidnext - 1), void 0) : (t(null, r), 
            void 0);
        }
        function s(t) {
            e.search([ [ "UID", Math.max(1, t - 49) + ":" + t ] ], o.bind(null, t - 50));
        }
        function o(e, n, i) {
            if (!i.length) {
                if (0 > e) return t(null, r), void 0;
                s(e);
            }
            c = i, a(c.pop());
        }
        function a(n) {
            var s = e.fetch([ n ], {
                request: {
                    headers: [ "RECEIVED" ],
                    struct: !1,
                    body: !1
                }
            });
            s.on("message", function(e) {
                e.on("end", function() {
                    var n = i(e.msg.headers);
                    return null !== n ? (t(null, n), void 0) : (c.length ? a(c.pop()) : t(null, r), 
                    void 0);
                });
            }), s.on("error", function(e) {
                t(e);
            });
        }
        var c = null;
        e.openBox("INBOX", !0, n);
    };
    t.checkServerProblems = function(e, t) {
        function n(e) {
            for (var t in e) if ("inbox" === t.toLowerCase()) return !0;
            return !1;
        }
        e.hasCapability("SPECIAL-USE") || t(null, null), e.getBoxes(function(s, r) {
            return n(r) ? (t(null, null), void 0) : (e.blacklistCapability("SPECIAL-USE"), e.getBoxes(function(e, s) {
                n(s) ? t(null, [ "SPECIAL-USE" ]) : t("server-problem", null);
            }), void 0);
        });
    };
});