define("net", [ "require", "exports", "module", "util", "events", "mailapi/worker-router" ], function(e, t) {
    function r(e, t, r) {
        var n = {
            onopen: this._onconnect.bind(this),
            onerror: this._onerror.bind(this),
            ondata: this._ondata.bind(this),
            onclose: this._onclose.bind(this)
        }, i = o.register(function(e) {
            n[e.cmd](e.args);
        });
        this._sendMessage = i.sendMessage, this._unregisterWithRouter = i.unregister;
        var a = [ t, e, {
            useSSL: r,
            useSecureTransport: r,
            binaryType: "arraybuffer"
        } ];
        this._sendMessage("open", a), s.call(this), this.destroyed = !1;
    }
    var n = e("util"), s = e("events").EventEmitter, i = e("mailapi/worker-router"), o = i.registerInstanceType("netsocket");
    t.NetSocket = r, n.inherits(r, s), r.prototype.setTimeout = function() {}, r.prototype.setKeepAlive = function() {}, 
    r.prototype.write = function(e) {
        if (e instanceof Blob) return this._sendMessage("write", [ e ]), void 0;
        if (0 !== e.byteOffset || e.length !== e.buffer.byteLength) {
            var t = e.buffer.slice(e.byteOffset, e.byteOffset + e.length);
            this._sendMessage("write", [ t, 0, t.byteLength ], [ t ]);
        } else this._sendMessage("write", [ e.buffer, e.byteOffset, e.length ]);
    }, r.prototype.upgradeToSecure = function() {
        this._sendMessage("upgradeToSecure", []);
    }, r.prototype.end = function() {
        this.destroyed || (this._sendMessage("close"), this.destroyed = !0, this._unregisterWithRouter());
    }, r.prototype._onconnect = function() {
        this.emit("connect");
    }, r.prototype._onerror = function(e) {
        this.emit("error", e);
    }, r.prototype._ondata = function(e) {
        var t = Buffer(e);
        this.emit("data", t);
    }, r.prototype._onclose = function() {
        this.emit("close"), this.emit("end");
    }, t.connect = function(e, t, n) {
        return new r(e, t, !!n);
    };
}), define("pop3/transport", [ "exports" ], function(e) {
    function t(e, t) {
        var r = new Uint8Array(e.byteLength + t.byteLength);
        return r.set(e, 0), r.set(t, e.byteLength), r;
    }
    function r() {
        this.buffer = new Uint8Array(0), this.unprocessedLines = [];
    }
    function n(e, t) {
        this.lines = e, this.isMultiline = t, this.ok = this.lines[0][0] === h, this.err = !this.ok, 
        this.request = null;
    }
    function s(e, t, r, n) {
        this.command = e, this.args = t, this.expectMultiline = r, this.onresponse = n || null;
    }
    function i() {
        this.parser = new r(), this.onsend = function() {
            throw new Error("You must implement Pop3Protocol.onsend to send data.");
        }, this.unsentRequests = [], this.pipeline = !1, this.pendingRequests = [], this.closed = !1;
    }
    window.setTimeout.bind(window), window.clearTimeout.bind(window);
    var o = "\r".charCodeAt(0), a = "\n".charCodeAt(0), c = ".".charCodeAt(0), h = "+".charCodeAt(0);
    "-".charCodeAt(0), " ".charCodeAt(0);
    var u = new TextEncoder("utf-8", {
        fatal: !1
    }), d = new TextDecoder("utf-8", {
        fatal: !1
    });
    r.prototype.push = function(e) {
        for (var r = this.buffer = t(this.buffer, e), n = 0; n < r.length - 1; n++) if (r[n] === o && r[n + 1] === a) {
            var s = n + 1;
            this.unprocessedLines.push(r.slice(0, s + 1)), r = this.buffer = r.slice(s + 1), 
            n = -1;
        }
    }, r.prototype.extractResponse = function(e) {
        if (!this.unprocessedLines.length) return null;
        if (this.unprocessedLines[0][0] !== h && (e = !1), e) {
            for (var t = -1, r = 1; r < this.unprocessedLines.length; r++) {
                var s = this.unprocessedLines[r];
                if (3 === s.byteLength && s[0] === c && s[1] === o && s[2] === a) {
                    t = r;
                    break;
                }
            }
            if (-1 === t) return null;
            var i = this.unprocessedLines.splice(0, t + 1);
            i.pop();
            for (var r = 1; t > r; r++) i[r][0] === c && (i[r] = i[r].slice(1));
            return new n(i, !0);
        }
        return new n([ this.unprocessedLines.shift() ], !1);
    }, n.prototype.getStatusLine = function() {
        return this.getLineAsString(0).replace(/^(\+OK|-ERR) /, "");
    }, n.prototype.getLineAsString = function(e) {
        return d.decode(this.lines[e]);
    }, n.prototype.getLinesAsString = function() {
        for (var e = [], t = 0; t < this.lines.length; t++) e.push(this.getLineAsString(t));
        return e;
    }, n.prototype.getDataLines = function() {
        for (var e = [], t = 1; t < this.lines.length; t++) {
            var r = this.getLineAsString(t);
            e.push(r.slice(0, r.length - 2));
        }
        return e;
    }, n.prototype.getDataAsString = function() {
        for (var e = [], t = 1; t < this.lines.length; t++) e.push(this.getLineAsString(t));
        return e.join("");
    }, n.prototype.toString = function() {
        return this.getLinesAsString().join("\r\n");
    }, e.Request = s, s.prototype.toByteArray = function() {
        return u.encode(this.command + (this.args.length ? " " + this.args.join(" ") : "") + "\r\n");
    }, s.prototype._respondWithError = function(e) {
        var t = new n([ u.encode("-ERR " + e + "\r\n") ], !1);
        t.request = this, this.onresponse(t, null);
    }, e.Response = n, e.Pop3Protocol = i, i.prototype.sendRequest = function(e, t, r, n) {
        var i;
        return i = e instanceof s ? e : new s(e, t, r, n), this.closed ? (i._respondWithError("(request sent after connection closed)"), 
        void 0) : (this.pipeline || 0 === this.pendingRequests.length ? (this.onsend(i.toByteArray()), 
        this.pendingRequests.push(i)) : this.unsentRequests.push(i), void 0);
    }, i.prototype.onreceive = function(e) {
        this.parser.push(e);
        for (var t; ;) {
            var r = this.pendingRequests[0];
            if (t = this.parser.extractResponse(r && r.expectMultiline), !t) break;
            if (!r) {
                console.error("Unsolicited response from server: " + t);
                break;
            }
            t.request = r, this.pendingRequests.shift(), this.unsentRequests.length && this.sendRequest(this.unsentRequests.shift()), 
            r.onresponse && (t.err ? r.onresponse(t, null) : r.onresponse(null, t));
        }
    }, i.prototype.onclose = function() {
        this.closed = !0;
        var e = this.pendingRequests.concat(this.unsentRequests);
        this.pendingRequests = [], this.unsentRequests = [];
        for (var t = 0; t < e.length; t++) {
            var r = e[t];
            r._respondWithError("(connection closed, no response)");
        }
    };
}), define("mailparser/datetime", [ "require", "exports", "module" ], function() {
    this.strtotime = function(e, t) {
        var r, n, s, i = "", o = "";
        if (i = e, i = i.replace(/\s{2,}|^\s|\s$/g, " "), i = i.replace(/[\t\r\n]/g, ""), 
        "now" == i) return new Date().getTime() / 1e3;
        if (!isNaN(o = Date.parse(i))) return o / 1e3;
        t = t ? new Date(1e3 * t) : new Date(), i = i.toLowerCase();
        var a = {
            day: {
                sun: 0,
                mon: 1,
                tue: 2,
                wed: 3,
                thu: 4,
                fri: 5,
                sat: 6
            },
            mon: {
                jan: 0,
                feb: 1,
                mar: 2,
                apr: 3,
                may: 4,
                jun: 5,
                jul: 6,
                aug: 7,
                sep: 8,
                oct: 9,
                nov: 10,
                dec: 11
            }
        }, c = function(e) {
            var r = e[2] && "ago" == e[2], n = (n = "last" == e[0] ? -1 : 1) * (r ? -1 : 1);
            switch (e[0]) {
              case "last":
              case "next":
                switch (e[1].substring(0, 3)) {
                  case "yea":
                    t.setFullYear(t.getFullYear() + n);
                    break;

                  case "mon":
                    t.setMonth(t.getMonth() + n);
                    break;

                  case "wee":
                    t.setDate(t.getDate() + 7 * n);
                    break;

                  case "day":
                    t.setDate(t.getDate() + n);
                    break;

                  case "hou":
                    t.setHours(t.getHours() + n);
                    break;

                  case "min":
                    t.setMinutes(t.getMinutes() + n);
                    break;

                  case "sec":
                    t.setSeconds(t.getSeconds() + n);
                    break;

                  default:
                    var s;
                    if ("undefined" != typeof (s = a.day[e[1].substring(0, 3)])) {
                        var i = s - t.getDay();
                        0 == i ? i = 7 * n : i > 0 ? "last" == e[0] && (i -= 7) : "next" == e[0] && (i += 7), 
                        t.setDate(t.getDate() + i);
                    }
                }
                break;

              default:
                if (!/\d+/.test(e[0])) return !1;
                switch (n *= parseInt(e[0], 10), e[1].substring(0, 3)) {
                  case "yea":
                    t.setFullYear(t.getFullYear() + n);
                    break;

                  case "mon":
                    t.setMonth(t.getMonth() + n);
                    break;

                  case "wee":
                    t.setDate(t.getDate() + 7 * n);
                    break;

                  case "day":
                    t.setDate(t.getDate() + n);
                    break;

                  case "hou":
                    t.setHours(t.getHours() + n);
                    break;

                  case "min":
                    t.setMinutes(t.getMinutes() + n);
                    break;

                  case "sec":
                    t.setSeconds(t.getSeconds() + n);
                }
            }
            return !0;
        };
        if (n = i.match(/^(\d{2,4}-\d{2}-\d{2})(?:\s(\d{1,2}:\d{2}(:\d{2})?)?(?:\.(\d+))?)?$/), 
        null != n) {
            n[2] ? n[3] || (n[2] += ":00") : n[2] = "00:00:00", s = n[1].split(/-/g);
            for (r in a.mon) a.mon[r] == s[1] - 1 && (s[1] = r);
            return s[0] = parseInt(s[0], 10), s[0] = s[0] >= 0 && s[0] <= 69 ? "20" + (s[0] < 10 ? "0" + s[0] : s[0] + "") : s[0] >= 70 && s[0] <= 99 ? "19" + s[0] : s[0] + "", 
            parseInt(this.strtotime(s[2] + " " + s[1] + " " + s[0] + " " + n[2]) + (n[4] ? n[4] / 1e3 : ""), 10);
        }
        var h = "([+-]?\\d+\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday)|(last|next)\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday))(\\sago)?";
        if (n = i.match(new RegExp(h, "gi")), null == n) return !1;
        for (r = 0; r < n.length; r++) if (!c(n[r].split(" "))) return !1;
        return t.getTime() / 1e3;
    };
}), define("mailparser/streams", [ "require", "exports", "module", "stream", "util", "mimelib", "encoding", "crypto" ], function(e, t, r) {
    function n() {
        o.call(this), this.writable = !0, this.checksum = u.createHash("md5"), this.length = 0, 
        this.current = "";
    }
    function s(e) {
        o.call(this), this.writable = !0, this.checksum = u.createHash("md5"), this.length = 0, 
        this.charset = e || "UTF-8", this.current = void 0;
    }
    function i(e) {
        o.call(this), this.writable = !0, this.checksum = u.createHash("md5"), this.length = 0, 
        this.charset = e || "UTF-8", this.current = "";
    }
    var o = e("stream").Stream, a = e("util"), c = e("mimelib"), h = e("encoding"), u = e("crypto");
    r.exports.Base64Stream = n, r.exports.QPStream = s, r.exports.BinaryStream = i, 
    a.inherits(n, o), n.prototype.write = function(e) {
        return this.handleInput(e), !0;
    }, n.prototype.end = function(e) {
        return this.handleInput(e), this.emit("end"), {
            length: this.length,
            checksum: this.checksum.digest("hex")
        };
    }, n.prototype.handleInput = function(e) {
        if (e && e.length) {
            e = (e || "").toString("utf-8");
            var t = 0;
            this.current += e.replace(/[^\w\+\/=]/g, "");
            var r = new Buffer(this.current.substr(0, this.current.length - this.current.length % 4), "base64");
            r.length && (this.length += r.length, this.checksum.update(r), this.emit("data", r)), 
            this.current = (t = this.current.length % 4) ? this.current.substr(-t) : "";
        }
    }, a.inherits(s, o), s.prototype.write = function(e) {
        return this.handleInput(e), !0;
    }, s.prototype.end = function(e) {
        return this.handleInput(e), this.flush(), this.emit("end"), {
            length: this.length,
            checksum: this.checksum.digest("hex")
        };
    }, s.prototype.handleInput = function(e) {
        e && e.length && (e = (e || "").toString("utf-8"), e.match(/^\r\n/) && (e = e.substr(2)), 
        "string" != typeof this.current ? this.current = e : this.current += "\r\n" + e);
    }, s.prototype.flush = function() {
        var e = c.decodeQuotedPrintable(this.current, !1, this.charset);
        "binary" == this.charset.toLowerCase() || (e = "utf-8" != this.charset.toLowerCase() ? h.convert(e, "utf-8", this.charset) : new Buffer(e, "utf-8")), 
        this.length += e.length, this.checksum.update(e), this.emit("data", e);
    }, a.inherits(i, o), i.prototype.write = function(e) {
        return e && e.length && (this.length += e.length, this.checksum.update(e), this.emit("data", e)), 
        !0;
    }, i.prototype.end = function(e) {
        return e && e.length && this.emit("data", e), this.emit("end"), {
            length: this.length,
            checksum: this.checksum.digest("hex")
        };
    };
}), define("mailparser/mailparser", [ "require", "exports", "module", "stream", "util", "mimelib", "./datetime", "encoding", "./streams", "crypto" ], function(e, t, r) {
    function n(e) {
        s.call(this), this.writable = !0, this.options = e || {}, this._state = d.header, 
        this._remainder = "", this.mimeTree = this._createMimeNode(), this._currentNode = this.mimeTree, 
        this._currentNode.priority = "normal", this._fileNames = {}, this._multipartTree = [], 
        this.mailData = {}, this._lineCounter = 0, this._lineFeed = !1, this._headersSent = !1;
    }
    var s = e("stream").Stream, i = e("util"), o = e("mimelib"), a = e("./datetime"), c = e("encoding"), h = e("./streams"), u = e("crypto");
    r.exports.MailParser = n;
    var d = {
        header: 1,
        body: 2,
        finished: 3
    };
    i.inherits(n, s), n.prototype.write = function(e, t) {
        return this._write(e, t) && process.nextTick(this._process.bind(this)), !0;
    }, n.prototype.end = function(e, t) {
        this._write(e, t), this.options.debug && this._remainder && console.log("REMAINDER: " + this._remainder), 
        process.nextTick(this._process.bind(this, !0));
    }, n.prototype._write = function(e, t) {
        return "string" == typeof e && (e = new Buffer(e, t)), e = e && e.toString("binary") || "", 
        this._lineFeed && "\n" === e.charAt(0) && (e = e.substr(1)), this._lineFeed = "\r" === e.substr(-1), 
        e && e.length ? (this._remainder += e, !0) : !1;
    }, n.prototype._process = function(e) {
        e = !!e;
        var t, r, n, s = this._remainder.split(/\r?\n|\r/);
        for (e || (this._remainder = s.pop(), this._remainder.length > 1048576 && (this._remainder = this._remainder.replace(/(.{1048576}(?!\r?\n|\r))/g, "$&\n"))), 
        r = 0, n = s.length; n > r; r++) t = s[r], this.options.unescapeSMTP && ".." == t.substr(0, 2) && (t = t.substr(1)), 
        this.options.debug && console.log("LINE " + ++this._lineCounter + " (" + this._state + "): " + t), 
        !(this._state == d.header && this._processStateHeader(t) === !0 || this._state == d.body && this._processStateBody(t) === !0);
        e && (this._state == d.header && this._remainder && (this._processStateHeader(this._remainder), 
        this._headersSent || (this.emit("headers", this._currentNode.parsedHeaders), this._headersSent = !0)), 
        (this._currentNode.content || this._currentNode.stream) && this._finalizeContents(), 
        this._state = d.finished, process.nextTick(this._processMimeTree.bind(this)));
    }, n.prototype._processStateHeader = function(e) {
        var t, r, n = this._currentNode.headers.length - 1, s = !1;
        return e.length ? (e.match(/^\s+/) && n >= 0 ? this._currentNode.headers[n] += " " + e.trim() : (this._currentNode.headers.push(e.trim()), 
        n >= 0 && this._processHeaderLine(n)), !1) : (n >= 0 && this._processHeaderLine(n), 
        this._headersSent || (this.emit("headers", this._currentNode.parsedHeaders), this._headersSent = !0), 
        this._state = d.body, n >= 0 && this._processHeaderLine(n), this._currentNode.parentNode || this._currentNode.meta.contentType || (this._currentNode.meta.contentType = "text/plain"), 
        s = [ "text/plain", "text/html" ].indexOf(this._currentNode.meta.contentType || "") >= 0, 
        !s || this._currentNode.meta.contentDisposition && "inline" != this._currentNode.meta.contentDisposition ? s && !([ "attachment", "inline" ].indexOf(this._currentNode.meta.contentDisposition) >= 0) || this._currentNode.meta.mimeMultipart || (this._currentNode.attachment = !0) : this._currentNode.attachment = !1, 
        this._currentNode.attachment && (this._currentNode.checksum = u.createHash("md5"), 
        this._currentNode.meta.generatedFileName = this._generateFileName(this._currentNode.meta.fileName, this._currentNode.meta.contentType), 
        r = this._currentNode.meta.generatedFileName.split(".").pop().toLowerCase(), "application/octet-stream" == this._currentNode.meta.contentType && o.contentTypes[r] && (this._currentNode.meta.contentType = o.contentTypes[r]), 
        t = this._currentNode.meta, this.options.streamAttachments ? (this._currentNode.stream = "base64" == this._currentNode.meta.transferEncoding ? new h.Base64Stream() : "quoted-printable" == this._currentNode.meta.transferEncoding ? new h.QPStream("binary") : new h.BinaryStream(), 
        t.stream = this._currentNode.stream, this.emit("attachment", t)) : this._currentNode.content = void 0), 
        !0);
    }, n.prototype._processStateBody = function(e) {
        var t, r, n, s = !1;
        if ("--" == e.substr(0, 2)) for (t = 0, r = this._multipartTree.length; r > t; t++) {
            if (e == "--" + this._multipartTree[t].boundary) {
                (this._currentNode.content || this._currentNode.stream) && this._finalizeContents(), 
                n = this._createMimeNode(this._multipartTree[t].node), this._multipartTree[t].node.childNodes.push(n), 
                this._currentNode = n, this._state = d.header, s = !0;
                break;
            }
            if (e == "--" + this._multipartTree[t].boundary + "--") {
                (this._currentNode.content || this._currentNode.stream) && this._finalizeContents(), 
                this._currentNode = this._multipartTree[t].node.parentNode ? this._multipartTree[t].node.parentNode : this._multipartTree[t].node, 
                this._state = d.body, s = !0;
                break;
            }
        }
        return s ? !0 : ([ "text/plain", "text/html" ].indexOf(this._currentNode.meta.contentType || "") >= 0 && !this._currentNode.attachment ? this._handleTextLine(e) : this._currentNode.attachment && this._handleAttachmentLine(e), 
        !1);
    }, n.prototype._processHeaderLine = function(e) {
        var t, r, n, s;
        if (e = e || 0, (s = this._currentNode.headers[e]) && "string" == typeof s) {
            switch (n = s.split(":"), t = n.shift().toLowerCase().trim(), r = n.join(":").trim(), 
            t) {
              case "content-type":
                this._parseContentType(r);
                break;

              case "mime-version":
                this._currentNode.useMIME = !0;
                break;

              case "date":
                this._currentNode.meta.date = new Date(1e3 * a.strtotime(r) || Date.now());
                break;

              case "to":
                this._currentNode.to = this._currentNode.to && this._currentNode.to.length ? this._currentNode.to.concat(o.parseAddresses(r)) : o.parseAddresses(r);
                break;

              case "from":
                this._currentNode.from = this._currentNode.from && this._currentNode.from.length ? this._currentNode.from.concat(o.parseAddresses(r)) : o.parseAddresses(r);
                break;

              case "cc":
                this._currentNode.cc = this._currentNode.cc && this._currentNode.cc.length ? this._currentNode.cc.concat(o.parseAddresses(r)) : o.parseAddresses(r);
                break;

              case "bcc":
                this._currentNode.bcc = this._currentNode.bcc && this._currentNode.bcc.length ? this._currentNode.bcc.concat(o.parseAddresses(r)) : o.parseAddresses(r);
                break;

              case "x-priority":
              case "x-msmail-priority":
              case "importance":
                r = this._parsePriority(r), this._currentNode.priority = r;
                break;

              case "message-id":
                this._currentNode.meta.messageId = this._trimQuotes(r);
                break;

              case "references":
                this._parseReferences(r);
                break;

              case "in-reply-to":
                this._parseInReplyTo(r);
                break;

              case "thread-index":
                this._currentNode.meta.threadIndex = r;
                break;

              case "content-transfer-encoding":
                this._currentNode.meta.transferEncoding = r.toLowerCase();
                break;

              case "subject":
                this._currentNode.subject = this._encodeString(r);
                break;

              case "content-disposition":
                this._parseContentDisposition(r);
                break;

              case "content-id":
                this._currentNode.meta.contentId = this._trimQuotes(r);
            }
            this._currentNode.parsedHeaders[t] ? (Array.isArray(this._currentNode.parsedHeaders[t]) || (this._currentNode.parsedHeaders[t] = [ this._currentNode.parsedHeaders[t] ]), 
            this._currentNode.parsedHeaders[t].push(this._replaceMimeWords(r))) : this._currentNode.parsedHeaders[t] = this._replaceMimeWords(r), 
            this._currentNode.headers[e] = {
                key: t,
                value: r
            };
        }
    }, n.prototype._createMimeNode = function(e) {
        var t = {
            parentNode: e || this._currentNode || null,
            headers: [],
            parsedHeaders: {},
            meta: {},
            childNodes: []
        };
        return t;
    }, n.prototype._parseHeaderLineWithParams = function(e) {
        var t, r, n = {};
        r = e.split(";"), n.defaultValue = r.shift().toLowerCase();
        for (var s = 0, i = r.length; i > s; s++) e = r[s].split("="), t = e.shift().trim().toLowerCase(), 
        e = e.join("=").trim(), e = this._trimQuotes(e), n[t] = e;
        return n;
    }, n.prototype._parseContentType = function(e) {
        var t;
        return e = this._parseHeaderLineWithParams(e), e && (e.defaultValue ? (e.defaultValue = e.defaultValue.toLowerCase(), 
        this._currentNode.meta.contentType = e.defaultValue, "multipart/" == e.defaultValue.substr(0, "multipart/".length) && (this._currentNode.meta.mimeMultipart = e.defaultValue.substr("multipart/".length))) : this._currentNode.meta.contentType = "application/octet-stream", 
        e.charset && (e.charset = e.charset.toLowerCase(), "win-" == e.charset.substr(0, 4) ? e.charset = "windows-" + e.charset.substr(4) : "ks_c_5601-1987" == e.charset ? e.charset = "cp949" : e.charset.match(/^utf\d/) ? e.charset = "utf-" + e.charset.substr(3) : e.charset.match(/^latin[\-_]?\d/) ? e.charset = "iso-8859-" + e.charset.replace(/\D/g, "") : e.charset.match(/^(us\-)?ascii$/) && (e.charset = "utf-8"), 
        this._currentNode.meta.charset = e.charset), e.format && (this._currentNode.meta.textFormat = e.format.toLowerCase()), 
        e.delsp && (this._currentNode.meta.textDelSp = e.delsp.toLowerCase()), e.boundary && (this._currentNode.meta.mimeBoundary = e.boundary), 
        !this._currentNode.meta.fileName && (t = this._detectFilename(e)) && (this._currentNode.meta.fileName = t), 
        e.boundary && (this._currentNode.meta.mimeBoundary = e.boundary, this._multipartTree.push({
            boundary: e.boundary,
            node: this._currentNode
        }))), e;
    }, n.prototype._detectFilename = function(e) {
        var t, r, n, s = "", i = 0;
        if (e.name) return this._replaceMimeWords(e.name);
        if (e.filename) return this._replaceMimeWords(e.filename);
        if (e["name*"]) s = e["name*"]; else if (e["filename*"]) s = e["filename*"]; else if (e["name*0*"]) for (;e["name*" + i + "*"]; ) s += e["name*" + i++ + "*"]; else if (e["filename*0*"]) for (;e["filename*" + i + "*"]; ) s += e["filename*" + i++ + "*"];
        return s && (t = s.split("'"), r = t.shift(), n = t.pop()) ? this._replaceMimeWords(this._replaceMimeWords("=?" + (r || "us-ascii") + "?Q?" + n.replace(/%/g, "=") + "?=")) : "";
    }, n.prototype._parseContentDisposition = function(e) {
        var t;
        e = this._parseHeaderLineWithParams(e), e && (e.defaultValue && (this._currentNode.meta.contentDisposition = e.defaultValue.trim().toLowerCase()), 
        (t = this._detectFilename(e)) && (this._currentNode.meta.fileName = t));
    }, n.prototype._parseReferences = function(e) {
        this._currentNode.references = (this._currentNode.references || []).concat((e || "").toString().trim().split(/\s+/).map(this._trimQuotes.bind(this)));
    }, n.prototype._parseInReplyTo = function(e) {
        this._currentNode.inReplyTo = (this._currentNode.inReplyTo || []).concat((e || "").toString().trim().split(/\s+/).map(this._trimQuotes.bind(this)));
    }, n.prototype._parsePriority = function(e) {
        if (e = e.toLowerCase().trim(), !isNaN(parseInt(e, 10))) return e = parseInt(e, 10) || 0, 
        3 == e ? "normal" : e > 3 ? "low" : "high";
        switch (e) {
          case "non-urgent":
          case "low":
            return "low";

          case "urgent":
          case "hight":
            return "high";
        }
        return "normal";
    }, n.prototype._handleTextLine = function(e) {
        var t = this._currentNode.meta.transferEncoding;
        "base64" === t ? "string" != typeof this._currentNode.content ? this._currentNode.content = e.trim() : this._currentNode.content += e.trim() : "quoted-printable" === t || "flowed" != this._currentNode.meta.textFormat ? "string" != typeof this._currentNode.content ? this._currentNode.content = e : this._currentNode.content += "\n" + e : "string" != typeof this._currentNode.content ? this._currentNode.content = e : this._currentNode.content.match(/[ ]{1,}$/) ? ("yes" == this._currentNode.meta.textDelSp && (this._currentNode.content = this._currentNode.content.replace(/\s+$/, "")), 
        this._currentNode.content += e) : this._currentNode.content += "\n" + e;
    }, n.prototype._handleAttachmentLine = function(e) {
        this._currentNode.attachment && (this._currentNode.stream ? this._currentNode.streamStarted ? this._currentNode.stream.write(new Buffer("\r\n" + e, "binary")) : (this._currentNode.streamStarted = !0, 
        this._currentNode.stream.write(new Buffer(e, "binary"))) : "content" in this._currentNode && ("string" != typeof this._currentNode.content ? this._currentNode.content = e : this._currentNode.content += "\r\n" + e));
    }, n.prototype._finalizeContents = function() {
        var e;
        this._currentNode.content && (this._currentNode.attachment ? (this._currentNode.content = "quoted-printable" == this._currentNode.meta.transferEncoding ? o.decodeQuotedPrintable(this._currentNode.content, !1, "binary") : "base64" == this._currentNode.meta.transferEncoding ? new Buffer(this._currentNode.content.replace(/[^\w\+\/=]/g, ""), "base64") : new Buffer(this._currentNode.content, "binary"), 
        this._currentNode.checksum.update(this._currentNode.content), this._currentNode.meta.checksum = this._currentNode.checksum.digest("hex"), 
        this._currentNode.meta.length = this._currentNode.content.length) : ("text/html" == this._currentNode.meta.contentType && (this._currentNode.meta.charset = this._detectHTMLCharset(this._currentNode.content) || this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1"), 
        "quoted-printable" == this._currentNode.meta.transferEncoding ? (this._currentNode.content = o.decodeQuotedPrintable(this._currentNode.content, !1, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1"), 
        "flowed" === this._currentNode.meta.textFormat && (this._currentNode.content = "yes" === this._currentNode.meta.textDelSp ? this._currentNode.content.replace(/ \n/g, "") : this._currentNode.content.replace(/ \n/g, " "))) : this._currentNode.content = "base64" == this._currentNode.meta.transferEncoding ? o.decodeBase64(this._currentNode.content, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1") : this._convertStringToUTF8(this._currentNode.content))), 
        this._currentNode.stream && (e = this._currentNode.stream.end() || {}, e.checksum && (this._currentNode.meta.checksum = e.checksum), 
        e.length && (this._currentNode.meta.length = e.length));
    }, n.prototype._processMimeTree = function() {
        var e, t, r, n, s = {};
        if (this.mailData = {
            html: [],
            text: [],
            alternatives: [],
            attachments: []
        }, this.mimeTree.meta.mimeMultipart ? this._walkMimeTree(this.mimeTree) : this._processMimeNode(this.mimeTree, 0), 
        this.mailData.html.length) for (r = 0, n = this.mailData.html.length; n > r; r++) !s.html || this.mailData.html[r].level < e ? (s.html && (s.alternatives || (s.alternatives = []), 
        s.alternatives.push({
            contentType: "text/html",
            content: s.html
        })), e = this.mailData.html[r].level, s.html = this.mailData.html[r].content) : (s.alternatives || (s.alternatives = []), 
        s.alternatives.push({
            contentType: "text/html",
            content: this.mailData.html[r].content
        }));
        if (this.mailData.text.length) for (r = 0, n = this.mailData.text.length; n > r; r++) !s.text || this.mailData.text[r].level < t ? (s.text && (s.alternatives || (s.alternatives = []), 
        s.alternatives.push({
            contentType: "text/plain",
            content: s.text
        })), t = this.mailData.text[r].level, s.text = this.mailData.text[r].content) : (s.alternatives || (s.alternatives = []), 
        s.alternatives.push({
            contentType: "text/plain",
            content: this.mailData.text[r].content
        }));
        if (s.headers = this.mimeTree.parsedHeaders, this.mimeTree.subject && (s.subject = this.mimeTree.subject), 
        this.mimeTree.references && (s.references = this.mimeTree.references), this.mimeTree.inReplyTo && (s.inReplyTo = this.mimeTree.inReplyTo), 
        this.mimeTree.priority && (s.priority = this.mimeTree.priority), this.mimeTree.from && (s.from = this.mimeTree.from), 
        this.mimeTree.to && (s.to = this.mimeTree.to), this.mimeTree.cc && (s.cc = this.mimeTree.cc), 
        this.mimeTree.bcc && (s.bcc = this.mimeTree.bcc), this.mailData.attachments.length) for (s.attachments = [], 
        r = 0, n = this.mailData.attachments.length; n > r; r++) s.attachments.push(this.mailData.attachments[r].content);
        process.nextTick(this.emit.bind(this, "end", s));
    }, n.prototype._walkMimeTree = function(e, t) {
        t = t || 1;
        for (var r = 0, n = e.childNodes.length; n > r; r++) this._processMimeNode(e.childNodes[r], t, e.meta.mimeMultipart), 
        this._walkMimeTree(e.childNodes[r], t + 1);
    }, n.prototype._processMimeNode = function(e, t, r) {
        var n, s;
        if (t = t || 0, e.attachment) {
            if (e.meta = e.meta || {}, e.content && (e.meta.content = e.content), this.mailData.attachments.push({
                content: e.meta || {},
                level: t
            }), this.options.showAttachmentLinks && "mixed" == r && this.mailData.html.length) for (n = 0, 
            s = this.mailData.html.length; s > n; n++) if (this.mailData.html[n].level == t) return this._joinHTMLAttachment(this.mailData.html[n], e.meta), 
            void 0;
        } else switch (e.meta.contentType) {
          case "text/html":
            if ("mixed" == r && this.mailData.html.length) for (n = 0, s = this.mailData.html.length; s > n; n++) if (this.mailData.html[n].level == t) return this._joinHTMLNodes(this.mailData.html[n], e.content), 
            void 0;
            return this.mailData.html.push({
                content: this._updateHTMLCharset(e.content || ""),
                level: t
            }), void 0;

          case "text/plain":
            return this.mailData.text.push({
                content: e.content || "",
                level: t
            }), void 0;
        }
    }, n.prototype._joinHTMLNodes = function(e, t) {
        var r = !1;
        t = (t || "").toString("utf-8").trim(), t = t.replace(/^\s*<\!doctype( [^>]*)?>/gi, ""), 
        t = t.replace(/<head( [^>]*)?>(.*)<\/head( [^>]*)?>/gi, "").replace(/<\/?html( [^>]*)?>/gi, "").trim(), 
        t.replace(/<body(?: [^>]*)?>(.*)<\/body( [^>]*)?>/gi, function(e, r) {
            t = r.trim();
        }), e.content = (e.content || "").toString("utf-8").trim(), e.content = e.content.replace(/<\/body( [^>]*)?>/i, function(e) {
            return r = !0, "<br/>\n" + t + e;
        }), r || (e.content += "<br/>\n" + t);
    }, n.prototype._joinHTMLAttachment = function(e, t) {
        var r, n, s = !1, i = t.generatedFileName.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;");
        r = t.cid || (t.cid = t.generatedFileName + "@node"), n = '\n<div class="mailparser-attachment"><a href="cid:' + r + '">&lt;' + i + "&gt;</a></div>", 
        e.content = (e.content || "").toString("utf-8").trim(), e.content = e.content.replace(/<\/body( [^>]*)?>/i, function(e) {
            return s = !0, "<br/>\n" + n + e;
        }), s || (e.content += "<br/>\n" + n);
    }, n.prototype._convertString = function(e, t, r) {
        return r = (r || "utf-8").toUpperCase(), t = (t || "utf-8").toUpperCase(), e = "string" == typeof e ? new Buffer(e, "binary") : e, 
        r == t ? e : e = c.convert(e, r, t);
    }, n.prototype._convertStringToUTF8 = function(e) {
        return e = this._convertString(e, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1").toString("utf-8");
    }, n.prototype._encodeString = function(e) {
        return e = this._replaceMimeWords(this._convertStringToUTF8(e));
    }, n.prototype._replaceMimeWords = function(e) {
        return e.replace(/(=\?[^?]+\?[QqBb]\?[^?]+\?=)\s+(?==\?[^?]+\?[QqBb]\?[^?]+\?=)/g, "$1").replace(/\=\?[^?]+\?[QqBb]\?[^?]+\?=/g, function(e) {
            return o.decodeMimeWord(e.replace(/\s/g, ""));
        }.bind(this));
    }, n.prototype._trimQuotes = function(e) {
        return e = (e || "").trim(), ('"' == e.charAt(0) && '"' == e.charAt(e.length - 1) || "'" == e.charAt(0) && "'" == e.charAt(e.length - 1) || "<" == e.charAt(0) && ">" == e.charAt(e.length - 1)) && (e = e.substr(1, e.length - 2)), 
        e;
    }, n.prototype._generateFileName = function(e, t) {
        var r, n = "";
        return t && (n = o.contentTypesReversed[t], n = n ? "." + n : ""), e = e || "attachment" + n, 
        e = e.toString().split(/[\/\\]+/).pop().replace(/^\.+/, "") || "attachment", e in this._fileNames ? (this._fileNames[e]++, 
        r = e.substr((e.lastIndexOf(".") || 0) + 1), r == e ? e += "-" + this._fileNames[e] : e = e.substr(0, e.length - r.length - 1) + "-" + this._fileNames[e] + "." + r) : this._fileNames[e] = 0, 
        e;
    }, n.prototype._updateHTMLCharset = function(e) {
        return e = e.replace(/\n/g, "\0").replace(/<meta[^>]*>/gi, function(e) {
            return e.match(/http\-equiv\s*=\s*"?content\-type/i) ? '<meta http-equiv="content-type" content="text/html; charset=utf-8" />' : e.match(/\scharset\s*=\s*['"]?[\w\-]+["'\s>\/]/i) ? '<meta charset="utf-8"/>' : e;
        }).replace(/\u0000/g, "\n");
    }, n.prototype._detectHTMLCharset = function(e) {
        var t, r, n;
        return " string" != typeof e && (e = e.toString("ascii")), (n = e.match(/<meta\s+http-equiv=["']content-type["'][^>]*?>/i)) && (r = n[0]), 
        r && (t = r.match(/charset\s?=\s?([a-zA-Z\-_:0-9]*);?/), t && (t = (t[1] || "").trim().toLowerCase())), 
        !t && (n = e.match(/<meta\s+charset=["']([^'"<\/]*?)["']/i)) && (t = (n[1] || "").trim().toLowerCase()), 
        t;
    };
}), define("mailapi/imap/imapchew", [ "mimelib", "mailapi/db/mail_rep", "../mailchew", "exports" ], function(e, t, r, n) {
    function s(t) {
        var r = /^([^']*)'([^']*)'(.+)$/.exec(t);
        return r ? e.parseMimeWords("=?" + (r[1] || "us-ascii") + "?Q?" + r[3].replace(/%/g, "=") + "?=") : null;
    }
    function i(r) {
        function n(e) {
            var t = e.encoding.toLowerCase();
            return "base64" === t ? Math.floor(57 * e.size / 78) : "quoted-printable" === t ? e.size : e.size;
        }
        function i(r) {
            function i(e) {
                return "<" === e[0] ? e.slice(1, -1) : e;
            }
            function o(e, r) {
                return t.makeAttachmentPart({
                    name: r || "unnamed-" + ++h,
                    contentId: e.id ? i(e.id) : null,
                    type: (e.type + "/" + e.subtype).toLowerCase(),
                    part: e.partID,
                    encoding: e.encoding && e.encoding.toLowerCase(),
                    sizeEstimate: n(e),
                    file: null
                });
            }
            function d(e) {
                return t.makeBodyPart({
                    type: e.subtype,
                    part: e.partID,
                    sizeEstimate: e.size,
                    amountDownloaded: 0,
                    isDownloaded: 0 === e.size,
                    _partInfo: e.size ? e : null,
                    content: ""
                });
            }
            var p, m, l = r[0];
            if (p = l.params && l.params.name ? e.parseMimeWords(l.params.name) : l.params && l.params["name*"] ? s(l.params["name*"]) : l.disposition && l.disposition.params && l.disposition.params.filename ? e.parseMimeWords(l.disposition.params.filename) : l.disposition && l.disposition.params && l.disposition.params["filename*"] ? s(l.disposition.params["filename*"]) : null, 
            m = l.disposition ? l.disposition.type.toLowerCase() : l.id ? "inline" : p || "text" !== l.type ? "attachment" : "inline", 
            "text" !== l.type && "image" !== l.type && (m = "attachment"), "application" === l.type && ("pgp-signature" === l.subtype || "pkcs7-signature" === l.subtype)) return !0;
            if ("attachment" === m) return a.push(o(l, p)), !0;
            switch (l.type) {
              case "image":
                return u.push(o(l, p)), !0;

              case "text":
                if ("plain" === l.subtype || "html" === l.subtype) return c.push(d(l)), !0;
            }
            return !1;
        }
        function o(e) {
            var t, r = e[0];
            switch (r.subtype) {
              case "alternative":
                for (t = e.length - 1; t >= 1; t--) {
                    var n = e[t][0];
                    switch (n.type) {
                      case "text":
                        break;

                      case "multipart":
                        if (o(e[t])) return !0;
                        break;

                      default:
                        continue;
                    }
                    switch (n.subtype) {
                      case "html":
                      case "plain":
                        if (i(e[t])) return !0;
                    }
                }
                return !1;

              case "mixed":
              case "signed":
              case "related":
                for (t = 1; t < e.length; t++) e[t].length > 1 ? o(e[t]) : i(e[t]);
                return !0;

              default:
                return console.warn("Ignoring multipart type:", r.subtype), !1;
            }
        }
        var a = [], c = [], h = 0, u = [];
        return r.structure.length > 1 ? o(r.structure) : i(r.structure), {
            bodyReps: c,
            attachments: a,
            relatedParts: u
        };
    }
    n.chewHeaderAndBodyStructure = function(e, r, n) {
        var s = i(e), o = {};
        return o.header = t.makeHeaderInfo({
            id: n,
            srvid: e.id,
            suid: r + "/" + n,
            guid: e.msg.meta.messageId,
            author: e.msg.from && e.msg.from[0] || {
                address: "missing-address@example.com"
            },
            to: "to" in e.msg ? e.msg.to : null,
            cc: "cc" in e.msg ? e.msg.cc : null,
            bcc: "bcc" in e.msg ? e.msg.bcc : null,
            replyTo: "reply-to" in e.msg.parsedHeaders ? e.msg.parsedHeaders["reply-to"] : null,
            date: e.date,
            flags: e.flags,
            hasAttachments: s.attachments.length > 0,
            subject: e.msg.subject || null,
            snippet: null
        }), o.bodyInfo = t.makeBodyInfo({
            date: e.date,
            size: 0,
            attachments: s.attachments,
            relatedParts: s.relatedParts,
            references: e.msg.references,
            bodyReps: s.bodyReps
        }), o;
    }, n.updateMessageWithFetch = function(e, t, n, s, i) {
        var o = t.bodyReps[n.bodyRepIndex];
        (!n.bytes || s.bytesFetched < n.bytes[1]) && (o.isDownloaded = !0, o._partInfo = null), 
        !o.isDownloaded && s.buffer && (o._partInfo.pendingBuffer = s.buffer), o.amountDownloaded += s.bytesFetched;
        var a = r.processMessageContent(s.text, o.type, o.isDownloaded, n.createSnippet, i);
        n.createSnippet && (e.snippet = a.snippet), o.isDownloaded && (o.content = a.content);
    }, n.selectSnippetBodyRep = function(e, t) {
        if (e.snippet) return -1;
        for (var r = t.bodyReps, s = r.length, i = 0; s > i; i++) if (n.canBodyRepFillSnippet(r[i])) return i;
        return -1;
    }, n.canBodyRepFillSnippet = function(e) {
        return e && "plain" === e.type || "html" === e.type;
    }, n.calculateBytesToDownloadForImapBodyDisplay = function(e) {
        var t = 0;
        return e.bodyReps.forEach(function(e) {
            e.isDownloaded || (t += e.sizeEstimate - e.amountDownloaded);
        }), e.relatedParts.forEach(function(e) {
            e.file || (t += e.sizeEstimate);
        }), t;
    };
}), define("pop3/mime_mapper", [], function() {
    return {
        _typeToExtensionMap: {
            "image/jpeg": "jpg",
            "image/png": "png",
            "image/gif": "gif",
            "image/bmp": "bmp",
            "audio/mpeg": "mp3",
            "audio/mp4": "m4a",
            "audio/ogg": "ogg",
            "audio/webm": "webm",
            "audio/3gpp": "3gp",
            "audio/amr": "amr",
            "video/mp4": "mp4",
            "video/mpeg": "mpg",
            "video/ogg": "ogg",
            "video/webm": "webm",
            "video/3gpp": "3gp",
            "application/vcard": "vcf",
            "text/vcard": "vcf",
            "text/x-vcard": "vcf"
        },
        _extensionToTypeMap: {
            jpg: "image/jpeg",
            jpeg: "image/jpeg",
            jpe: "image/jpeg",
            png: "image/png",
            gif: "image/gif",
            bmp: "image/bmp",
            mp3: "audio/mpeg",
            m4a: "audio/mp4",
            m4b: "audio/mp4",
            m4p: "audio/mp4",
            m4r: "audio/mp4",
            aac: "audio/aac",
            opus: "audio/ogg",
            amr: "audio/amr",
            mp4: "video/mp4",
            mpeg: "video/mpeg",
            mpg: "video/mpeg",
            ogv: "video/ogg",
            ogx: "video/ogg",
            webm: "video/webm",
            "3gp": "video/3gpp",
            ogg: "video/ogg",
            vcf: "text/vcard"
        },
        _parseExtension: function(e) {
            var t = e.split(".");
            return t.length > 1 ? t.pop() : "";
        },
        isSupportedType: function(e) {
            return e in this._typeToExtensionMap;
        },
        isSupportedExtension: function(e) {
            return e in this._extensionToTypeMap;
        },
        isFilenameMatchesType: function(e, t) {
            var r = this._parseExtension(e), n = this.guessTypeFromExtension(r);
            return n == t;
        },
        guessExtensionFromType: function(e) {
            return this._typeToExtensionMap[e];
        },
        guessTypeFromExtension: function(e) {
            return this._extensionToTypeMap[e];
        },
        guessTypeFromFileProperties: function(e, t) {
            var r = this._parseExtension(e), n = this.isSupportedType(t) ? t : this.guessTypeFromExtension(r);
            return n || "";
        },
        ensureFilenameMatchesType: function(e, t) {
            if (!this.isFilenameMatchesType(e, t)) {
                var r = this.guessExtensionFromType(t);
                r && (e += "." + r);
            }
            return e;
        }
    };
}), define("pop3/pop3", [ "module", "exports", "rdcommon/log", "net", "crypto", "./transport", "mailparser/mailparser", "../mailapi/imap/imapchew", "../mailapi/syncbase", "../mailapi/date", "./mime_mapper", "../mailapi/allback" ], function(e, t, r, n, s, i, o, a, c, h, u, d) {
    function p(e) {
        return s.createHash("md5").update(e).digest("hex").toLowerCase();
    }
    function m(e, t, r, n) {
        var s = [], i = e.meta.contentType.split("/"), o = {};
        if (o.type = i[0], o.subtype = i[1], o.params = {}, o.params.boundary = e.meta.mimeBoundary || null, 
        o.params.format = e.meta.textFormat || null, o.params.charset = e.meta.charset || null, 
        o.params.name = e.meta.fileName || null, e.meta.contentDisposition && (o.disposition = {
            type: e.meta.contentDisposition,
            params: {}
        }, e.meta.fileName && (o.disposition.params.filename = e.meta.fileName)), o.partID = t || "1", 
        o.id = e.meta.contentId, o.encoding = "binary", o.size = e.content && e.content.length || 0, 
        o.description = null, o.lines = null, o.md5 = null, null != e.content && ("text" === o.type && e.content.length && "\n" === e.content[e.content.length - 1] && (e.content = e.content.slice(0, -1), 
        o.size--), r[o.partID] = e.content, n === e && (r.partial = o.partID)), s.push(o), 
        e.childNodes.length) for (var a = 0; a < e.childNodes.length; a++) {
            var c = e.childNodes[a];
            s.push(m(c, o.partID + "." + (a + 1), r, n));
        }
        return s;
    }
    function l(e) {
        var t = "";
        if (Array.isArray(e)) return e.forEach(function(e) {
            t += l(e) + "\n";
        }), t;
        for (var r = 0; r < e.length; r++) {
            var n = String.fromCharCode(e[r]);
            t += "\r" === n ? "\\r" : "\n" === n ? "\\n" : n;
        }
        return t;
    }
    var f = window.setTimeout.bind(window), g = window.clearTimeout.bind(window);
    t.setTimeoutFuncs = function(e, t) {
        f = e, g = t;
    };
    var _ = t.Pop3Client = function(e, t) {
        if (this.options = e = e || {}, e.host = e.host || null, e.username = e.username || null, 
        e.password = e.password || null, e.port = e.port || null, e.crypto = e.crypto || !1, 
        e.connTimeout = e.connTimeout || 3e4, e.debug = e.debug || !1, e.authMethods = [ "apop", "sasl", "user-pass" ], 
        this._LOG = e._logParent ? y.Pop3Client(this, e._logParent, Date.now() % 1e3) : null, 
        e.preferredAuthMethod) {
            var r = e.authMethods.indexOf(e.preferredAuthMethod);
            -1 !== r && e.authMethods.splice(r, 1), e.authMethods.unshift(e.preferredAuthMethod);
        }
        if (e.crypto === !0 ? e.crypto = "ssl" : e.crypto || (e.crypto = "plain"), !e.port && (e.port = {
            plain: 110,
            starttls: 110,
            ssl: 995
        }[e.crypto], !e.port)) throw new Error("Invalid crypto option for Pop3Client: " + e.crypto);
        this.state = "disconnected", this.authMethod = null, this.idToUidl = {}, this.uidlToId = {}, 
        this.idToSize = {}, this._messageList = null, this._greetingLine = null, this.protocol = new i.Pop3Protocol(), 
        this.socket = n.connect(e.port, e.host, "ssl" === e.crypto);
        var s = f(function() {
            this.state = "disconnected", s && (g(s), s = null), t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: "Could not connect to " + e.host + ":" + e.port + " with " + e.crypto + " encryption."
            });
        }.bind(this), e.connTimeout);
        e.debug && this.attachDebugLogging(), this.socket.on("data", this.protocol.onreceive.bind(this.protocol)), 
        this.protocol.onsend = this.socket.write.bind(this.socket), this.socket.on("connect", function() {
            s && (g(s), s = null), this.state = "greeting";
        }.bind(this)), this.socket.on("error", function(e) {
            s && (g(s), s = null), t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: "Socket exception: " + JSON.stringify(e),
                exception: e
            });
        }.bind(this)), this.socket.on("close", function() {
            this.protocol.onclose(), this.die();
        }.bind(this)), this.protocol.pendingRequests.push(new i.Request(null, [], !1, function(e, r) {
            return e ? (t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: e.getStatusLine(),
                response: e
            }), void 0) : (this._greetingLine = r.getLineAsString(0), this._maybeUpgradeConnection(function(e) {
                return e ? (t && t(e), void 0) : (this._thenAuthorize(function(e) {
                    e || (this.state = "ready"), t && t(e);
                }), void 0);
            }.bind(this)), void 0);
        }.bind(this)));
    };
    _.prototype.disconnect = _.prototype.die = function() {
        "disconnected" !== this.state && (this.state = "disconnected", this.socket.end());
    }, _.prototype.attachDebugLogging = function() {
        this.socket.on("data", function(e) {
            var t = l(e), r = -1 === t.indexOf("-ERR") ? "[32m" : "[31m";
            dump("<-- " + r + t + "[0;37m\n");
        });
        var e = this.socket.write;
        this.socket.write = function(t) {
            var r = l(t);
            return r = r.replace(/(AUTH|USER|PASS|APOP)(.*?)\\r\\n/g, "$1 ***CREDENTIALS HIDDEN***\\r\\n"), 
            dump("--> [0;33m" + r + "[0;37m\n"), e.apply(this, arguments);
        }.bind(this.socket);
    }, _.prototype._getCapabilities = function() {
        this.protocol.sendRequest("CAPA", [], !0, function(e, t) {
            if (e) this.capabilities = {}; else for (var r = t.getDataLines(), n = 0; n < r.length; n++) {
                var s = r[n].split(" ");
                this.capabilities[s[0]] = s.slice(1);
            }
        }.bind(this));
    }, _.prototype._maybeUpgradeConnection = function(e) {
        "starttls" === this.options.crypto ? (this.state = "starttls", this.protocol.sendRequest("STLS", [], !1, function(t) {
            return t ? (e && e({
                scope: "connection",
                request: t.request,
                name: "bad-security",
                message: t.getStatusLine(),
                response: t
            }), void 0) : (this.socket.upgradeToSecure(), e(), void 0);
        }.bind(this))) : e();
    }, _.prototype._thenAuthorize = function(e) {
        this.state = "authorization", this.authMethod = this.options.authMethods.shift();
        var t, r = this.options.username, n = this.options.password;
        switch (this.authMethod) {
          case "apop":
            var s = /<.*?>/.exec(this._greetingLine || ""), i = s && s[0];
            i ? (t = p(i + n), this.protocol.sendRequest("APOP", [ r, t ], !1, function(t) {
                t ? (this._greetingLine = null, this._thenAuthorize(e)) : e();
            }.bind(this))) : this._thenAuthorize(e);
            break;

          case "sasl":
            t = btoa(r + "\0" + r + "\0" + n), this.protocol.sendRequest("AUTH", [ "PLAIN", t ], !1, function(t) {
                t ? this._thenAuthorize(e) : e();
            }.bind(this));
            break;

          case "user-pass":
          default:
            this.protocol.sendRequest("USER", [ r ], !1, function(t) {
                return t ? (e && e({
                    scope: "authentication",
                    request: t.request,
                    name: "bad-user-or-pass",
                    message: t.getStatusLine(),
                    response: t
                }), void 0) : (this.protocol.sendRequest("PASS", [ n ], !1, function(t) {
                    return t ? (e && e({
                        scope: "authentication",
                        request: t.request,
                        name: "bad-user-or-pass",
                        message: t.getStatusLine(),
                        response: t
                    }), void 0) : (e(), void 0);
                }.bind(this)), void 0);
            }.bind(this));
        }
    }, _.prototype.quit = function(e) {
        this.state = "disconnected", this.protocol.sendRequest("QUIT", [], !1, function(t) {
            this.disconnect(), t ? e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }) : e && e();
        }.bind(this));
    }, _.prototype._loadMessageList = function(e) {
        return this._messageList ? (e(null, this._messageList), void 0) : (this.protocol.sendRequest("UIDL", [], !0, function(t, r) {
            if (t) return e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }), void 0;
            for (var n = r.getDataLines(), s = 0; s < n.length; s++) {
                var i = n[s].split(" "), o = i[0], a = i[1];
                this.idToUidl[o] = a, this.uidlToId[a] = o;
            }
        }.bind(this)), this.protocol.sendRequest("LIST", [], !0, function(t, r) {
            if (t) return e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }), void 0;
            for (var n = r.getDataLines(), s = [], i = 0; i < n.length; i++) {
                var o = n[i].split(" "), a = o[0], c = parseInt(o[1], 10);
                this.idToSize[a] = c, s.unshift({
                    uidl: this.idToUidl[a],
                    size: c,
                    number: a
                });
            }
            this._messageList = s, e && e(null, s);
        }.bind(this)), void 0);
    }, _.prototype.listMessages = function(e, t) {
        var r = e.filter, n = e.progress, s = e.checkpointInterval || null, i = e.maxMessages || 1/0, o = e.checkpoint, a = [];
        this._loadMessageList(function(e, c) {
            if (e) return t && t(e), void 0;
            for (var h = 0, u = 0, p = [], m = 0, l = 0; l < c.length; l++) {
                var f = c[l];
                !r || r(f.uidl) ? p.length < i ? (h += f.size, p.push(f)) : a.push(f) : m++;
            }
            console.log("POP3: listMessages found " + p.length + " new, " + a.length + " overflow, and " + m + " seen messages. New UIDLs:"), 
            p.forEach(function(e) {
                console.log("POP3: " + e.size + " bytes: " + e.uidl);
            });
            var g = p.length;
            s || (s = g);
            var _ = function() {
                if (console.log("POP3: Next batch. Messages left: " + p.length), !p.length) return console.log("POP3: Sync complete. " + g + " messages synced, " + a.length + " overflow messages."), 
                t && t(null, g, a), void 0;
                var e = p.splice(0, s), r = d.latch();
                e.forEach(function(e) {
                    var t = r.defer();
                    this.downloadPartialMessageByNumber(e.number, function(r, s) {
                        u += e.size, n && n({
                            totalBytes: h,
                            bytesFetched: u,
                            size: e.size,
                            message: s
                        }), t(r);
                    });
                }.bind(this)), r.then(function() {
                    console.log("POP3: Checkpoint."), o ? o(_) : _();
                });
            }.bind(this);
            _();
        }.bind(this));
    }, _.prototype.downloadMessageByUidl = function(e, t) {
        this._loadMessageList(function(r) {
            r ? t && t(r) : this.downloadMessageByNumber(this.uidlToId[e], t);
        }.bind(this));
    }, _.prototype.downloadPartialMessageByNumber = function(e, t) {
        var r = Math.floor(c.POP3_SNIPPET_SIZE_GOAL / 80);
        this.protocol.sendRequest("TOP", [ e, r ], !0, function(r, n) {
            if (r) return t && t({
                scope: "message",
                request: r.request,
                name: "server-problem",
                message: r.getStatusLine(),
                response: r
            }), void 0;
            var s = this.idToSize[e], i = n.getDataAsString(), o = !s || i.length < s;
            t(null, this.parseMime(i, o, e));
        }.bind(this));
    }, _.prototype.downloadMessageByNumber = function(e, t) {
        this.protocol.sendRequest("RETR", [ e ], !0, function(r, n) {
            return r ? (t && t({
                scope: "message",
                request: r.request,
                name: "server-problem",
                message: r.getStatusLine(),
                response: r
            }), void 0) : (t(null, this.parseMime(n.getDataAsString(), !1, e)), void 0);
        }.bind(this));
    }, _.parseMime = function(e) {
        return _.prototype.parseMime.call(this, e);
    }, _.prototype.parseMime = function(e, t, r) {
        var n = new o.MailParser();
        n._write(e), n._process(!0);
        var s, i = n.mimeTree, d = t ? n._currentNode : null, p = r && this.idToSize[r] || e.length, l = i.meta.date && i.meta.date.valueOf();
        l || (l = h.NOW());
        var f = {}, g = {
            id: r && this.idToUidl[r],
            msg: i,
            date: l,
            flags: [],
            structure: m(i, "1", f, d)
        }, _ = a.chewHeaderAndBodyStructure(g, null, null), y = a.selectSnippetBodyRep(_.header, _.bodyInfo), b = {}, v = 0, N = f.partial;
        for (var x in f) "partial" !== x && x !== N && (v += f[x].length, b[x] = f[x].length);
        N && (b[N] = p - v);
        for (var w = 0; w < _.bodyInfo.bodyReps.length; w++) {
            var T = _.bodyInfo.bodyReps[w];
            if (s = f[T.part], null != s) {
                var S = {
                    bytes: N === T.part ? [ -1, -1 ] : null,
                    bodyRepIndex: w,
                    createSnippet: w === y
                };
                T.size = b[T.part];
                var M = {
                    bytesFetched: s.length,
                    text: s
                };
                a.updateMessageWithFetch(_.header, _.bodyInfo, S, M, this._LOG);
            }
        }
        for (var w = 0; w < _.bodyInfo.relatedParts.length; w++) {
            var k = _.bodyInfo.relatedParts[w];
            k.sizeEstimate = b[k.part], s = f[k.part], null != s && N !== k.part && (k.file = new Blob([ s ], {
                type: k.type
            }));
        }
        for (var w = 0; w < _.bodyInfo.attachments.length; w++) {
            var L = _.bodyInfo.attachments[w];
            s = f[L.part], L.sizeEstimate = b[L.part], null != s && N !== L.part && u.isSupportedType(L.type) && (L.file = new Blob([ s ], {
                type: L.type
            }));
        }
        return t && !_.header.hasAttachments && (i.parsedHeaders["x-ms-has-attach"] || "mixed" === i.meta.mimeMultipart || p > c.POP3_INFER_ATTACHMENTS_SIZE) && (_.header.hasAttachments = !0), 
        _.bodyInfo.bodyReps.push({
            type: "fake",
            part: "fake",
            sizeEstimate: 0,
            amountDownloaded: 0,
            isDownloaded: !t,
            content: null,
            size: 0
        }), _.header.bytesToDownloadForBodyDisplay = t ? p : 0, _;
    };
    var y = t.LOGFAB = r.register(e, {
        Pop3Client: {
            type: r.CONNECTION,
            subtype: r.CLIENT,
            events: {},
            TEST_ONLY_events: {},
            errors: {
                htmlParseError: {
                    ex: r.EXCEPTION
                },
                htmlSnippetError: {
                    ex: r.EXCEPTION
                },
                textChewError: {
                    ex: r.EXCEPTION
                },
                textSnippetError: {
                    ex: r.EXCEPTION
                }
            },
            asyncJobs: {}
        }
    });
    _._LOG = y.Pop3Client();
});